/* 

 Depends on parser-check.lisp to convert to normal form.  
 See: parser-check.lisp

 */

%{

#include <stdio.h>
#include <string.h>
#include <stddef.h>
#include <stdlib.h> 
#include "scansubs.h"
#include "semsubs.h"
#include "types.h"
/* #define  YYDEBUG 1 */
/* #define YYERROR_VERBOSE 1 */
#define  YYDEBUG 1
#define YYERROR_VERBOSE 1

%}

%union{
 char  *charptr;
 CELL  *treeptr;
 SYMBOLS *symptr;
 }

%token <symptr>    TOK_IDENTIFIER TOK_KEYWORD TOK_ACL2_CONSTANT TOK_COMMA_APPEND 
%token <symptr>    TOK_BQ_COMMA 
%token <symptr>    TOK_OMIT_DEFUN TOK_PREDICATE TOK_CONC_NAME TOK_KEYWORD_CONSTRUCTOR
%token <symptr>    TOK_KEYWORD_UPDATER TOK_CAR_RULE_CLASSES 
%token <symptr>    TOK_NTH_RULE_CLASSES TOK_THEORY_NAME

%token <charptr>   TOK_CHARACTER_LITERAL TOK_STRING_LITERAL  TOK_COLON_COLON
%token <charptr>   TOK_DECIMAL_LITERAL TOK_OCTAL_LITERAL TOK_RATIONAL_LITERAL
%token <charptr>   TOK_STRING TOK_BOOLEAN TOK_BQUOTE TOK_COMPLEX_C
%token <charptr>   TOK_INTEGER TOK_ATOM TOK_BIT TOK_CHARACTER TOK_COMPLEX TOK_CONS
%token <charptr>   TOK_NIL TOK_NULL TOK_T TOK_RATIO TOK_RATIONAL TOK_SYMBOL 
%token <charptr>   TOK_SIGNED_BYTE TOK_UNSIGNED_BYTE TOK_STANDARD_CHAR 
%token <charptr>   TOK_IF TOK_IF_STAR TOK_THEN TOK_ELIF TOK_ELSE TOK_RECORD TOK_CASE 
%token <charptr>   TOK_CASE_MATCH TOK_TYPE TOK_TYPEDEF TOK_ENUM
%token <charptr>   TOK_ADD1 TOK_SUB1 TOK_SYM_ASSIGN TOK_IGNORE
%token <charptr>   TOK_TIMES TOK_PLUS TOK_DIV TOK_MINUS TOK_APPEND TOK_REM
%token <charptr>   TOK_UNION TOK_DIFFERENCE TOK_INTERSECT TOK_INCOMPATIBLE

%token <charptr>   TOK_LOCAL TOK_LAMBDA TOK_SKIP_PROOFS /* TOK_BQ_FORM */

%token <charptr>   TOK_SYM_QUOTE TOK_SYM_DOUBLE_QUOTE TOK_QLIST TOK_THM TOK_BQ_LIST
%token <charptr>   TOK_BINARY_APPEND TOK_BINARY_TIME
%token <charptr>   TOK_LT TOK_GT TOK_E0_ORD_LESS TOK_BINARY_PLUS TOK_LE 
%token <charptr>   TOK_GE TOK_SYM_NE TOK_SYM_NEQ TOK_ASSOC

%token <charptr>   TOK_THEOREM_KEY TOK_INSTANCE_KEY TOK_FUNCTIONAL_INSTANCE_KEY
%token <charptr>   TOK_SYM_CONS TOK_SYM_APPEND TOK_SYM_IFF TOK_SYM_IMPLIES 
%token <charptr>   TOK_SYM_ASSOC TOK_SYM_EQUAL_EQUAL TOK_SYM_EQUAL TOK_SYM_AND
%token <charptr>   TOK_SYM_OR TOK_SYM_NOT
%token <charptr>   TOK_BRR  TOK_CHAR_LESS TOK_CHAR_LESS_EQUAL
%token <charptr>   TOK_CHAR_GREATER TOK_CHAR_GREATER_EQUAL
%token <charptr>   TOK_STRING_LESS  TOK_STRING_LESS_EQUAL TOK_SYMBOL_LESS
%token <charptr>   TOK_STRING_GREATER TOK_STRING_GREATER_EQUAL TOK_INTEGER_EQUAL

%token <charptr>   TOK_THEORY_INVARIANT TOK_INCOMPATIBLE TOK_EVALUATOR TOK_WORLD
%token <charptr>   TOK_AXIOM TOK_CONSTANT TOK_THEOREM TOK_FUNCTION TOK_MACRO
%token <charptr>   TOK_PACKAGE TOK_CONG TOK_EQUIV
%token <charptr>   TOK_LABEL TOK_DOC TOK_MODULE TOK_SIGNATURE TOK_IN_PACKAGE 
%token <charptr>   TOK_LOAD TOK_INCLUDE TOK_CERTIFY TOK_CERTIFY_BAN TOK_THEORY 
%token <charptr>   TOK_CURRENT TOK_HINTS TOK_RULE_CLASSES TOK_MEASURE TOK_MODE
%token <charptr>   TOK_WELL_FOUNDED_RELATION
%token <charptr>   TOK_UNIVERSAL_THEORY TOK_CURRENT_THEORY TOK_FUNCTION_THEORY

%token <charptr>   TOK_AND TOK_OR TOK_IN TOK_NOT_IN TOK_IFF TOK_IMPLIES TOK_NOT
%token <charptr>   TOK_FOR TOK_ON TOK_WHEN TOK_COLLECT TOK_UNLESS TOK_NEVER 

%token <charptr>   TOK_RETURN TOK_OF TOK_TO TOK_QUOTE 
%token <charptr>   TOK_MACRO_OPTIONAL TOK_MACRO_REST TOK_MACRO_KEY 
%token <charptr>   TOK_MACRO_WHOLE  TOK_MACRO_BODY TOK_MACRO_ALLOW_OTHER_KEYS

%token <charptr>   TOK_DO_NOT_INDUCT TOK_DO_NOT TOK_IN_THEORY TOK_IN_THEORY_KEY 
%token <charptr>   TOK_EXPAND TOK_RESTRICT TOK_HANDS_OFF TOK_INDUCT TOK_USE TOK_BDD 
%token <charptr>   TOK_CASES TOK_BY TOK_SEARCH TOK_QUIT TOK_GOOD_BYE

%token <charptr>   TOK_VERIFY TOK_GUARD TOK_GUARDS TOK_VERIFY_GUARDS
%token <charptr>   TOK_TERMINATION TOK_DISABLE TOK_ENABLE TOK_GUARD_HINTS

%token <charptr>   TOK_HERE TOK_DEFINITION TOK_REWRITE TOK_ELIM TOK_EXECUTABLE
%token <charptr>   TOK_FORALL TOK_EXISTS TOK_TABLE

%token <charptr>   TOK_COROLLARY TOK_INSTRUCTIONS TOK_OTF_FLAG TOK_TRIGGER_FNS 
%token <charptr>   TOK_TRIGGER_TERMS TOK_TYPE_SET TOK_TYPED_TERM TOK_CLIQUE 
%token <charptr>   TOK_CONTROLLER_ALIST TOK_LOOP_STOPPER TOK_CONDITION TOK_PATTERN 
%token <charptr>   TOK_SCHEME TOK_PROGRAM TOK_LOGIC 
%token <charptr>   TOK_MUTUAL_RECURSION
%token <charptr>   TOK_BACK TOK_ABSOLUTE TOK_RELATIVE
%token <charptr>   TOK_PCBBANG TOK_PRBANG TOK_PEBANG TOK_MORE_BANG 
%token <charptr>   TOK_PUFF_STAR TOK_REDEF_BANG TOK_PCS
%token <charptr>   TOK_VAR  TOK_BDD_CONSTRUCTORS TOK_PROVE TOK_BDD_LITERAL
%token <charptr>   TOK_BDD_ALL  TOK_BDD_CONC 

/*  Precedence - This only applies when these literals are the first non-term 
    in a rule.  (Or if you use %prec.)  */

/* %left   TOK_IF  TOK_ELIF TOK_CASE TOK_CASE_MATCH */

%right  TOK_SYM_IMPLIES TOK_SYM_IFF  TOK_IF  TOK_ELIF TOK_CASE TOK_CASE_MATCH

%right  TOK_SYM_AND TOK_SYM_OR  /* (a & b &  c) -> (& a b c) */

%left TOK_SYM_EQUAL TOK_SYM_EQUAL_EQUAL TOK_SYM_NE TOK_SYM_NEQ

%left  TOK_IN TOK_NOT_IN /* TOK_MEMBER */

%left  TOK_LE TOK_GE TOK_GT TOK_LT TOK_E0_ORD_LESS 

%right  TOK_SYM_APPEND
%left  TOK_SYM_ASSOC  TOK_BINARY_APPEND
%right TOK_SYM_CONS '.'                

%left  TOK_DIFFERENCE TOK_INTERSECT TOK_INCOMPATIBLE TOK_UNION

%right TOK_PLUS 
%left  TOK_MINUS TOK_ADD1 TOK_SUB1 TOK_BINARY_PLUS

%right  TOK_TIMES 
%left  TOK_DIV TOK_BINARY_TIME TOK_REM

%nonassoc TOK_THEN 
%nonassoc TOK_ELSE UAPPEND

%type <charptr> in_or_on accumulate conditional termination 
%type <charptr> typename  lambda_list_keywords
%type <charptr>    patharg token_certify_group 

%type <treeptr> compilation translation_unit_list local_unit_list  
%type <treeptr> command_decl special_keyword cmd_descriptor oneform
%type <treeptr> top_level_declaration  top_level_declaration2 
%type <treeptr> encapsulate encapsulate2 mutual_recursion theory_invariant_decl

%type <treeptr> complex_number type_decl type_decl2 
%type <treeptr> field field_list arg_annotation true_nil skolembody 
%type <treeptr> function_decl function_decls function_decls2
%type <treeptr> function_defn function_defns
%type <treeptr> function_args lambda_form evaluator_decl skip_proofs_decl
%type <treeptr> lambda_args  lambda_function_call2
%type <treeptr> loopbody for_clause main_clause list_accumulation termination_clause
%type <treeptr> package_decl condition_clause value_clause defcong_decl
%type <treeptr> signature signature2 idformals function_type functiontail measuretail
%type <treeptr> theorem_decl thmdecoration thmdec thm_decl defequiv_decl
%type <treeptr> rule_classes rule_class_list rule_class rule_class_args rule_class_arg 
%type <treeptr> axiom_decl theory_decl include_decl certify_decl certify_decl2
%type <treeptr> macro_decl macro_decl2 macrotail1 macrotail2 pathargs macro_body 

%type <treeptr> hint_list hint_list2 hints hint goal_hint
%type <treeptr> constant_decl label_decl id_or_type id_or_types 
%type <treeptr> key general_keyword 
%type <treeptr> id var formal_list identifier_list tail acl2_constant
%type <treeptr> function_call function_call2 argument macro_args macro_args2 
%type <treeptr> parameter parameter2  parameter3  parameter4  
%type <treeptr> literal expression expression_list relation logical
%type <treeptr> list list2 rlist rlist2 eterm reserved_fun reserved_word
%type <treeptr> lmi lmi_list alist alist2 aterm qlist qlist2 qterm reserved_keyword
%type <treeptr> bq_list bq_list2 bq_term fn_sym_list fn_sym_list2  fn_sym
%type <treeptr> textual_sub textual_sub2  textual_assign fn_symbols fn_symbols2 fn_symbols3  
%type <treeptr> simple_expression term primary  unary_expression quote_atom quote_arg
%type <treeptr> body let_decl let_tail let_decls assignment theories_reserved_variables
%type <treeptr> if_expr else_body case_expr case_body case_alternative
%type <treeptr> case_match_expr case_match_body case_alt_body case_match_alternative
%type <treeptr> case_match_list  case_match_list2 case_match_list3 case_match_term case_match_pattern
%type <treeptr> optclose rune hands_off hands_off2 hands_off3 restrict restrict2
%type <treeptr> bdd bdd2 bdd_keyword list_function_symbols list_function_symbols2
%type <treeptr> function_symbols relation_name in_package argument_id 

%%

compilation: { reset_function_info(); } translation_unit_list
    { $$ = NULL; printf("\n");
      if (fail_flag == 1) exit(1); }
   | error { exit(3); }
;
optclose: ';' { $$ = NULL;} | { $$ = NULL;}
;

oneform: { reset_function_info(); } top_level_declaration ';'
    { topwritetree($2); 
      if (fail_flag == 1) exit(1); }
   | error { exit(3); }
;


translation_unit_list: translation_unit_list ';'  {  topwritetree($1); $$ = NULL;}
    |  translation_unit_list ';'  top_level_declaration
                               {   topwritetree($3); $$ = NULL;}
    | top_level_declaration    { topwritetree($1); reset_function_info();
                                $$ = NULL;}
    | error ';'
      { topwritetree(cons_terminal("ERROR", NULL));
        fprintf(stderr, "\n;Skipping to next form from line %d.",yylineno+1);}
       translation_unit_list 
      { $$= NULL }
;


top_level_declaration: TOK_LOCAL top_level_declaration2 
      { $$ = append(cons_terminal_package("LOCAL",NULL), 
					list1($2));
       };
      | top_level_declaration2 { $$ = $1;}
;

			
top_level_declaration2:
     function_defn    { $$ = $1; } 
     |  in_package   { $$ = $1;}
     |  macro_decl    { $$ = $1; }
     |  type_decl     { $$ = $1; }
     |  theorem_decl  { $$ = $1; } 
     |  thm_decl      { $$ = $1; }
     |  evaluator_decl { $$ = $1;}
     |  axiom_decl    { $$ = $1; }
     |  constant_decl { $$ = $1; }
     |  label_decl    { $$ = $1; }
     |  theory_decl   { $$ = $1; }
     |  include_decl  { $$ = $1; }
     |  certify_decl  { $$ = $1; }
     |  package_decl  { $$ = $1; }
     |  encapsulate   { $$ = $1; }
     |  defequiv_decl { $$ = $1; }
     |  defcong_decl  { $$ = $1; }
     |  mutual_recursion { $$ = $1; }
     |  theory_invariant_decl {$$ = $1;}
     |  skip_proofs_decl {$$ = $1;}
     |  command_decl  { $$ = $1; }
     |  assignment    {$$ = $1;}  
     |  expression    { $$ = $1; }
 
;

in_package :  TOK_IN_PACKAGE '(' TOK_STRING_LITERAL ')' {

  /* printf("\n Package was %s\n", package);
     if (!strcasecmp(package, "ACL2")) {
       printf("\n Package (%s) = ACL2\n", package); }
     else printf("\n Package (%s) ne ACL2\n", package); */

  package = substring($3,1,-1);

  /* printf("\n Just set package to %s\n", package);
     if (!strcasecmp(package, "ACL2")) {
       printf("\n Package (%s) = ACL2\n", package); }
     else printf("\n Package (%s) ne ACL2\n", package);  */
  
  $$ = cons_terminal_package("IN-PACKAGE",
			       cons(cons_terminal(remove_tag,
						  cons_terminal($3,NULL)),
				    NULL));}
;

defequiv_decl: TOK_EQUIV relation_name thmdecoration
       { $$ = cons_terminal_package("DEFEQUIV", cons($2, $3)); }
    | TOK_EQUIV relation_name 
       { $$ = cons_terminal_package("DEFEQUIV", cons($2, NULL)); }
;

defcong_decl: TOK_CONG relation_name TOK_TO relation_name 
              TOK_FOR literal TOK_OF expression 
              thmdecoration
        { $$ = cons_terminal_package("DEFCONG", cons($2,cons($4,cons($8,
							     cons($6,$9))))); }
      | TOK_CONG relation_name  TOK_TO relation_name  
        TOK_FOR literal TOK_OF expression
        { $$ = cons_terminal_package("DEFCONG", cons($2,cons($4,cons($8,
							     list1($6))))); }
;

relation_name: id { $$ = $1;}
  | reserved_word { $$ = $1;}
  | theories_reserved_variables { $$ = $1;}
  | fn_symbols    { $$ = $1;}
;

skip_proofs_decl: TOK_SKIP_PROOFS '{' top_level_declaration ';' '}'
   { $$ = cons_terminal_package ("skip-proofs", list1($3));}
| TOK_SKIP_PROOFS '{' top_level_declaration  '}'
   { $$ = cons_terminal_package ("skip-proofs", list1($3));}
;

evaluator_decl: TOK_EVALUATOR '(' id ',' id ')' list
  { $$ = cons_terminal_package ("DEFEVALUATOR", 
			list1(append(append($3,list1($5)), list1($7))));} 
;

function_decls2: tail  { $$ = NULL; }
     |  function_decls tail { $$ = $1; }
;
function_decls:
    function_decl { $$ = list1($1); }
  | function_decls ';' function_decl { $$ = append($1,list1($3)); }
;

function_decl:
    signature 
   { if (function_type)
     { $$ = append($1,list1(function_type)); }
     else $$ = append($1,cons_terminal_package("T",NULL));  /* needs to accumulate type axioms */
     if (   function_annotation
	 || (   function_type
             && !string_eq(strcar(function_type),"t") /* I don't think case matters. */
             && !string_eq(strcar(function_type),"state")
             && !string_eq(strcar(function_type),"mv")
	     && !string_eq(strcar(function_type),"acl2::t") /* I don't think case matters. */
             && !string_eq(strcar(function_type),"acl2::state")
             && !string_eq(strcar(function_type),"acl2::mv")))
       { 
         type_axioms = cons(cons_terminal_package(function_name,
					  make_function_type_lemma("DEFTHM")),
			    type_axioms); };
     reset_function_info(); }
  | TOK_TYPE id 
   { $$ = cons($2, cons(cons_terminal_package("X",NULL), cons_terminal_package("BOOLEANP",NULL)));
     type_axioms =
     cons(cons_terminal_package(name_of($2),
				make_function_type_lemma2("DEFTHM", name_of($2), 
							  cons_terminal_package("X",NULL),
							  NULL, NULL, make_name_acl2("BOOLEANP"))),
          type_axioms); }
;
function_defn: TOK_FUNCTION signature body
  
   { /* type_suffix = "-1"; */
 
    if (arg_guards) 
        $$ = cons_terminal_package("DEF", append($2, cons(arg_guards, list1($3))));
     else $$ = cons_terminal_package("DEF", append($2, list1($3)));
      
     if (function_type)
       $$ = append( $$, cons_terminal(":TYPE",list1(function_type)));
     
     if (function_annotation || function_type)

       $$ = append($$,cons_terminal(":LEMMA",cdr(cdr(make_function_type_lemma("")))));
     
     /* Disabling non-recursive functions implifies their admission
	to ACL2 in the presence of the type system scheme are using.
	Jun 17 96 MKS */
     if (!function_recursive)
        $$ = append($$,cons_terminal(":DISABLE",cons_terminal_package("T",NULL)));
   
     
     reset_function_info(); }
  |  TOK_FUNCTION signature body functiontail
   { /* type_suffix = "-1";*/
     if (arg_guards) 
        $$ = cons_terminal_package("DEF", append($2, cons(arg_guards, list1($3))));
     else $$ = cons_terminal_package("DEF", append($2, list1($3)));
      
     if (function_type)
       $$ = append( $$, cons_terminal(":TYPE",list1(function_type)));
     
     if (function_annotation || function_type)

       $$ = append($$,cons_terminal(":LEMMA",cdr(cdr(make_function_type_lemma("")))));
     
     /* Disabling non-recursive functions implifies their admission
	to ACL2 in the presence of the type system scheme are using.
	Jun 17 96 MKS */
     if (!function_recursive)
        $$ = append($$,cons_terminal(":DISABLE",cons_terminal_package("T",NULL)));
   
     reset_function_info(); }


  | TOK_FUNCTION signature skolembody
   { type_suffix = "-1";
     if (function_annotation || function_type || arg_guards)
       printf("\nTypes not permitted on skolem functions.");
     $$ = cons_terminal_package("DEFUN-SK", append($2, list1($3)));
     reset_function_info(); }
  | TOK_FUNCTION signature loopbody
   { type_suffix = "-1";
     if (arg_guards) 
        $$ = list1(cons_terminal_package("DEFLOOP", append($2, cons(arg_guards, list1($3)))));
     else $$ = list1(cons_terminal_package("DEFLOOP", append($2, list1($3))));
     if (function_annotation || function_type)
        $$ = append($$, list1(make_function_type_lemma("DEFTHM")));
     $$ = cons_terminal_package("PROGN",$$);
     
     if ( (cdr (cdr($$))) == NULL)     /*progn( x) */
       $$= lcar(cdr($$));

     reset_function_info(); }
  | TOK_SIGNATURE signature 
   { type_suffix = "-1";
     /* deleted && strcasecmp(name_of(function_type),"TRUEP")) from the following */
     /*  Sep 26 96 MKS */
     if (function_type)
     { $$ = append($2,list1(function_type)); }
     else $$ = append($2,cons_terminal_package("T",NULL)); 
     $$ = cons_terminal_package("Defstub-Signature", $$);
     if (   function_annotation 
         || ( function_type && !ignore_function_type(function_type) ))
        $$ = append($$, cons_terminal(":AXIOM",cdr (cdr (make_function_type_lemma("")))));
     
     reset_function_info(); }
;

function_defns: function_defn { $$ = $1;}
     |  function_defns ';' function_defn{ $$ = append(list1($1),list1($3));}
;


local_unit_list: top_level_declaration  { $$ = list1($1);}
     |  local_unit_list ';' top_level_declaration  { $$ = append($1,list1($3));}
     |  error ';' { $$ = cons_terminal("ERROR", NULL);
                   printf("\n;; *** In MODULE: skipping to next form from line %d.",yylineno+1);}
;


functiontail: measuretail functiontail { $$ = append($1,$2); }
   | measuretail  { $$ = append($1,NULL); }
;

macrotail1: macrotail2 macrotail1 
       { $$ = NULL;}
 | macrotail2 { $$ = NULL;}
;

macrotail2: 
     TOK_GUARD expression { $$ = add_measure(cons_terminal(":guard", list1($2)));}
;

measuretail: TOK_MEASURE expression { $$ = add_measure(cons_terminal(":measure", 
								     list1($2))); }
    | TOK_MODE  TOK_PROGRAM { $$ = add_measure(cons_terminal(":mode", 
							     cons_terminal(":program",
									   NULL))); }
    | TOK_MODE  TOK_LOGIC { $$ = add_measure(cons_terminal(":mode", 
							     cons_terminal(":logic",
									   NULL))); }
    | TOK_GUARD expression { $$ = add_measure(cons_terminal(":guard", list1($2))); }
    | TOK_GUARD_HINTS hint_list { $$ = add_measure(cons_terminal(":GUARD-HINTS", 
								 list1($2))); }
    | TOK_VERIFY_GUARDS true_nil { $$ = add_measure(cons_terminal(":verify-guards", 
								 list1($2))); }
    | TOK_VERIFY_GUARDS '[' ']' { $$ = add_measure(cons_terminal(":verify-guards", 
						   cons_terminal_package("NIL",NULL))); }
    | TOK_WELL_FOUNDED_RELATION fn_sym
           { $$ = add_measure(cons_terminal(":well-founded-relation", 
					    list1($2))); }
    | TOK_OTF_FLAG true_nil        { $$ = add_measure(cons_terminal(":OTF-FLAG",list1($2))); }
    
    | TOK_OTF_FLAG '[' ']'        { $$ = add_measure(cons_terminal(":OTF-FLAG", 
						     cons_terminal_package("NIL",NULL)));}
    | TOK_HINTS hint_list { $$ = add_measure(cons_terminal(":HINTS", list1($2))); }
    | general_keyword expression  { $$ = cons($1, list1($2)); }
;

/* The verify-guards OPTION needs to be moved into the deflist DECLARE list. */
/* !!! FIX  Mar  3 97 MKS !!! */

/* The default for types is that guards are verified.
   so the logic ends up inverted from the normal case.

optiontail: TOK_OMIT_DEFUN { $$ = cons_terminal(":omit-defun", NULL); }
   | TOK_VERIFY_GUARDS TOK_T { function_guards = NULL; $$ = NULL; }
   | TOK_VERIFY_GUARDS TOK_NIL  
                            { function_guards = cons_terminal_package("t",NULL); $$ = NULL; }
   | TOK_VERIFY_GUARDS '[' ']'  
                            { function_guards = cons_terminal_package("t",NULL); $$ = NULL; }

   | TOK_PREDICATE id { $$ = cons_terminal(":predicate", list1($2)); }
   | TOK_CONC_NAME TOK_NIL
     { $$ = cons_terminal(":conc-name", cons_terminal_package("NIL", NULL)); }
   | TOK_CONC_NAME '[' ']'
     { $$ = cons_terminal(":conc-name", cons_terminal_package("NIL", NULL)); }

   | TOK_KEYWORD_CONSTRUCTOR id { $$ = cons_terminal(":keyword-constructor", list1($2)); }
   | TOK_KEYWORD_UPDATER id { $$ = cons_terminal(":keyword-updater", list1($2)); }
   | TOK_CAR_RULE_CLASSES identifier_list { $$ = cons_terminal(":car-rule-classes",$2); }
   | TOK_NTH_RULE_CLASSES identifier_list { $$ = cons_terminal(":nth-rule-classes",$2); }
   | TOK_THEORY identifier_list { $$ = cons_terminal(":theory",$2); }
   | TOK_THEORY_NAME id { $$ = cons_terminal(":theory-name",list1($2)); }
; */

/* NEVER CALLED.  SHOULD DELETE OR FIX.
keytail: keytail ',' keypair { $$ = append($1,list1($3)); }
   | keypair  { $$ = list1($1); }
;
keypair: key expression { $$ = cons($1,list1($2)); }
;
local_declaration: 
        theorem_decl  { $$ = list1($1); }
     |  axiom_decl    { printf("\n;; No axioms permitted in an encapsulate"); $$ = NULL; }
     |  constant_decl { $$ = list1($1); }
; */
encapsulate:
        { type_axioms = NULL;} TOK_MODULE encapsulate2 { $$ = $3; }
;
encapsulate2:
        id '{' { type_suffix = "-2"; } function_decls2 '{' local_unit_list tail
      { $$ = make_encapsulate($1,$4,$6); }
     |  '{' { type_suffix = "-2"; } function_decls2 '{' local_unit_list tail
      { $$ = make_encapsulate(NULL,$3,$5); }
;
mutual_recursion:
      TOK_MUTUAL_RECURSION '{' function_defns  optclose '}'
      { $$ = cons_terminal_package("mutual-recursion",$3); }
;

arg_annotation: TOK_SYM_OR  expression               
        { guards = append
	             (guards,
		      list1(cons_terminal_package("XARGS", cons_terminal(":guard", list1($2))))); 
          $$ = $2;}
;

type_decl: type_decl2 { $$ = $1; }
;

type_decl2:
       TOK_TYPE id TOK_SYM_EQUAL id_or_type 
      { $4 = cons_type_name_x(cons_terminal_package("X",NULL),name_of($4));
        $$= cons_terminal_package("DEFUN", cons($2, cons(cons_terminal_package("X", NULL),
						 cons(make_verify_guard(),list1($4)))));}
     | TOK_TYPE id TOK_SYM_EQUAL TOK_ENUM list
      { $$=cons_terminal_package
	  ("DEFUN",
	   cons($2,
		cons(cons_terminal_package("X", NULL),cons(make_verify_guard(),
		     list1
		     (cons_terminal_package("MEMBER-EQUAL",
				    cons_terminal_package("X",
						  list1(cons_terminal("'",list1($5))))))))));}
     | TOK_TYPE id TOK_SYM_EQUAL TOK_RECORD '(' field_list ')' 
       { $$=cons_terminal_package
	   ("DEFSTRUCTURE",
	    cons_terminal_package(make_name_suffix("MAKE-", name_of($2)),
			  append($6, 
				 list1
				 (cons_terminal
				  (":options",
				  cons_terminal
				  (":guards",
				   cons(cons_terminal(":predicate", list1($2)),
					cons(cons_terminal(":conc-name",
							   cons_terminal_package("NIL", NULL)),
					    cons(cons_terminal(":keyword-constructor",
								cons_terminal_package
								(make_name_suffix("key-", name_of($2)), NULL)),
						 list1(cons_terminal(":keyword-updater",
								cons_terminal_package
								(make_name_suffix("update-", name_of($2)), NULL))))))))))));}
     | TOK_TYPE id TOK_SYM_EQUAL id_or_type TOK_TIMES 
       { $$=make_defun_listp($2, make_type_name(name_of($4))); }
     | TOK_TYPE id TOK_SYM_EQUAL '[' ']' 
       { $$=make_defun_truelistp($2); }
     | TOK_TYPE id TOK_SYM_EQUAL '[' id_or_types ']'
       { $$=make_defun_vectorp($2, $5); }
     | TOK_TYPE id TOK_SYM_EQUAL '[' id_or_type '.' id_or_type ']' TOK_TIMES
       { $$=make_defun_alistp($2, make_type_name(name_of($5)), 
			      make_type_name(name_of($7))); }
     | TOK_TYPE id TOK_SYM_EQUAL '{' id ':' id '|' expression '}'
      { $$ = make_defun_setp($2, $5, $7, $9);}
     | TOK_TYPE id TOK_SYM_EQUAL lambda_form TOK_TIMES
      { $$=make_defun_listp($2,$4); }
;

constant_decl: TOK_CONSTANT id TOK_SYM_EQUAL expression
      { $$ = cons_terminal_package("CONST", cons($2, list1($4))); }
  | TOK_CONSTANT id ':' id_or_type TOK_SYM_EQUAL expression
   { $$ = append( cons_terminal_package("CONST",cons($2, list1($6))),
		  append ( cons_terminal(":TYPE",list1($4)),
			   /* eliminated extra list1 around $2 below  Apr  4 97 MKS */
			   cons_terminal(":LEMMA",list1(cons_type_name_x($2, name_of($4))))));}
;

/*make_constant_suffix(name_of($2),""),*/

label_decl: TOK_LABEL id TOK_STRING_LITERAL
      { $$ = cons_terminal_package("DEFLABEL", cons($2, cons_terminal(":doc", cons_terminal($3, NULL))));}
  | TOK_LABEL id 
      { $$ = cons_terminal_package("DEFLABEL", cons($2, NULL));}
;
axiom_decl: TOK_AXIOM id body thmdecoration
       { $$ = cons_terminal_package("DEFAXIOM", cons($2, cons($3,$4))); }
     | TOK_AXIOM id body
       { $$ = cons_terminal_package("DEFAXIOM", cons($2, cons($3,NULL))); }
;

theory_invariant_decl: TOK_THEORY_INVARIANT '(' expression')'
                         { $$ =  cons_terminal_package("THEORY-INVARIANT", list1($3));};


thm_decl: TOK_THM body thmdecoration
       { $$ = cons_terminal_package("THM", cons($2,$3)); }
    | TOK_THM body
       { $$ = cons_terminal_package("THM", cons($2,NULL)); }
;

theorem_decl: TOK_THEOREM id body thmdecoration
       { $$ = cons(make_name_acl2("DEFTHM"), cons($2, cons($3,$4))); }
    | TOK_THEOREM id body
       { $$ = cons(make_name_acl2("DEFTHM"), cons($2, cons($3,NULL))); }
;
thmdecoration: thmdecoration thmdec { $$ = append($1,$2); }
    | thmdec { $$ = $1; }
;
thmdec: TOK_DOC TOK_STRING_LITERAL { $$ = cons_terminal(":doc", cons_terminal($2,NULL)); }
    | TOK_HINTS hint_list { $$ = cons_terminal(":HINTS", list1($2)); }
    | TOK_RULE_CLASSES rule_classes { $$ = cons_terminal(":rule-classes", $2); }
    | TOK_INSTRUCTIONS '[' expression_list ']'  { $$ = cons_terminal(":INSTRUCTIONS",list1($3)); }
    | TOK_OTF_FLAG true_nil  { $$ = cons_terminal(":OTF-FLAG", list1($2)); }
    | TOK_OTF_FLAG '[' ']'   { $$ = cons_terminal(":OTF-FLAG",
		       				 cons_terminal_package("NIL",NULL)); }
;
rule_classes:
   TOK_NIL              { $$ = list1(make_name_acl2("NIL")); }
 | '[' ']'              { $$ = list1(make_name_acl2("NIL")); }
 | key                  { $$ = list1($1); }
 | '[' rule_class_list  { $$ = list1($2); }
;
rule_class_list:
   rule_class  rule_class_list { $$ = cons($1,$2); }
 | rule_class ']' { $$ = list1($1); }
;

rule_class: key { $$ = $1; }
 | '[' key ']' { $$ = cons($2,NULL);}
 | '[' key  rule_class_args { $$ = cons($2,$3); }   
;

rule_class_args: 
    rule_class_arg ',' rule_class_args { $$ = append($1,$3); }
  | rule_class_arg ']' { $$ = $1; }
;
rule_class_arg:
   TOK_COROLLARY expression    { $$ = cons_terminal(":COROLLARY",list1($2)); }		
 | TOK_HINTS hint_list         { $$ = cons_terminal(":HINTS", list1($2)); }
 | TOK_INSTRUCTIONS '[' expression_list ']' { $$ = cons_terminal(":INSTRUCTIONS",list1($3)); }
 | TOK_OTF_FLAG true_nil       { $$ = cons_terminal(":OTF-FLAG",list1($2)); }
 | TOK_OTF_FLAG '[' ']'        { $$ = cons_terminal(":OTF-FLAG",
		       				 cons_terminal_package("NIL",NULL)); }
 | TOK_TRIGGER_FNS  fn_sym_list { $$ = cons_terminal(":TRIGGER-FNS",list1($2)); }
 | TOK_TRIGGER_TERMS list       { $$ = cons_terminal(":TRIGGER-TERMS",list1($2)); }     
 | TOK_TYPE_SET TOK_DECIMAL_LITERAL
                                { $$ = cons_terminal(":TYPE-SET",cons_terminal($2,NULL)); }
 | TOK_TYPED_TERM term          { $$ = cons_terminal(":TYPED-TERM",list1($2)); }
 | TOK_CLIQUE list              { $$ = cons_terminal(":CLIQUE",list1($2)); }
 | TOK_CONTROLLER_ALIST alist   { $$ = cons_terminal(":CONTROLLER-ALIST",list1($2)); }
 | TOK_LOOP_STOPPER alist       { $$ = cons_terminal(":LOOP-STOPPER",list1($2)); }
 | TOK_PATTERN term             { $$ = cons_terminal(":PATTERN",list1($2)); }
 | TOK_SCHEME term              { $$ = cons_terminal(":SCHEME",list1($2)); }
;
theory_decl: TOK_THEORY id TOK_SYM_ASSIGN expression 
       { $$ = cons_terminal_package("DEFTHEORY", cons($2, list1($4))); }
;
hint_list: '[' hint_list2 ']' { $$ = $2; }
;
hint_list2: goal_hint { $$ = list1($1); }
    | hint_list2 goal_hint { $$ = append($1, list1($2)); }
;
goal_hint: '[' TOK_STRING_LITERAL hints ']'{ $$ = cons_terminal($2, $3); }
;
hints: hint { $$ = $1; }
    | hints hint { $$ = append($1, $2); }
;
hint: TOK_DO_NOT_INDUCT expression { $$ = cons_terminal(":do-not-induct", list1($2)); }
    | TOK_DO_NOT id        { $$ = cons_terminal(":do-not", list1($2)); }
    | TOK_DO_NOT TOK_QLIST identifier_list ']'
         { $$ = cons_terminal(":do-not", cons_terminal("'", list1($3))); }
    | TOK_IN_THEORY_KEY expression  { $$ = cons_terminal(":in-theory", list1($2));}
    | TOK_EXPAND expression  { if ( stringp_car($2))
                                 $$ = cons_terminal(":expand", list1(cdr($2)));
			      else
                                 $$ = cons_terminal(":expand", list1($2));}  
    | TOK_CASES expression  { if ( stringp_car($2))
                                 $$ = cons_terminal(":cases", list1(cdr($2)));
			      else
				$$ = cons_terminal(":cases", list1($2));} 
    | TOK_INDUCT expression   { $$ = cons_terminal(":induct", list1($2)); }
    | TOK_USE lmi             { $$ = cons_terminal(":use", list1($2)); }
    | TOK_USE '[' lmi_list    { $$ = cons_terminal(":use", list1($3)); }
    | TOK_BY lmi              { $$ = cons_terminal(":by", list1($2)); }
    | TOK_BY TOK_NIL          { $$ = cons_terminal (":by",  
							cons_terminal_package("NIL",NULL));}
    | TOK_BY '[' ']'         { $$ = cons_terminal (":by",  
							cons_terminal_package("NIL",NULL));} 

    | TOK_HANDS_OFF hands_off { $$ = cons_terminal (":hands-off", list1($2));}
    | TOK_RESTRICT  restrict  { $$ = cons_terminal (":restrict", list1($2));}
    | TOK_BDD bdd   { $$ = cons_terminal (":bdd", list1($2));}
;

bdd: '[' bdd_keyword bdd2 {$$ = append($2,$3);}
;

bdd2: ']' { $$ = NULL;}
  |',' bdd_keyword bdd2 {$$ = append($2,$3);}
;

bdd_keyword: TOK_VAR TOK_SYM_ASSIGN TOK_T 
               {  $$ = cons_terminal(":vars",cons_terminal_package("T",NULL));}
       | TOK_VAR TOK_SYM_ASSIGN TOK_NIL
               {  $$ = cons_terminal(":vars",cons_terminal_package("NIL",NULL));}
       | TOK_VAR TOK_SYM_ASSIGN '[' ']'
               {  $$ = cons_terminal(":vars",cons_terminal_package("NIL",NULL));}
       | TOK_VAR TOK_SYM_ASSIGN '[' formal_list ']' 
               {  $$ = cons_terminal(":vars",list1($4));}
       | TOK_BDD_CONSTRUCTORS  TOK_SYM_ASSIGN list_function_symbols
               {  $$ = cons_terminal(":bdd-constructors",list1($3));}
       | TOK_PROVE  TOK_SYM_ASSIGN TOK_T 
            { $$ = cons_terminal(":prove",
			      cons_terminal_package("T",NULL));}
       | TOK_PROVE TOK_SYM_ASSIGN TOK_NIL   
         { $$ = cons_terminal(":prove", cons_terminal_package("NIL",NULL));}
       | TOK_PROVE TOK_SYM_ASSIGN '[' ']'  
         { $$ = cons_terminal(":prove", cons_terminal_package("NIL",NULL));}

       | TOK_BDD_LITERAL TOK_SYM_ASSIGN TOK_BDD_ALL
              { $$ = cons_terminal(":literal",
			       cons_terminal(":all",NULL));}
       | TOK_BDD_LITERAL TOK_SYM_ASSIGN TOK_BDD_CONC   
          { $$ = cons_terminal(":literal",
			       cons_terminal(":conc",NULL));}
       | TOK_BDD_LITERAL TOK_SYM_ASSIGN  TOK_DECIMAL_LITERAL   
             { $$ = cons_terminal(":literal",
				  cons_terminal(remove_tag, cons_terminal($3,NULL)))}
;

restrict: '[' rune textual_sub restrict2 { $$ = append(list1(cons($2,list1($3))),$4);}
;

restrict2: ',' rune textual_sub  restrict2 {$$ = append(list1(cons($2,list1($3))),$4);}
    | ']' { $$ = NULL;}
;

hands_off: hands_off2 { $$ = $1;}
    | '[' hands_off2 hands_off3 { $$ = cons($2, $3);}
;

hands_off2:  id  { $$ = $1; }
  | reserved_word { $$ = $1; }
  | special_keyword{ $$ = $1;}   /* added  Jun  6 97 MKS */
  | theories_reserved_variables { $$ = $1;}
  | fn_symbols    { $$ = $1; }
  | lambda_form   { $$ = $1;}
;

hands_off3: ']' { $$ = NULL;}
  | ',' hands_off2 hands_off3 { $$ = cons($2, $3);}
;


lmi_list:  lmi lmi_list { $$ = cons($1, $2);}
     |  ']' { $$ = NULL;}
;


lmi:  rune { $$ = $1; }
  
    | '[' TOK_THEOREM_KEY expression ']'  { $$ = cons_terminal(":theorem",list1($3)); }

    | '[' TOK_INSTANCE_KEY lmi textual_sub ']'  
	 { $$ =cons_terminal(":instance", cons($3,$4)); }
/* an LMI can be an ID
  | '[' TOK_INSTANCE_KEY id textual_sub ']'  
	{ $$ = cons_terminal(":instance",cons($3,$4)); } */
    | '[' TOK_FUNCTIONAL_INSTANCE_KEY lmi textual_sub']'
           { $$ =cons_terminal(":functional-instance", cons($3,$4)); }
/* an LMI can be an ID
    | '[' TOK_FUNCTIONAL_INSTANCE_KEY id textual_sub ']'
          { $$ =cons_terminal(":functional-instance", cons($3,$4)); } */
; 

rune: '[' key id ']' { $$ = cons($2,list1($3)); }  
    | '[' TOK_INSTANCE_KEY id ']' { $$ = cons_terminal(":instance",
				      list1($3)); }
    | '[' TOK_FUNCTIONAL_INSTANCE_KEY id ']' 
          { $$ = cons_terminal(":functional-instance",list1($3));}
    | '[' TOK_THEOREM_KEY id ']' { $$ = (":theorem",list1($3));}
    | id          { $$ = $1; }
    | '(' id ')'  { $$ = list1($2); }
;

include_decl: TOK_INCLUDE '(' TOK_STRING_LITERAL ')' 
     { $$ = cons_terminal_package("INCLUDE-BOOK", cons_terminal($3, NULL));}
    | TOK_INCLUDE '(' '('  pathargs  ')' ')' 
     { $$ = cons_terminal_package("INCLUDE-BOOK", list1($4));}
;

certify_decl: token_certify_group '(' '(' pathargs ')'  certify_decl2
    { $$ = cons_terminal_package($1, append(list1($4),$6));}
    | token_certify_group '(' TOK_STRING_LITERAL certify_decl2 
      { $$ = cons_terminal_package($1, append(cons_terminal($3,NULL),$4));}

;

certify_decl2: ')' { $$ = NULL;} 
 |',' TOK_T ')' { $$ = cons_terminal_package("T",NULL);}
 |',' TOK_NIL ')' {$$ = cons_terminal_package("NIL",NULL);}
 |',' '[' ']' ')' {$$ = cons_terminal_package("NIL",NULL);}

 | ',' TOK_DECIMAL_LITERAL ')'{ $$ = cons_terminal($2,NULL); } 
 | ',' TOK_DECIMAL_LITERAL ',' TOK_T ')' { $$ = append(cons_terminal($2,NULL),
					       cons_terminal_package("T",NULL)); }
 | ',' TOK_DECIMAL_LITERAL ',' TOK_NIL ')'  { $$ =  append(cons_terminal($2,NULL),
						       cons_terminal_package("NIL",NULL)); }
 | ',' TOK_DECIMAL_LITERAL ',' '[' ']' ')'  { $$ =  append(cons_terminal($2,NULL),
						       cons_terminal_package("NIL",NULL)); }
;

token_certify_group: TOK_CERTIFY {  $$ = "CERTIFY-BOOK"; }
    | TOK_CERTIFY_BAN { $$ = "CERTIFY-BOOK!" ;}
;

package_decl: TOK_PACKAGE TOK_STRING_LITERAL TOK_SYM_EQUAL expression 
     { $$ = cons_terminal_package("DEFPKG", cons_terminal($2, list1($4))); }
;
pathargs: patharg   { $$ = cons_terminal($1,NULL); }
 | pathargs patharg { $$ = append($1,cons_terminal($2,NULL)); }
;
patharg:  
   TOK_RELATIVE       { $$ = ":relative"; }
 | TOK_BACK           { $$ = ":back"; }
 | TOK_ABSOLUTE       { $$ = ":absolute"; }
 | TOK_STRING_LITERAL { $$ = $1; }
;
signature: 
      signature2 function_type { $$ = $1; }
    | signature2 { $$ = $1; }
;
signature2: 
      { guards = NULL;} idformals  { make_arg_guards(); $$ =  $2;}
;

function_type: ':' id_or_type TOK_SYM_OR expression 
     { function_type = $2; function_annotation = $4; $$ = NULL; }
    | ':' id_or_type { function_type = $2; $$ = NULL; }
    | ':' TOK_LT id_or_types TOK_GT TOK_SYM_OR expression 
     { function_type = cons_terminal_package("MV", $3); function_annotation = $6; $$ = NULL; }
    | ':' TOK_LT id_or_types TOK_GT
     { function_type = cons_terminal_package("MV", $3); $$ = NULL; }
;

idformals: id '(' formal_list arg_annotation ')'
     { save_function_info(cdr($1),$3,guards);
       $$ = cons($1, list1($3));}
    | id '(' formal_list ')' 
     { save_function_info(cdr($1),$3,guards);
       $$ = cons($1, list1($3));}
    | id '(' ')'             
     { save_function_info(cdr($1),NULL,NULL);
       $$ = cons($1, cons_terminal_package("NIL",NULL));}
;
formal_list:   var  { $$ = $1;}
   |  formal_list ',' var { $$ = append($1, $3);}
;


var: id ':' TOK_IGNORE
       { guards = append(guards,
	 		    list1(cons_terminal_package("IGNORE",list1($1))));
         $$ = list1($1); }
      
      | id ':' id
      { guards = append(guards,
			list1(cons_terminal_package("TYPE",
				    cons(cons_terminal_package("SATISFIES", list1($3)),
					 list1($1))))); 
        lemma_arg_type = append(lemma_arg_type, 
				list1(cons_type_name_x($1,name_of($3))));   
        $$ = list1($1); }
     | id ':' typename 
      { guards = append(guards,
			list1(cons_terminal_package("TYPE", cons_terminal_package($3, list1($1)))));
       lemma_arg_type = append(lemma_arg_type, list1(cons_type_name_x($1,$3)));  
       $$ = list1($1); }
     | id { $$ = list1($1);}
;

/* all_reserved_word: reserved_word { $$ = $1;} ;*/

argument_id: id { $$ = $1;}
;
/* (defmacro name (vars) body) */
macro_decl:macro_decl2 macrotail1
  {  
      $$ = cons_terminal_package("DEFMACRO",
		       cons(lcar(cdr($1)),
			    cons(lcar(cdr(cdr($1))),
				 cons(arg_guards,cdr(cdr(cdr($1)))))));
      reset_function_info(); }
 | macro_decl2 {   
 
                  if (arg_guards)
                   $$ = cons_terminal_package("DEFMACRO",
				      cons(lcar(cdr($1)),
					   cons(lcar(cdr(cdr($1))),
						cons(arg_guards,cdr(cdr(cdr($1)))))));
                 else $$ = $1;
                 reset_function_info();}
;


macro_decl2: TOK_MACRO id macro_args TOK_SYM_EQUAL macro_body
 { 
   make_arg_guards();
   if (string_equal(strcar($5),remove_tag))  /* when expression is `[ ...] */
     $$ = cons_terminal_package("DEFMACRO",
			cons($2,
			     cons($3,list1($5))));

   else 
     $$ = cons_terminal_package("DEFMACRO",
			cons($2,
			     cons($3,cons_terminal("`",
						   list1(replace_args(macro_argument,
								      $5)))))); 
   macro_argument = NULL; }
 | TOK_MACRO id macro_args '#' expression
    { make_arg_guards();
      $$ = cons_terminal_package("DEFMACRO",
			   cons($2,
				cons($3,list1($5)))); 
       macro_argument = NULL;
  }

;


macro_body: top_level_declaration { $$ = $1 ;}
;


field_list:  field { $$ = list1($1);}
     |  field_list ',' field { $$ = append($1, list1($3)) ;}
;
field: id ':' id_or_type TOK_SYM_ASSIGN expression 
      { $$ = cons($1, cons(cons_terminal(":assert", cons(cons_type_name_x($1,name_of($3)),
							 cons_terminal(":rewrite", NULL))),
			   list1(cons_terminal(":default", list1($5))))); }
     | id ':' id_or_type
      { $$ = cons($1, cons(cons_terminal(":assert", cons(cons($3,list1($1)),
							 cons_terminal(":rewrite", NULL))),
			   list1(cons_terminal(":default",
					       cons_terminal("NIL",NULL))))); }
     | id TOK_SYM_ASSIGN expression 
      { $$ = cons($1, list1(cons_terminal(":default", list1($3)))); }
     | id { $$ = list1($1); }
;

/* ONLY CAN BE USED IN DECLARATIONS */

typename: TOK_INTEGER  { $$ = "INTEGER"; }
     |  TOK_ATOM       { $$ = "ATOM"; }
     |  TOK_BOOLEAN    { $$ = "BOOLEAN"; }
     |  TOK_BIT        { $$ = "BIT"; }             
     |  TOK_CHARACTER  { $$ = "CHARACTER"; }
     |  TOK_COMPLEX    { $$ = "COMPLEX"; }
     |  TOK_CONS       { $$ = "CONS"; }
     |  TOK_T          { $$ = "T"; }
     |  TOK_NULL       { $$ = "NULL"; } 
     |  TOK_RATIO      { $$ = "RATIO"; }         
     |  TOK_RATIONAL   { $$ = "RATIONAL"; }
     |  TOK_STRING     { $$ = "STRING"; }
     |  TOK_SYMBOL     { $$ = "SYMBOL"; }
     |  TOK_SIGNED_BYTE   { $$ = "SIGNED-BYTE"; }
     |  TOK_UNSIGNED_BYTE { $$ = "UNSIGNED-BYTE"; }   
     |  TOK_STANDARD_CHAR { $$ = "STANDARD-CHAR"; }
;


id_or_types: id_or_type { $$ = list1($1); }
     |  id_or_types ',' id_or_type { $$ = append($1,list1($3)); }
;

id_or_type: id     { $$ = $1; }
     |  typename       { $$ = make_name_acl2($1); }
;

id: TOK_IDENTIFIER { $$ = cons_terminal(remove_tag, cons_symbol($1, NULL));}
;

acl2_constant: TOK_ACL2_CONSTANT
         { $$ = cons_terminal(remove_tag, cons_symbol($1, NULL));}
;


key: general_keyword { $$ = $1;} 
     | TOK_HERE  { $$ = make_name(":here"); } 
     | special_keyword { $$ = $1; }
;
/* keys_or_nil:  keys { $$ = list1($1);}
 | TOK_NIL { $$ = cons_terminal(remove_tag, cons_terminal_package("NIL",NULL)); }
 ; 
 keys:  key      { $$ = list1($1);}
      | keys key { $$ = append($1, list1($2));}
 ;*/

list_function_symbols: '[' function_symbols  list_function_symbols2
  {$$ = cons($2,$3);}
;

list_function_symbols2: ',' function_symbols  list_function_symbols2
        {$$ = cons($2,$3);}
  | ']' { $$ = NULL;}

function_symbols: id { $$ =$1;}
  | reserved_word { $$ = $1;}
  | special_keyword{ $$ = $1;} /* added  Jun  6 97 MKS */
  | fn_symbols   { $$ = $1;}
;

identifier_list:  id           { $$ = list1($1);}
     |  identifier_list  id { $$ = append($1, list1($2));}
;

list: '[' ']' { $$ = NULL;}
     | '[' reserved_keyword list2  { $$ = cons($2, $3); }
     | '[' expression list2 { $$ = cons($2, $3); }
;

list2:  ','  expression list2           { $$ = cons($2, $3);}
     |  ','  reserved_keyword list2     { $$ = cons($2, $3);}
     |  ']' { $$ = NULL;}
;

bq_list: TOK_BQ_LIST bq_list2  { $$ = cons_terminal(remove_tag,
						    cons_terminal("`"
								  ,list1($2)));}
;

bq_list2:  bq_term bq_list2 { $$ = cons($1,$2);}
   | ']' { $$ = NULL; }
;

bq_term:  id  { $$ = $1; }
  | key     { $$ = $1; }
  | TOK_COMMA_APPEND { $$ = make_name(",@");}
  | literal { $$ = $1; }
  | reserved_word { $$ = $1; }
  | reserved_keyword   { $$ = $1; }
  | fn_symbols  { $$ = $1; }
  | '.'     { $$ = make_name("."); }
  | ','      { $$ = make_name(","); }
  | '[' bq_list2   { $$ = $2; }
;

/* Bogus, not used.  Expression doesn't permit ,x or ,@x forms 
bq_form: TOK_BQUOTE '(' expression ')'
      { if (string_equal(strcar($3),remove_tag)) 
	$$ = cons_terminal(remove_tag,cons_terminal("`",list1(list1($3))));
      else
	$$ = cons_terminal(remove_tag,cons_terminal("`",list1($3))); 
      }
;*/

qlist:  TOK_SYM_QUOTE qlist  { $$ = cons_terminal(remove_tag,
					      cons_terminal("'", list1($2)));}
    |  TOK_QLIST qlist2 { if ($2 == NULL)
                            $$ = cons_terminal(remove_tag,
					cons_terminal_package("'NIL", NULL)); 
                           else $$ = cons_terminal(remove_tag,
						   cons_terminal("'", 
								 list1($2)));}
;

qlist2: qterm qlist2 { $$ = cons($1,$2); }   
   | qlist  qlist2{ $$ = cons($1, $2);; }
   | ']' { $$ = NULL; }
;

qterm: id  { $$ = $1; }
  | key     { $$ = $1; }
  | literal { $$ = $1; }
  | reserved_word { $$ = $1;}
  | reserved_keyword  { $$ = $1;}
  | fn_symbols2  { $$ = $1; }
  | fn_symbols3  { $$ = $1; }
  | theories_reserved_variables { $$ = $1;}
  | TOK_SYM_QUOTE { $$ = make_name("'"); } 
  | TOK_SYM_DOUBLE_QUOTE  { $$ = make_name("''"); }
  | '.'   { $$ = make_name(" .");}
  | '[' qlist2   { $$ = $2; }
;

 /*  elist: TOK_QLIST eterm elist2 { $$ = $2; } ;*/

rlist: '[' rlist2 { $$ = $2; }
;
rlist2: eterm rlist2 { $$ = cons($1,$2); }  
  | ']' { $$ = NULL; }
;

eterm: id  { $$ = $1; }
  | key     { $$ = $1; }
  | literal { $$ = $1; }
  | reserved_word { $$ = $1; }
  | reserved_keyword   { $$ = $1; }
  | theories_reserved_variables { $$ = $1;}
  | fn_symbols2  { $$ = $1; }
  | fn_symbols3   { $$ = $1; }
  | TOK_SYM_QUOTE { $$ = make_name("'"); } 
  | TOK_SYM_DOUBLE_QUOTE  { $$ = make_name("''"); }
  | '.'     { $$ = make_name("."); }
  | '[' rlist2   { $$ = $2; }
;


fn_sym_list: '[' fn_sym fn_sym_list2 { $$ = cons($2, $3); }
;

fn_sym_list2: ',' fn_sym fn_sym_list2 {  $$ = cons($2, $3);}
       |  ']' { $$ = NULL;}
;

fn_sym: id  { $$ = $1; }
   | fn_symbols { $$ = $1; }
;

alist: '[' alist2 { $$ = $2; }
;
alist2: aterm alist2 { $$ = cons($1,$2); }
  | ']' { $$ = NULL; }
;
aterm: '[' id expression ']'  { $$ = cons($2,list1($3)); }
 | '[' key expression ']'  { $$ = cons($2,list1($3)); }
 | '[' reserved_keyword expression ']'  { $$ = cons($2,list1($3)); }
 | '[' reserved_word expression ']'  { $$ = cons($2,list1($3)); }
;


reserved_word: TOK_CASE { $$ = make_name_acl2("CASE"); }
| TOK_CASE_MATCH  { $$ = make_name_acl2("CASE-MATCH"); }
| TOK_IGNORE { $$ = make_name_acl2("IGNORE"); }
| TOK_THM  { $$ = make_name_acl2("THM"); }
| TOK_ENUM { $$ = make_name_acl2("ENUM"); }
| TOK_IF { $$ = make_name_acl2("IF"); }
| TOK_THEN { $$ = make_name_acl2("THEN"); }
| TOK_ELIF { $$ = make_name_acl2("ELIF"); }
| TOK_ELSE { $$ = make_name_acl2("ELSE"); }
| TOK_RECORD { $$ = make_name_acl2("RECORD"); }
| TOK_TYPE { $$ = make_name_acl2("TYPE"); }
| TOK_TYPEDEF { $$ = make_name_acl2("TYPEDEF"); }
| TOK_LAMBDA { $$ = make_name_acl2("LAMBDA"); }
| TOK_WHEN { $$ = make_name_acl2("WHEN"); }
| TOK_UNLESS { $$ = make_name_acl2("UNLESS"); }
| TOK_COLLECT { $$ = make_name_acl2("COLLECT"); }

| TOK_APPEND { $$ = make_name_acl2("APPEND"); } 
 /* | TOK_MEMBER { $$ = make_name_acl2("MEMBER");} */
| TOK_ASSOC { $$ = make_name_acl2("ASSOC"); }
| TOK_IMPLIES { $$ = make_name_acl2("IMPLIES"); }
| TOK_IFF { $$ = make_name_acl2("IFF"); }
| TOK_AND { $$ = make_name_acl2("AND"); }
| TOK_OR { $$ = make_name_acl2("OR"); }
| TOK_NOT { $$ = make_name_acl2("NOT"); }

| TOK_QUOTE { $$ = make_name_acl2("QUOTE"); }

| TOK_RETURN { $$ = make_name_acl2("RETURN"); }


| TOK_AXIOM { $$ = make_name_acl2("AXIOM"); }
| TOK_CONSTANT { $$ = make_name_acl2("CONSTANT"); }
| TOK_THEOREM { $$ = make_name_acl2("THEOREM"); }
| TOK_MODULE { $$ = make_name_acl2("MODULE"); }
| TOK_MUTUAL_RECURSION {$$ = make_name_acl2 ("MUTUAl-RECURSION");}
| TOK_THEORY_INVARIANT {$$ = make_name_acl2 ("THEORY-INVARIANT");}
| TOK_CURRENT { $$ = make_name_acl2("CURRENT"); }
| TOK_FUNCTION { $$ = make_name_acl2("FUNCTION"); }
| TOK_SIGNATURE { $$ = make_name_acl2("SIGNATURE"); }
| TOK_LABEL { $$ = make_name_acl2("LABEL"); }
| TOK_MACRO { $$ = make_name_acl2("MACRO"); }
| TOK_PACKAGE { $$ = make_name_acl2("PACKAGE"); }
| TOK_IN_PACKAGE { $$ = make_name_acl2("IN-PACKAGE"); }
| TOK_LOCAL { $$ = make_name_acl2("LOCAL"); }
| TOK_LOAD { $$ = make_name_acl2("LOAD"); }
| TOK_INCLUDE { $$ = make_name_acl2("INCLUDE"); }
| TOK_FORALL { $$ = make_name_acl2("FORALL"); }
| TOK_EXISTS { $$ = make_name_acl2("EXISTS"); }
| TOK_NEVER { $$ = make_name_acl2("NEVER"); }
| TOK_FOR { $$ = make_name_acl2("FOR"); }
| TOK_IN { $$ = make_name_acl2("IN"); }
| TOK_ON { $$ = make_name_acl2("ON"); }
| TOK_UNION { $$ = make_name_acl2("UNION"); }
| TOK_DIFFERENCE { $$ = make_name_acl2("DIFFERENCE"); }
| TOK_INTERSECT { $$ = make_name_acl2("INTERSECT"); }
| TOK_VERIFY  { $$ = make_name_acl2("VERIFY"); }
| TOK_GUARDS { $$ = make_name_acl2("GUARDS"); }
| TOK_INCOMPATIBLE {$$ = make_name_acl2("INCOMPATIBLE");}
| TOK_GOOD_BYE    { $$ = make_name_acl2("GOOD-BYE");}
| reserved_fun    { $$ = $1; }
| TOK_INTEGER     { $$ = make_name_acl2("INTEGER"); }
|  TOK_ATOM       { $$ =  make_name_acl2("ATOM"); }
|  TOK_BOOLEAN    { $$ =  make_name_acl2("BOOLEAN"); }
|  TOK_BIT        { $$ =  make_name_acl2("BIT"); }             
|  TOK_CHARACTER  { $$ =  make_name_acl2("CHARACTER"); }
|  TOK_COMPLEX    { $$ =  make_name_acl2("COMPLEX"); }
|  TOK_CONS       { $$ =  make_name_acl2("CONS"); }
|  TOK_NULL       { $$ =  make_name_acl2("NULL"); } 
|  TOK_RATIO      { $$ =  make_name_acl2("RATIO"); }         
|  TOK_RATIONAL   { $$ =  make_name_acl2("RATIONAL"); }
|  TOK_STRING     { $$ =  make_name_acl2("STRING"); }
|  TOK_SYMBOL     { $$ =  make_name_acl2("SYMBOL"); }
|  TOK_SIGNED_BYTE   { $$ =  make_name_acl2("SIGNED-BYTE"); }
|  TOK_UNSIGNED_BYTE { $$ =  make_name_acl2("UNSIGNED-BYTE"); }   
|  TOK_STANDARD_CHAR { $$ =  make_name_acl2("STANDARD-CHAR"); }
;


fn_symbols:  TOK_SYM_CONS   { $$ = make_name_acl2("CONS"); }
| TOK_SYM_EQUAL_EQUAL   { $$ = make_name_acl2("="); }
| TOK_SYM_APPEND  { $$ = make_name_acl2("APPEND"); }
| TOK_SYM_ASSOC { $$ = make_name_acl2("ASSOC"); }
| TOK_SYM_EQUAL { $$ = make_name_acl2("EQUAL"); }
| TOK_SYM_IMPLIES { $$ = make_name_acl2("IMPLIES"); }
| TOK_SYM_IFF { $$ = make_name_acl2("IFF"); }
| TOK_SYM_AND { $$ = make_name_acl2("AND"); }
| TOK_SYM_OR { $$ = make_name_acl2("OR"); }
| TOK_SYM_NOT { $$ = make_name_acl2("NOT"); }
| fn_symbols2 { $$ = $1; }
;

fn_symbols2: TOK_ADD1 { $$ = make_name_acl2("1+"); }
| TOK_SUB1 { $$ = make_name_acl2("1-"); }
| TOK_LE { $$ = make_name_acl2("<="); }
| TOK_E0_ORD_LESS { $$ = make_name_acl2("e0-ord-<"); }
| TOK_GE { $$ = make_name_acl2(">="); }
| TOK_SYM_NE { $$ = make_name_acl2("~="); }
| TOK_SYM_NEQ { $$ = make_name("/="); }
| TOK_SYM_ASSIGN { $$ = make_name_acl2(":="); }
| TOK_LT { $$ = make_name_acl2("<"); }
| TOK_GT { $$ = make_name_acl2(">"); }
| TOK_MINUS { $$ = make_name_acl2("-"); }
| TOK_PLUS { $$ = make_name_acl2("+"); }
| TOK_TIMES { $$ = make_name_acl2("*"); }
| TOK_REM { $$ = make_name_acl2("rem"); }
| TOK_DIV { $$ = make_name_acl2("/"); }
;

fn_symbols3: TOK_SYM_CONS   { $$ = make_name(":>"); }
| TOK_SYM_APPEND  { $$ = make_name("@"); }
| TOK_SYM_ASSOC { $$ = make_name("\\"); }
| TOK_SYM_EQUAL { $$ = make_name("="); }
| TOK_SYM_EQUAL_EQUAL   { $$ = make_name("=="); }
| TOK_SYM_IMPLIES { $$ = make_name("->"); }
| TOK_SYM_IFF { $$ = make_name("<->"); }
| TOK_SYM_AND { $$ = make_name("&"); }
| TOK_SYM_OR { $$ = make_name("|"); }
| TOK_SYM_NOT { $$ = make_name("~"); }
;

/* (defun-sk ... &key doc quant-ok skolem-name thm-name) */

reserved_keyword: TOK_DOC { $$ = make_name(":DOC"); }
| TOK_INSTANCE_KEY { $$ = make_name(":INSTANCE"); }
| TOK_HINTS { $$ = make_name(":HINTS"); }
| TOK_GUARD { $$ = make_name(":GUARD"); }
| TOK_GUARD_HINTS { $$ = make_name(":GUARD-HINTS");}
| TOK_VERIFY_GUARDS { $$ = make_name(":VERIFY-GUARDS");} 
| TOK_MEASURE { $$ = make_name(":MEASURE"); }
| TOK_MODE { $$ = make_name(":MODE"); }
| TOK_LOGIC { $$ = make_name(":LOGIC"); }
| TOK_PROGRAM { $$ = make_name(":PROGRAM"); }
| TOK_RULE_CLASSES { $$ = make_name(":RULE-CLASSES"); }
| TOK_DO_NOT_INDUCT { $$ = make_name(":DO-NOT-INDUCT"); }
| TOK_DO_NOT { $$ = make_name(":DO-NOT"); }
| TOK_IN_THEORY { $$ = make_name("IN-THEORY"); }
| TOK_IN_THEORY_KEY { $$ = make_name(":IN-THEORY"); }
| TOK_EXPAND { $$ = make_name(":EXPAND"); }
| TOK_RESTRICT { $$ = make_name(":RESTRICT"); }
| TOK_HANDS_OFF { $$ = make_name(":HANDS-OFF"); }
| TOK_INDUCT { $$ = make_name(":INDUCT"); }
| TOK_USE { $$ = make_name(":USE"); }
| TOK_BDD { $$ = make_name(":BDD"); }
| TOK_CASES { $$ = make_name(":CASES"); }
| TOK_BY { $$ = make_name(":BY"); }
 /* Missing in v17 Jun  6 97 MKS  */
| TOK_SEARCH { $$ = make_name(":SEARCH"); }
| TOK_FUNCTIONAL_INSTANCE_KEY { $$ = make_name(":FUNCTIONAL-INSTANCE"); }
| TOK_COROLLARY { $$ = make_name(":COROLLARY"); }
| TOK_WELL_FOUNDED_RELATION { $$ = make_name(":WELL-FOUNDED-RELATION"); }
| TOK_CAR_RULE_CLASSES { $$ = make_name(":CAR-RULE-CLASSES"); }
| TOK_THEORY_NAME { $$ = make_name(":THEORY-NAME"); }
| TOK_NTH_RULE_CLASSES  { $$ = make_name(":NTH-RULE-CLASSES"); }
| TOK_KEYWORD_CONSTRUCTOR  { $$ = make_name(":KEYWORD-CONSTRUCTOR"); }
| TOK_PREDICATE  { $$ = make_name(":PREDICATE"); }
| TOK_KEYWORD_UPDATER  { $$ = make_name(":KEYWORD-UPDATER"); }
| TOK_OMIT_DEFUN { $$ = make_name(":OMIT-DEFUN"); }
 /* Added from v17 Jun  6 97 MKS  */
| TOK_BDD_ALL  { $$ = make_name(":ALL");} 
| TOK_BDD_CONC  { $$ = make_name(":CONC");}  
| TOK_BDD_LITERAL  { $$ = make_name(":LITERAL");} 
| TOK_CONC_NAME { $$ = make_name(":CONC-NAME");} 
| TOK_THEOREM_KEY  { $$ = make_name(":THEOREM");}      
| TOK_ABSOLUTE  { $$ = make_name(":ABSOLUTE");} 
| TOK_BACK      { $$ = make_name(":BACK");} 
| TOK_BDD_CONSTRUCTORS { $$ = make_name(":BDD-CONSTRUCTORS");} 
| TOK_CLIQUE { $$ = make_name(":CLIQUE");} 
| TOK_CONDITION { $$ = make_name(":CONDITION");} 
| TOK_CONTROLLER_ALIST { $$ = make_name(":CONTROLLER-ALIST");} 
| TOK_INSTRUCTIONS { $$ = make_name(":INSTRUCTIONS");} 
| TOK_LOOP_STOPPER { $$ = make_name(":LOOP-STOPPER");} 
| TOK_MORE_BANG  { $$ = make_name(":MORE!");} 
| TOK_OTF_FLAG { $$ = make_name(":OTF-FLAG");} 
| TOK_PATTERN { $$ = make_name(":PATTERN");} 
| TOK_PCBBANG { $$ = make_name(":PCB!");} 
| TOK_PCS { $$ = make_name(":PCS") ;} 
| TOK_PEBANG  { $$ = make_name(":PE!");} 
| TOK_PRBANG  { $$ = make_name(":PR!");} 
| TOK_PROVE   { $$ = make_name(":PROVE");} 
| TOK_PUFF_STAR   { $$ = make_name(":PUFF*");} 
| TOK_QUIT { $$ = make_name(":Q") ;} 
| TOK_REDEF_BANG   { $$ = make_name(":REDEF!");} 
| TOK_RELATIVE  { $$ = make_name(":RELATIVE");} 
| TOK_SCHEME { $$ = make_name(":SCHEME");} 
| TOK_TRIGGER_FNS { $$ = make_name(":TRIGGER-FNS");} 
| TOK_TRIGGER_TERMS { $$ = make_name(":TRIGGER-terms");} 
| TOK_TYPED_TERM { $$ = make_name(":TYPED-TERM");} 
| TOK_TYPE_SET { $$ = make_name(":TYPE-SET");} 
| TOK_VAR { $$ = make_name(":VARS");} 
;

reserved_fun:
  TOK_DISABLE { $$ = make_name_acl2("DISABLE"); }
 /* | TOK_LIST_STAR { $$ = make_name_acl2("LIST*"); } */
| TOK_ENABLE  { $$ = make_name_acl2("ENABLE"); }
| TOK_CURRENT_THEORY  { $$ =  make_name_acl2("CURRENT-THEORY"); }
| TOK_FUNCTION_THEORY  { $$ =  make_name_acl2("FUNCTION-THEORY"); }
| TOK_UNIVERSAL_THEORY { $$ =  make_name_acl2("UNIVERSAL-THEORY"); }
| TOK_TABLE  { $$ =  make_name_acl2("TABLE"); }
| TOK_BRR  { $$ =  make_name_acl2("BRR@"); }
| TOK_CHAR_LESS { $$ =  make_name_acl2("CHAR<"); }
| TOK_CHAR_LESS_EQUAL { $$ =  make_name_acl2("CHAR<="); }
| TOK_CHAR_GREATER { $$ =  make_name_acl2("CHAR>"); }
| TOK_CHAR_GREATER_EQUAL { $$ =  make_name_acl2("CHAR>="); }
| TOK_STRING_LESS  { $$ =  make_name_acl2("STRING<"); }
| TOK_STRING_LESS_EQUAL  { $$ =  make_name_acl2("STRING<="); }
| TOK_STRING_GREATER  { $$ =  make_name_acl2("STRING>"); }
| TOK_STRING_GREATER_EQUAL  { $$ =  make_name_acl2("STRING>="); }
|  TOK_SYMBOL_LESS  { $$ =  make_name_acl2("SYMBOL-<"); }
| TOK_INTEGER_EQUAL  { $$ =  make_name_acl2("INT="); }
;

expression:  logical      { $$ = $1;}
; 

assignment: 
       id TOK_SYM_ASSIGN expression
                     { $$ = cons_terminal_package ("ASSIGN", cons( $1, list1($3)));}
    |  key TOK_SYM_ASSIGN expression
                     { $$ = cons_terminal_package ("ASSIGN", cons( $1, list1($3)));}
;  


logical: 
        logical TOK_SYM_IFF logical    
                       { $$ = cons_terminal_package("iff", cons($1, list1($3)));}
      | logical TOK_SYM_IMPLIES logical { $$ = cons_terminal_package("implies", cons($1, list1($3)));}
      | logical TOK_SYM_AND logical   { $$ = cons_terminal_package("and", cons($1, list1($3)));}
      | logical TOK_SYM_OR logical     { $$ = cons_terminal_package("or", cons($1, list1($3)));}
      | relation  { $$ = $1;}
;


relation:  
        simple_expression { $$ = $1;}
      | relation TOK_SYM_EQUAL relation
         { $$ = cons_terminal_package("EQUAL", cons($1,list1($3)));}
      | relation TOK_SYM_EQUAL_EQUAL relation
         { $$ = cons_terminal_package("=", cons($1,list1($3)));}
      | relation TOK_SYM_NEQ relation
         { $$ = cons_terminal_package("/=", cons($1,list1($3)));}
      |  relation TOK_SYM_NE relation
         { $$ = cons_terminal_package("NOT", list1(cons_terminal_package("equal",cons($1,list1($3)))));}
      |  relation TOK_E0_ORD_LESS  relation
         { $$ = cons_terminal_package("e0-ord-<", cons($1,list1($3)));}
      |  relation TOK_LT relation
         { $$ = cons_terminal_package("<", cons($1,list1($3)));}
      |  relation TOK_GT relation
         { $$ = cons_terminal_package(">", cons($1,list1($3)));}   
      /* use for < a,b> := <1, 2> */ 
      | relation  TOK_GT { $$ = $1 ;}
      |  relation TOK_LE relation
         { $$ = cons_terminal_package("<=", cons($1,list1($3)));}
      |  relation TOK_GE relation
         { $$ = cons_terminal_package(">=", cons($1,list1($3)));}
      |  relation TOK_IN relation
         { $$ = cons_terminal_package("MEMBER-EQUAL", cons($1,list1($3)));}
      |  relation TOK_NOT_IN relation
         { $$ = cons_terminal_package("NOT",list1(cons_terminal_package("MEMBER-EQUAL", 
							cons($1,list1($3)))));}
 /*      | relation TOK_MEMBER relation
         { $$ = cons_terminal_package("MEMBER", cons($1,list1($3)));} */
;


simple_expression:   term { $$ = $1;}
    | simple_expression TOK_PLUS simple_expression
     { $$= cons_terminal_package("+", cons ($1, list1($3)));} 
    | simple_expression TOK_BINARY_PLUS simple_expression
     { $$= cons_terminal_package("BINARY-+", cons ($1, list1($3)));}
    |  simple_expression TOK_MINUS simple_expression
     { $$= cons_terminal_package("-", cons ($1, list1($3)));} 
    |  simple_expression TOK_SYM_CONS simple_expression
     { $$= cons_terminal_package("CONS", cons ($1, list1($3)));} 
    |  simple_expression TOK_SYM_APPEND simple_expression
     { $$= cons_terminal_package("APPEND", cons ($1, list1($3)));}
    |  simple_expression TOK_BINARY_APPEND simple_expression
     { $$= cons_terminal_package("BINARY-APPEND", cons ($1, list1($3)));}
    | simple_expression TOK_SYM_ASSOC simple_expression  
     { $$ = cons_terminal_package("ASSOC", cons($3,list1($1)));}
;

term:  primary    { $$ = $1;}
     | unary_expression     { $$ = $1;}
     | TOK_DIV primary      { $$ = cons_terminal_package("/", list1($2));} 
     | term TOK_TIMES term  { $$ = cons_terminal_package("*", (cons ($1, list1($3))));}
     | term TOK_REM term    { $$ = cons_terminal_package("rem", (cons ($1, list1($3))));}
     | term TOK_BINARY_TIME term  
           { $$ = cons_terminal_package("BINARY-*", (cons ($1, list1($3))));}
     | term TOK_DIV term    { $$ = cons_terminal_package("/", (cons ($1, list1($3))));}
     | term TOK_UNION term  {$$ = cons_terminal_package("union-theories",(cons ($1, list1($3))));}
     | term TOK_DIFFERENCE term { $$ = cons_terminal_package("set-difference-theories", 
						    (cons ($1, list1($3))));}
     |  term TOK_INTERSECT term { $$ = cons_terminal_package("intersection-theories", 
       						     (cons ($1, list1($3))));}
     | term  TOK_INCOMPATIBLE term
              { $$ = cons_terminal_package("incompatible",(cons ($1, list1($3))));}
 
;

unary_expression: 
      TOK_SYM_NOT primary { $$ = cons_terminal_package("NOT", list1($2));}
   |  TOK_MINUS primary { $$ = cons_terminal_package("-", list1($2));}
   |  TOK_SYM_NOT unary_expression   { $$ = cons_terminal_package("NOT", list1($2));}
   |  TOK_MINUS unary_expression { $$ = cons_terminal_package("-", list1($2));}
;


primary:   '(' expression ')'  { $$ = $2;} 

     |   primary '.' id   { $$ = cons($3,list1($1));}
     |   primary '[' expression ']' 
                        { $$ = cons_terminal_package("NTH",cons($3,list1($1))) ;}
     | TOK_LT expression_list
                            {$$ = cons_terminal_package("MV",$2);} 
     |  '[' key id ']'      { $$ = cons($2,list1($3)); }  /* rune*/
     |  body                { $$ = $1; }     /* let mv-let let* */
     |  TOK_SYM_DOUBLE_QUOTE  quote_arg
         {$$ = cons_terminal_package("quote",list1(cons_terminal_package("quote",$2)));}
     |  TOK_SYM_QUOTE quote_arg {$$ = cons_terminal_package("quote",$2);}
     |  qlist               { $$ = $1;}
/* |  bq_list             { $$ = $1;} */
     |  TOK_ADD1 expression { $$ = cons_terminal_package("1+", list1($2));}
     |  TOK_SUB1 expression { $$ = cons_terminal_package("1-", list1($2));}
     |  case_match_expr           { $$ = $1;}
     |  case_expr           { $$ = $1;}
     |  if_expr             { $$ = $1;}
     |  list                { if ($1 == NULL)
                                $$ = cons_terminal(remove_tag, 
					      cons_terminal("()", NULL));
                              else
				$$ = cons_terminal_package("LIST",$1);}
     |  lambda_form         { $$ = $1;} 
     |  function_call       { $$ = $1;} 
     |  TOK_SYM_APPEND id %prec UAPPEND { $$ = cons_terminal_package("@",list1($2));} 
     |  TOK_SYM_APPEND key %prec UAPPEND { $$ = cons_terminal_package("@",list1($2));} 
     |  id                  { $$ = $1;}    
     |  key                 { $$ = $1;}	
     |  theories_reserved_variables  { $$ = $1;}    
     |  acl2_constant       { $$ = $1;}
     |  literal             { $$ = $1;}    
     |  complex_number      { $$ = $1;}   
;

complex_number: TOK_COMPLEX_C '(' literal ',' literal ')'
     { $$ = $3;}

theories_reserved_variables: TOK_THEORY          
                           { $$ = cons_terminal(remove_tag, cons_terminal_package
     					            ("theory", NULL));}
      |  TOK_WORLD           { $$ = cons_terminal(remove_tag, cons_terminal_package
     		                    ("word", NULL));}
;

/* quote_quote_atom: TOK_SYM_QUOTE quote_atom
 {$$ = cons_terminal(remove_tag,cons_terminal ("'", list1($2)));}; */
/* This double quote stuff looks pretty fishy.  Save old version 16 in quoter.syntax */
/* This double quote stuff looks pretty fishy.  Save old version 17 in quoter.syntax */

quote_atom: TOK_SYM_QUOTE TOK_SYM_QUOTE quote_arg 
      {$$ = cons_terminal_package("quote",list1(cons_terminal_package("quote",$3)));}
     | TOK_SYM_QUOTE quote_arg {$$ = cons_terminal_package("quote",$2);}
;
quote_arg: id        {$$ = list1($1);}
     | literal       {$$ = list1($1);}
     | theories_reserved_variables
                            {$$ = list1($1);}
     | reserved_word {$$ = list1($1);}
     | key           {$$ = list1($1);}
     | reserved_keyword {$$ = list1($1);}
     | fn_symbols2   {$$ = list1($1);}
     | fn_symbols3   {$$ = list1($1);}
;
expression_list: expression  { $$ = list1($1);}
    |  TOK_SYM_EQUAL_EQUAL  { $$ = cons_terminal_package("=",NULL); }
    | expression_list ',' expression 
                              { $$ = append($1, list1($3));}
    | expression_list ','  TOK_SYM_EQUAL_EQUAL    /* for the symbol in :instruction*/
                      { $$ = append($1, cons_terminal_package("=",NULL));}
;

/* added _package to cons_terminal's below.  Apr 22 97 MKS  */
true_nil: TOK_T { $$ = cons_terminal(remove_tag, cons_terminal_package("T",NULL));}
    | TOK_NIL { $$ = cons_terminal(remove_tag, cons_terminal_package("NIL",NULL));}
;

literal:
        TOK_DECIMAL_LITERAL   { $$ = cons_terminal(remove_tag, cons_terminal($1,NULL)); }
     |  TOK_RATIONAL_LITERAL  { $$ = cons_terminal(remove_tag, cons_terminal($1,NULL)); }
     |  TOK_OCTAL_LITERAL     { $$ = cons_terminal(remove_tag, cons_terminal($1,NULL)); }
     |  TOK_CHARACTER_LITERAL { $$ = cons_terminal(remove_tag, cons_terminal($1,NULL)); }
     |  TOK_STRING_LITERAL    { $$ = cons_terminal(remove_tag, cons_terminal($1,NULL)); }
     |  true_nil { $$ = $1;}
;

function_call: id_or_type function_args
                     { if (recursivep($1)) function_recursive = 1; 
		       $$ = cons($1, $2); }
     |  reserved_fun function_args
                     { $$ = cons($1, $2); }
     |  TOK_THEORY   function_args { $$ = cons_terminal_package("Theory",$2); }
     |  lambda_form function_args { $$ = cons($1,$2);}
;




lambda_form: TOK_LAMBDA lambda_args body
  { if (lambda_value)
      $$ = append(list1(cons_terminal("LAMBDA",cons($2,list1($3)))),lambda_value);
    else
      $$ = append(cons_terminal_package("LAMBDA",cons($2,list1($3))),lambda_value); 
    lambda_value = NULL}
;

function_args: '(' argument function_call2  { $$ = append($2, $3); }
  | '(' ')'  { $$ = NULL;}
;

function_call2: ',' argument function_call2 { $$ = append($2, $3 );}
     |  ')'                                 { $$ = NULL;}
;

macro_args: '(' parameter macro_args2  { $$ = append($2, $3); }
    | '(' argument_id macro_args2  {  macro_argument = cons($2, macro_argument);
                             $$ = append(list1($2), $3); }
    | '(' ')'  { $$ = NULL;}
;

macro_args2: ',' parameter macro_args2 { $$ = append($2, $3); }
    | ',' argument_id  macro_args2 {  macro_argument = cons($2, macro_argument);
                             $$ = append(list1($2), $3); }
    | ')'    { $$ = NULL;}

parameter:
     argument_id ':' TOK_IGNORE
      { guards = append(guards,
			    list1(cons_terminal_package("IGNORE",list1($1))));
       
        macro_argument = cons($1, macro_argument);
	$$ = list1($1); }
     | parameter2 { $$ = $1;}
   
     | parameter2 TOK_SYM_ASSIGN expression {  $$ = list1(cons(lcar($1),list1($3)));}
     | argument_id TOK_SYM_ASSIGN expression   { 
                                      macro_argument = cons($1, macro_argument);
                                    $$ = list1(cons($1, list1($3))); } 
     | parameter4 { $$ = $1;} 
     | parameter4 TOK_SYM_ASSIGN expression  { $$ = cons(lcar($1),
							      list1(cons(lcar(cdr($1)),
									 list1($3))));}
     | parameter3  {$$ = $1;}
     | parameter3 TOK_SYM_ASSIGN expression {$$ = cons(lcar($1),
							     list1(cons(lcar(cdr($1)),
									list1($3))));}
;

parameter2: argument_id ':' id
      { guards = append(guards,
			    list1(cons_terminal_package("TYPE",
					cons(cons_terminal_package("SATISFIES", list1($3)),
					     list1($1)))));
	
	macro_argument = cons($1, macro_argument);
	$$ = list1($1); }
     | argument_id ':' typename
      { guards = append(guards,
			list1(cons_terminal_package("TYPE", cons_terminal_package($3, list1($1)))));
        macro_argument = cons($1, macro_argument);
        $$ = list1($1); }
;

parameter3:  parameter4 ':' argument_id { guards = append(guards,
				       list1(cons_terminal_package("TYPE",
			      		       cons(cons_terminal_package("SATISFIES", list1($3)),
					     cdr($1)))));

                           $$ = $1;}
       | parameter4 ':' typename { guards = append(guards,
      					 list1(cons_terminal_package("TYPE", 
			       			     cons_terminal_package($3, cdr($1)))));
    
                                   $$ = $1;}
      | parameter4 ':' TOK_IGNORE  { guards = append(guards,
			    list1(cons_terminal_package("IGNORE",cdr($1))));
       
	$$ = $1; } 

parameter4: lambda_list_keywords argument_id  {  macro_argument = cons($2, macro_argument);
                                   $$ = cons_terminal_package($1,list1($2));}
          
/* | other_package_lambda_list_keywords argument_id { 
                  macro_argument = cons($2, macro_argument);
                  $$ = append ($1,list1($2));} */
;

argument: 
      expression  { $$ = list1($1); } 
    | reserved_word    { $$ = list1($1); } 
    | reserved_keyword  { $$ = list1($1); } 
    | fn_symbols  { $$ = list1($1); } 
;



lambda_list_keywords:  TOK_MACRO_OPTIONAL { $$ = "&OPTIONAL" ;}
     | TOK_MACRO_REST { $$ = "&REST" ;}
     | TOK_MACRO_KEY  { $$ =  "&KEY";}
     | TOK_MACRO_WHOLE  { $$ = "&WHOLE" ;}
     | TOK_MACRO_BODY   { $$ = "&BODY" ;}
     | TOK_MACRO_ALLOW_OTHER_KEYS  { $$ = "&ALLOW-OTHER-KEYS"  ;}
;


lambda_args: '(' id lambda_function_call2  { $$ = cons($2, $3); }
  | '(' ')'  { $$ = NULL;}
;

lambda_function_call2: ',' id lambda_function_call2 { $$ = cons($2, $3 );}
     |  ')'                                  { $$ = NULL;}
;
/* 
lambda_argument: id  {$$ = list1($1); }
 | key  {$$ = list1($1); }
      | id TOK_SYM_ASSIGN expression  { lambda_value = append(lambda_value,list1($3));
                                    $$ = list1($1) }
;
*/

tail: ';' '}' { $$ = NULL }
     |'}'     { $$ = NULL }
;

/* includes mv-let */
body:
      '{' expression tail { $$ = $2; }
    | '{' TOK_LT expression_list TOK_SYM_ASSIGN 
       expression ';'
       expression tail                
     {  guards =  make_guard();
         if (guards) 
         $$ = cons_terminal_package("MV-LET",
			    cons($3, cons($5, cons(guards, list1($7)))));
       else 
         $$ = cons_terminal_package("MV-LET",
			    cons($3, cons($5, list1($7)))); } 
    | '{' let_tail
     { if (!cdr($2)) { $$ = $2; }
       else $$ = cons_terminal_package("LET*", $2); }
;
/* let_tail: let_decl ';' let_tail
  { $$ = cons( cons($1,lcar($3)), cdr($3)); }
 | let_decl ';' expression *//* { $<treeptr>$ = make_guard(); } *//* tail
  { *//* if ($<treeptr>4)
    $$ = cons(list1($1), cons($<treeptr>4, list1($3))); 
    else *//* $$ = cons(list1($1), list1($3)); } 
;*/

let_tail: let_decls ';' expression tail {
  if (let_declare) {
    $$ = cons($1, append(let_declare,list1($3)));
    let_declare = NULL; }
  else $$ = cons($1, list1($3)); }
;
let_decls: let_decls ';' let_decl { $$ = append($1, $3); }
 | let_decl { $$ = $1; }
;
let_decl: id TOK_SYM_ASSIGN expression
      { $$ = list1(cons($1, list1($3)));}
     | id ':'  TOK_IGNORE
      { let_declare = cons(cons_terminal_package("DECLARE",
				    list1(cons_terminal_package("IGNORE",
								list1($1)))),let_declare);
        $$ = NULL; }
;
skolembody:
    '{' TOK_FORALL formal_list TOK_SYM_OR expression tail 
  { $$ = cons_terminal_package("FORALL", cons($3, list1($5))); }
 |  '{' TOK_EXISTS formal_list TOK_SYM_OR expression tail 
  { $$ = cons_terminal_package("EXISTS", cons($3, list1($5))); }
;
loopbody: '{' TOK_FOR for_clause  ',' main_clause tail
  { $$ = cons_terminal_package("FOR", cons(list1($3), list1($5))); }
;
for_clause:
   id in_or_on expression TOK_BY id
  { $$ = cons($1, cons_terminal($2, cons($3, cons_terminal_package("BY", list1($5))))); }
 | id in_or_on expression { $$ = cons($1, cons_terminal($2, list1($3))); }
;
in_or_on: TOK_IN { $$ = "IN"; }
 | TOK_ON { $$ = "ON"; }
;
main_clause: list_accumulation { $$ = $1 ; }
 | condition_clause   { $$ = $1 ; }
 | termination_clause { $$ = $1 ; }
;
list_accumulation: accumulate expression { $$ = cons_terminal($1, list1($2)); }
;
accumulate: TOK_COLLECT { $$ = "COLLECT"; }
 | TOK_APPEND { $$ = "APPEND"; }
;
condition_clause: conditional expression ',' value_clause
 { $$ = cons_terminal_package($1,cons($2,list1($4))); }
;
value_clause: list_accumulation { $$ = $1 ; }
 | TOK_RETURN expression { $$ = cons_terminal_package("RETURN", list1($2)); }
;
conditional: TOK_IF { $$ = "IF"; }
 | TOK_WHEN   { $$ = "WHEN"; }
 | TOK_UNLESS { $$ = "UNLESS"; }
;
termination_clause: termination expression { $$ = cons_terminal_package($1,list1($2)); }
;
termination: TOK_FORALL { $$ = "ALWAYS"; }
 | TOK_EXISTS { $$ = "THEREIS"; }
 | TOK_NEVER  { $$ = "NEVER"; }
;

if_expr: TOK_IF expression TOK_THEN expression else_body
       { $$ = cons_terminal_package ("IF", cons($2, cons($4, list1($5))));}
  |  TOK_IF_STAR expression TOK_THEN expression else_body
       { $$ = cons_terminal_package ("IF*", cons($2, cons($4, list1($5))));}
;
else_body: TOK_ELSE expression { $$ = $2;}
     | TOK_ELIF expression TOK_THEN expression else_body
          { $$ = cons_terminal_package ("IF", cons($2, cons($4, list1($5))));}

     /*  { $$ = cons_terminal_package ("cond", append(list1(append(list1($2),list1($4))), 
                list1(cons_terminal_package("t",list1($5)))));} */
;
case_match_expr: TOK_CASE_MATCH id '{' case_match_body tail
        { $$ = cons_terminal_package("CASE-MATCH", cons($2, $4));}
;

case_match_body:  case_match_alternative       { $$ = list1($1);}
     |  case_match_body ';' case_match_alternative 
                        { $$ = append ($1, cons($3,NULL));}
;
/* We tried letting the case_body be a let (of the form { ... }).
   But it didn't work.
   If its first arg is NIL, then we need to pull it out
   so that any declare will get handled by the case-match arm syntax. */

case_match_alternative: case_match_pattern ':' case_alt_body
   { $$ = cons($1, $3); }
  | TOK_SYM_AND ':' expression
   { $$ = cons_terminal_package("&", list1($3));}
;
case_alt_body: id ':' TOK_IGNORE ';' case_alt_body
   { $$ = cons(cons_terminal_package("DECLARE",
				    list1(cons_terminal_package("IGNORE",
								list1($1)))),
	       $5); }
  | expression { $$ = list1($1); }
;

case_match_pattern: case_match_list { $$ = $1 ;}
;

/*
case_match_list:  '[' case_match_list2 {$$ = $2;}
;

case_match_list2: case_match_term case_match_list2 { $$ = cons($1,$2); }   
   | '!' id case_match_list2
    { $$ = cons_terminal(our_strcat("!",strcar(cdr($2))), $3);}
   | ']' { $$ = NULL; }
;
*/

case_match_list:  '[' case_match_list2 ']' {$$ = $2;}
;

case_match_list2: case_match_list2 case_match_list3{ $$ = append($1,list1($2)); }   
    | case_match_list3 { $$ = list1($1); }
;

case_match_list3:  case_match_term { $$ = $1;}
   | '!' id  { $$ = cons_terminal(our_strcat("!",strcar(cdr($2))), NULL);}
;

case_match_term: id  { $$ = $1; }
  | key     { $$ = $1; }
  | literal { $$ = $1; }
  | '[' ']' { $$ = cons_terminal_package("NIL",NULL);}

  | reserved_word { $$ = $1;}
  | reserved_keyword  { $$ = $1;}
  | fn_symbols2  { $$ = $1; }
  | fn_symbols3  { $$ = $1; }
  | TOK_SYM_QUOTE { $$ = make_name("'"); } 
  | TOK_SYM_DOUBLE_QUOTE  { $$ = make_name("''"); }
  | theories_reserved_variables { $$ = $1;}
  | '.'   { $$ = make_name(" .");}
  | '[' case_match_list2 ']'  { $$ = $2; }
;


case_expr: TOK_CASE expression '{' case_body tail
      { $$ = cons_terminal_package("CASE", cons($2, $4));}
;
case_body:  case_alternative       { $$ = list1($1);}
     |  case_body ';' case_alternative { $$ = append ($1, cons($3,NULL));}
;
case_alternative:  expression ':' expression
      { $$ = cons ($1, list1($3));}
     | reserved_word ':' expression
          { $$ = cons ($1, list1($3));}
     | fn_symbols2 ':'  expression
            { $$ = cons ($1, list1($3));}
     | fn_symbols3 ':'  expression
           { $$ = cons ($1, list1($3));}
     | TOK_ELSE ':' expression 
      { $$ = cons_terminal_package ("OTHERWISE", list1($3));}
;

command_decl: 
   TOK_LOAD '(' expression functiontail ')'
  { topwritetree( cons_terminal_package("ld ", (cons($3, $4)))); $$ = NULL; }
 | TOK_LOAD '(' expression  ')'
  { topwritetree( cons_terminal_package("ld ", (cons($3, NULL)))); $$ = NULL; }
 | TOK_VERIFY id
  { $$ = cons_terminal_package("verify", list1($2)); }
 | TOK_VERIFY TOK_GUARDS id
  { $$ = cons_terminal_package("verify-guards", list1($3)); }
 | TOK_VERIFY TOK_TERMINATION id
  { $$ = cons_terminal_package("verify-termination", list1($3));  }
 | TOK_VERIFY TOK_TERMINATION id arg_annotation
  { guards = $4;
    $$ = cons_terminal_package("verify-termination", cons($3, list1(make_guard())));
    guards = NULL; }
 | TOK_IN_THEORY expression
  { $$ =  cons_terminal_package("IN-THEORY", list1($2));  }
 | TOK_ENABLE id
  { $$ = cons_terminal_package("IN-THEORY",
			       list1(cons_terminal_package("ENABLE",list1($2))));  }
 | TOK_DISABLE id
  { $$ = cons_terminal_package("IN-THEORY",
			       list1(cons_terminal_package("DISABLE",list1($2))));  }
 | TOK_QUIT { $$ = cons_terminal(remove_tag, cons_terminal(":q", NULL)); }
 | TOK_GOOD_BYE { $$ = cons_terminal_package ("good-bye",NULL);}

 | TOK_PCBBANG cmd_descriptor { $$ =  cons_terminal_package("PCB!", cons($2, NULL));  }
 | TOK_PRBANG cmd_descriptor { $$ =  cons_terminal_package("PR!", cons($2, NULL));  }
 | TOK_PEBANG cmd_descriptor { $$ =  cons_terminal_package("PE!", cons($2, NULL));  }
 | TOK_PUFF_STAR cmd_descriptor { $$ =  cons_terminal_package("PUFF*", cons($2, NULL));}  

 | TOK_PCS cmd_descriptor cmd_descriptor
  { $$ =  cons_terminal_package("PCS", cons($2, cons($3, NULL)));  }

 | key cmd_descriptor { $$ =  cons(make_id_from_key($1), cons($2, NULL));  }

/* | key { $$ = ...} is in primary */

;

general_keyword:  TOK_KEYWORD { $$ = cons_terminal(remove_tag, cons_symbol($1, NULL));}
;

special_keyword: 
   TOK_EXECUTABLE { $$ = make_name(":executable-counterpart"); }
 | TOK_DEFINITION { $$ = make_name(":definition"); }
 | TOK_REWRITE    { $$ = make_name(":rewrite"); }
 | TOK_ELIM       { $$ = make_name(":elim"); }
;

cmd_descriptor:
  '[' TOK_SEARCH rlist ']' 
  { $$ = cons_terminal_package("list",
			       cons_terminal(":search", list1(cons_terminal_package("quote", list1($3))))); }
 | '[' TOK_SEARCH rlist cmd_descriptor cmd_descriptor ']'
  { $$ = cons_terminal_package("list",
			       cons_terminal(":search",
					     cons(cons_terminal_package("quote", list1($3)),
						  cons($4, list1($5))))); }
 | '[' cmd_descriptor literal ']'
  { $$ = cons_terminal_package("list", cons($2, cons($3, NULL))); }
 | '[' cmd_descriptor ']'  { $$ = $2; }
 | general_keyword { $$ = $1; }
 | fn_symbols  { $$ = cons_terminal_package("quote", list1($1)); } 
 | reserved_word { $$ = cons_terminal_package("quote", list1($1)); } 
 | TOK_HERE        { $$ = make_name(":here"); } 
 | literal { $$ = $1; }
 | '[' ']' { $$ = make_name_acl2("NIL"); } 
 | id      { $$ = cons_terminal_package("quote", list1($1)); }
;

/* Modified cmd_descriptor is above from 6/5/97 mks/jimmy

cmd_descriptor: general_keyword TOK_MINUS literal
  { $$ = cons(make_name(name_of($1)), cons_terminal($2, list1($3))); }
 | '[' TOK_REWRITE id ']' { $$ = cons_terminal(":rewrite", cons($3, NULL)); }
 | '[' TOK_DEFINITION id ']' { $$ = cons_terminal(":definition", cons($3, NULL)); }
 | '[' TOK_SEARCH rlist ']' { $$ = cons_terminal(":search", cons($3, NULL)); }
 | '[' TOK_SEARCH rlist cmd_descriptor cmd_descriptor ']'
  { $$ = cons_terminal(":search", cons($3, cons($4, list1($5)))); }
 | '[' cmd_descriptor literal ']' { $$ = cons($2, cons($3, NULL)); }
 | general_keyword     { $$ = make_name(name_of($1)); }
 | TOK_HERE { $$ = make_name(":here"); } 
 | literal { $$ = $1; }
 | '[' ']' { $$ = make_name_acl2("NIL"); } 
 | id      { $$ = cons_terminal_package("quote", list1($1)); }
;
 */

textual_sub:  '[' textual_assign textual_sub2 { $$ =cons($2, $3);}
;
      
textual_sub2:  ','  textual_assign textual_sub2 { $$ = cons($2, $3);}
              |  ']' { $$ = NULL;}
;

textual_assign : 
         id TOK_SYM_ASSIGN reserved_word { $$ = cons( $1, list1($3));}   
       | id TOK_SYM_ASSIGN fn_symbols  { $$ = cons( $1, list1($3));}
       | id TOK_SYM_ASSIGN expression  { $$ = cons( $1, list1($3));}
       | key TOK_SYM_ASSIGN expression { $$ = cons( $1, list1($3));}
;

/* We no longer need this rule iacl2 has already loaded these books.
   Apr 24 97 MKS  
 including_header_file: { topwritenodes(initialize_libs()); 
     reset_function_info();$$ = NULL;}
; */ 

%%

extern FILE  *yyin;

main(int argc, char* argv[]) { 
  /* Remove the comments around yydebug = 1 to incorporate massive
     debugging information in your parse. */
  /* yydebug = 1; */

 if ((argc > 1) && (argv[1][0] == '-') && (argv[1][1] == 'p')) { 
    package = argv[2];
    argv++;
    argc--;
  };

 yyin = stdin ; /* fopen ("avaex1", "r"); */
 while (!feof(yyin)) { yyparse (); }
}

/* %union{
 char *charptr;
 CELL  *treeptr;
 OBJCT *symptr;
 }
*/

/* token <symptr> IDENTIFIER */




