
#include <stdio.h>
#include <string.h>
#include <stddef.h>
#include <stdlib.h> 
#include "scansubs.h"

/* 
Copyright 1991, 1996 Computational Logic Inc.

This code was originally written by Miren Carranza circa 1992.  I have
had to fix a number of bugs.  Some only showed up when there was a
clash in the smybol table.

MKSmith, Apr 15 1996 */

char *replacechar(char *s, char old, char new)
 { char *p = s; 
   for ( ; *p; p++ ) { if (*p==old) *p=new; }; 
   return s;
 };

/* return the substring of s from i to j inclusive.

   if i < 0, i = 0
   if j <= 0, j = maxindex+j
   if i > maxindex, return ""

   Thus,

   i, j substring("TESTING",i,j)
   --------------------
   0, 0 TESTING
   0,-1 TESTIN
   1,-1 ESTIN
   4, 3 
   3, 4 TI
   4, 4 I
   9, 3 
   9, 9 

   The first char of s is the 0th. 
   strlen(s) returns the number of bytes in s, not including the
             terminating null character. */

PSTRING substring(s,i,j) const PSTRING s; int i; int j; 
{ 
  PSTRING y = (PSTRING) malloc (strlen(s)+1);
  int max = strlen(s);
  // max is one greater than largest index.
  if (j <= 0) {
    j = max+j; } 
  else if (j >= max) {
    j = max; }
  else j = j+1;
  if (i < 0) i = 0;

  if (i > j-1) return "";
  // strcpy(y,s);                             
  // y = y + i;
  // CHECK that substring("abcde",1,3) = "bcd"
  y = strncpy(y, s+i, j-i+1);  //  Apr 17 97 MKS 
  *(y + j-i) = '\0';
  // *(y + strlen(s) - i -j + 1) = '\0';
  //y = strncpy(x, s + i, j-i+1); //Jimmy 12-10
  return y;}

PSTRING raise(s1) PSTRING s1; 
{ PSTRING s2;
  int len = strlen(s1);
  int i;
  s2=strdup(s1);
  for ( i = 0 ; i<len; i++ ) { if (s2[i] >= 'a' && s2[i] <= 'z') s2[i]=s2[i]-32; }; 
  return s2; };

/* not case sensitive */
int string_equal(s1,s2) PSTRING s1, s2; 
{ return string_eq(raise(s1),raise(s2)); }; 

PSYMBOLS symlook(s,ptab,tsize) char *s; int tsize; SYMBOLS ptab[tsize]; 

/* Symlook returns a pointer to the object containing s */
/* this can be a pointer to the object list where the collisions are */
/* or a pointer to the symbol table */

{PSYMBOLS p;
 int si;
 int i;
 s = replacechar(s,'%',':');  /* PACKAGE HACK: We replace all occurences of % by : . */
 i = hash(s,tsize);

 /* printf("We are in symlook storing %s (hash = %d)\n",s,i); debug */

 if (!(ptab[i].id)) /*empty?*/
   { ptab[i].id = s;
     ptab[i].next = NULL;
     return &ptab[i];
   }
 else if (string_equal(ptab[i].id, s)) /* is it there? */
   { /* printf("Ptab[i].id is there\n"); debug */
     return &ptab[i]; }
 else if (ptab[i].next == NULL)
   { /* printf(" Ptab[i].id is %s.  NEW .next.\n", ptab[i].id);  debug */
     p = (PSYMBOLS) malloc (sizeof(struct symbols)); /* malloc (sizeof (SYMBOLS)); */
     p->id = strdup(s);
     p->next = NULL;
     ptab[i].next = p;
     return p; }
 else
   { /* printf(" Ptab[i].id is %s.  Searching .next.\n", ptab[i].id); debug */
     return seqsearch(ptab[i].next, s, ptab); };
     /* there is a name already which may be my key or a collision */
     /* we need to do sequential search in object list */
     /* if not there we place it in the object list*/
};
   
PSYMBOLS seqsearch(p,s)           /* on entry p is nonNULL */
  PSYMBOLS p;
  char *s;
{ 
  PSYMBOLS q;
  while ( p != NULL)
   { if (string_equal(p->id, s))       /* strcmp returns 0 if a==b */
       { /* printf(" Found p->id = %s", p->id); debug */
         return p; }
     /* (next == NULL)... add the identifier at end of collision list*/
     else if (p->next == NULL)
       { /* printf(" p->id = %s, p->next = NULL.  NEW p->next.\n", p->id);  debug */
         q = (PSYMBOLS) malloc (sizeof(struct symbols));
	 q->id = strdup(s); 
	 q->next = NULL;
	 p->next = q;
	 return q; }
     else
       { /* printf(" p->id = %s, p->next = %d.\n", p->id, p->next); debug */
         p = p->next; }}
};      

int hash(s,tsize) char *s; int tsize;
{
 int slen = strlen(s);
 return (101 * s[0] + 103 * s[slen - 1] + 107 * slen) % tsize;
};

/* AVOID STRCPY

main()
 { char *s1 = "TESTING";
   char *s2 = "testing";

   printf("\nTEST");
   printf("\ns1 = %s", s1);
   printf("\nraise(s1) = %s", raise(s1));
   printf("\ns2 = %s", s2);
   printf("\nraise(s2) = %s", raise(s2));
   printf("\n");

 };

*/
