
/* (load "startup.lisp" ) */

in-package "ACL2";

module ieee-854 
{ 
  e-max () : integer; 
  e-min () : integer; 
  b () : integer ;
  p () : integer ;
 }
{
  local function e-max () : integer { 128 };
  local function e-min () : integer { -127 };
  local function p () : rational { 18 };
  local function b () : integer  { 2 };

  theorem b-bounds { b() > 1 };
  theorem p-bounds { p() > 1 };

  theorem base-values { b() = 2 | b() = 10 } :classes nil ;

  theorem exponent-pos-linear1
  {   (d < a*c) & rationalp(a) & rationalp(c) & rationalp(d) & c > 0 & d > 0
   -> 0 < a }
  :classes :forward-chaining ;

  theorem exponent-pos-linear2
  {   (d < a* 1/ c) & rationalp(a) & rationalp(c) & rationalp(d) & c > 0 & d > 0
   -> 0 < a }
  :classes nil ;

  theorem exponent-pos-linear3
  {   (d < (a - b)* 1/ c) & rationalp(a) & rationalp(b) & rationalp(c) & rationalp(d)
      & c > 0 & d > 0
   -> 0 < (a - b) } 
  :hints "Goal" :use [:instance [ exponent-pos-linear2, [a, a - b]]]
  :classes nil ;

  theorem exponent-range { (e-max() - e-min()) / p() > 10 }
  :hints "Goal" :use [ exponent-pos-linear3 ];

  theorem significand-size { expt(b(), p() - 1) >= expt(10,5) } ;
  theorem e-balance
  {   (b() < 4 implies e-max() + e-min() = 1)
    & (b() >= 4 implies e-max() + e-min() = 0) } :classes :linear ;

} ;


theorem e-max-gt-e-min { e-max() > e-min() }  :classes :linear ;
theorem e-min-neg { e-min() < 0 } :classes :linear ;
theorem e-max-pos { e-max() > 0 } :classes :linear ;

theorem exponent-balance 
{   expt(b(), (e-max() + e-min())) < 4
  & 4 <= expt(b(), (e-max() + e-min() + 1)) }  :classes :linear ;
