in-package ("acl2");


32 + 3;

 Theorem foo { (a | (b | c)) = (a | b | c) }
          :hints [["Goal" :do-not-induct t
                          :do-not '[generalize fertilize]
                          :expand [x \ a, y member z]
                          :restrict [ trans [x := x, y := foo(x) ] ]
                          :hands-off [length, binary-append]
                          :in-theory current-theory(:here) difference '[\]
                          :induct a[n] & b[n]
                          :use [[:instance assoc-of-append
                                           [x := a, y := b, z := c ]]
                                [:functional-instance [:instance p-f
                                                                 [x := a, y := b ]]
                                                      [p := consp, f := \ ]]
                                ]
                          :bdd [:vars := [c, a0, b0, a1, b1], 
                                :prove := nil, 
                                :bdd-constructors := [:>]
                                ]
                          :cases [true-listp(a), consp(a)]
                          :by [:instance rev-rev
                                         [x := cdr(z) ]]]];





module IEEE
{ e-max () : integer; 
  e-min () : integer; 
  b () : integer ;
  p () : integer ;
 
 }
{
  local function e-max () : integer { 128 };
  local function e-min () : integer { -127 };
  local function p () : rational { 18 };
  local function b () : integer  { 2 };

  theorem b-bounds { b() > 1 };
  theorem p-bounds { p() > 1 };

  theorem base-values { b() = 2 | b() = 10 } :rule-classes nil ;

  theorem exponent-pos-linear1
  {   (d < a*c) & rationalp(a) & rationalp(c) & rationalp(d) & c > 0 & d > 0
   -> 0 < a }
  :rule-classes :forward-chaining ;

  theorem exponent-pos-linear2
  {   (d < a* 1/ c) & rationalp(a) & rationalp(c) & rationalp(d) & c > 0 & d > 0
   -> 0 < a }
  :rule-classes nil ;

  theorem exponent-pos-linear3
  {   (d < (a - b)* 1/ c) & rationalp(a) & rationalp(b) & rationalp(c) & rationalp(d)
      & c > 0 & d > 0
   -> 0 < (a - b) } 
  :hints [["Goal" :use [:instance exponent-pos-linear2 [ a := a - b]]]]
  :rule-classes nil ;

  theorem exponent-range { (e-max() - e-min()) / p() > 10 }
  :hints [["Goal" :use [ exponent-pos-linear3 ]]];

  theorem significand-size { expt(b(), p() - 1) >= expt(10,5) } ;
  theorem e-balance
  {   (b() < 4 implies e-max() + e-min() = 1)
    & (b() >= 4 implies e-max() + e-min() = 0) } :rule-classes :linear ;

} ;







Module CKK { }
{ local Theorem hack
  { syntaxp(quotep(x)) & syntaxp(quotep(y)) -> x + (y + z) = x + y + z };
  Theorem nthcdr-add1-conditional
  { ~(zp(1 + n)) -> nthcdr(1 + n, x) = nthcdr(n, cdr(x)) }; };

function foo(x) : integer { 1 + x };



constant *days*   = '[:BINDING-RULE-CLASSES :THEORY :OMIT-DEFUN :DOMAIN-TYPE :RANGE-TYPE :THEORY-NAME];



Mutual-Recursion {

Function my-conjuncts(term)
{ if eq(term, t) then nil
      elif atom(term) then [term]
      elif eq(car(term), '&) then my-conjuncts-list(cdr(term))
      else [term] };

Function my-conjuncts-list(termlist)
{ if atom(termlist) then nil
      else my-conjuncts(car(termlist)) @ my-conjuncts-list(cdr(termlist)) };

};


Constant *minus-0* = -1/2;

enable([:definition nth],ads,[:definition booleanp]);



IN-THEORY(enable ([:definition nth],
                 [:definition booleanp]));


*t*;
't;

Mutual-Recursion {

Function nqthm-translate(term)
{ if atom(term)
      then if eq(term, 't) then *t*
               elif eq(term, 'nqthm::f) then *nil*
               elif eq(term, 'nil) then ''nil
               elif symbolp(term) then term
               else ['quote, convert-nqthm-evg(term)]
      elif eq(car(term), 'quote) then ['quote, convert-nqthm-evg(cadr(term))]
      elif car(term) in '[& | nqthm::plus nqthm::times]
      then xxxjoin(car(term), nqthm-translate-lst(cdr(term)))
      elif car-cdr-symbolp(car(term))
      then make-nqthm-car-cdr-nest(car(term), nqthm-translate(cadr(term)))
      elif eq(car(term), 'cond)
      then if eq(car(cadr(term)), 't) then nqthm-translate(cadr(cadr(term)))
               else ['if, 
                     nqthm-translate(car(cadr(term))), 
                     nqthm-translate(cadr(cadr(term))), 
                     nqthm-translate('cond :> cddr(term))
                     ]
      elif eq(car(term), 'case)
      then if eq(car(caddr(term)), 'otherwise) then nqthm-translate(cadr(caddr(term)))
               else ['if, 
                     nqthm-translate(`[= ,[cadr term] ',[car [caddr term]]]), 
                     nqthm-translate(cadr(caddr(term))), 
                     nqthm-translate(`[case ,[cadr term] ,@[cdddr term]])
                     ]
      elif eq(car(term), 'let)
      then nqthm-sublis(pairlis$(strip-cars(cadr(term)),
                                 nqthm-translate-lst(strip-cadrs(cadr(term)))),
                        nqthm-translate(caddr(term)))
      elif eq(car(term), 'list) then xxxjoin(':>, nqthm-translate-lst(cdr(term)) @ [''nil])
      elif eq(car(term), 'list*) then xxxjoin(':>, nqthm-translate-lst(cdr(term)))
      else car(term) :> nqthm-translate-lst(cdr(term)) }
 :mode :program;

Function nqthm-translate-lst(lst)
{ if atom(lst) then nil
      else nqthm-translate(car(lst)) :> nqthm-translate-lst(cdr(lst)) };

};


if* x then 3 else 4;

function foo(X)
{ x := 4;
  x + 4; };


Theorem hamming-correct
{ { input := [i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i13, i14, i15, i16, i17, i18, i19];
    bvp(input) -> hamming(input) = v-logcount(input, make-nils(5))}} 
 :hints [["Goal" :bdd [:vars := t
                 ]]];


THM { input := [i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i13, i14,               i15, i16, i17, i18, i19];
    bvp(input) -> hamming(input) = v-logcount(cddr(input), make-nils(5))}
 :hints [["Goal" :bdd [:vars := t]]];



/*
  (if (nlistp a)
      
    (cons (if (if c (car a) (car b)) t nil)
          (v-if c (cdr a) (cdr b)))))
*/ 


IF nlistp(a) then nil 
            else (IF (IF c then car(a)
                            else car(b)) then t
                       else nil) :> v-if(c, cdr(a), cdr(b));


IF nlistp(a)
            then (IF 3 > 2 then t
                       else nil) = 4
            else (IF (IF c then car(a)
                            else car(b)) then t
                       else nil) :> v-if(c, cdr(a), cdr(b));

{ p$0000 := b-and(x1, y1);
         p$0001 := b-and(x1, y2);
         3 + 3};

Theorem tv-adder-step
{   tree := left :> right;
    tv-adder(c, a, b, tree) = { lhs := tv-adder(c,
                                              tfirstn(a, tree),
                                              tfirstn(b, tree),
                                              car(tree));
                                { lhs-p := car(lhs);
                                  { lhs-g := cadr(lhs);
                                    { lhs-sum := cddr(lhs);
                                      { rhs-c := t-carry(c,
                                                       lhs-p,
                                                       lhs-g);
                                        { rhs := tv-adder(rhs-c,
                                                        trestn(a,
                                                               tree),
                                                        trestn(b,
                                                               tree),
                                                        cdr(tree));
                                          { rhs-p := car(rhs);
                                            { rhs-g := cadr(rhs);
                                              { rhs-sum := cddr(rhs);
                                                { p := lhs-p & rhs-p;
                                                  { g := t-carry(lhs-g,
                                                               rhs-p,
                                                               rhs-g);
                                                    p :> g :> 
	(lhs-sum @ rhs-sum)}
	}
	}
	}
	}
	}
	}
	}
	}
	};
	};
	};
{ a := 3;
         { b := 3;
           a + b}};



{ a := 3;
         b := 3;
         a + b};

{ a + b;};
function b(x) : integer
 { 1 + x};

constant *day* : integer  = 3;

acl2::f(3);

*a3*;

constant *a3* : integer = 3;

function foo1 (x , y | moo(x)): integer
 { if x < y then 1+ x else 1- y ;}
 :measure p(x);

function foo2 (x : integer , y | moo(x)): integer
 { if x < y then 1+ x else 1- y ;}
 :measure p(x);

function foo3 (x : atom , y : integer| moo(x))
 { if x < y then 1+ x else 1- y ;};

function foo4 (x , y ): integer
 { if x < y then 1+ x else 1- y ;};



'[[a 1] [b 2]] \ 'a;

 demo( 1,2 , :key1 := 3);

3 * 3;
3 binary-* 3;
2 binary-@ 3;

type foo1 = complex;
type foo2 = bit;
type foo3 = integer *;
type foo4 = ratio







