
IN-PACKAGE "acl2";

MODULE stacks
{ type stack;
  pushs (a, s : stack) : stack;
  pops (s : stack) : stack ;
  tops (s : stack) ;
  empty? (s : stack) : bool }

{ local type stack = [];
  local function pushs (a, s) { cons(a,s) };
  local function empty? (s) { !consp(s) };
  local function pops (s) { if empty?(s) then s else cdr(s) };
  local function tops (s) { if empty?(s) then nil else car(s) };

  theorem pushs-pops  { (pops(pushs (x, s)) = s) };
  local theorem empty-pops1 { empty?(s) -> pops(s) = s };
  theorem empty-pops  { empty?(s) -> empty?(pops(s)) };
  theorem pushs-pops2 { pops(pops(pushs(x, pushs(y,s)))) = s };

}
