
in-package("ACL2");

function bar() { 1 + x ;}
   :guard symbolpXX(x)
   :guard fooXX(x);

function cat() { 1 + x; }
  :guard integerp (i) & (0 <= i);

macro foo1 () = 1;

macro foo2 (x) = x;  /* (defmacro foo (x) x) */

macro foo3 (x) = [x];  /* (defmacro foo (x) dcl ... dcl `(list ,x)) */

macro foo5 (&optional x := 4, y := 5, z := 6) = x + y + z;

macro foo4 (x : bark, y : atom, z : ignore) = [x, y] 
 :guard symbolp(x)
 :guard foo(x);

macro foo6 (x) # { y := x + 10; ['foo, x, y] };

function foo7 (x : bark, y : ignore) { x + 1 };


 Theorem MAIN { HYPS(X,Y,Z) -> CONCL(X,Y,Z) }
  :rule-classes [[:META  
  :trigger-fns [A,B,C]]];
 

Theorem MAIN { HYPS(X,Y,Z) -> CONCL(X,Y,Z) }
  :hints [["Goal" :DO-NOT-INDUCT T
                  :do-not '[GENERALIZE FERTILIZE]
                  :expand [{ A := 4;
                             { B := 2;
                               A @ B}}, 
                           Y member Z
                           ]]];


 Theorem main8 { x + (y + z) = x + (y + z) }
  :rule-classes [:rewrite]
  :hints [["Goal" :do-not '[generalize fertilize]
                  :in-theory current-theory(:here) difference '[\]
                  :induct a[n] & b[n]
                  :expand [{ x := a;
                             { y := c;
                               x @ y}}
                           ]]];


:pe ;



Module 
{equiv(x,y) : t;
 pred(x) : t;
 op(x,y) : t;
 id() : t;
 inv(x) : t;} 
{ local 
  
  Function equiv(x,y) { x = y }
   ;
  
  local 
  
  Function pred(x) { x = t | x = nil }
   :verify-guards t;
  
  local 
  
  Function op(x,y) { x | y & ~(x & y) }
   :guard pred(x) & pred(y);
  
  local 
  
  Function id() { nil }
   ;
  
  local 
  
  Function inv(x) { x }
   :guard pred(x);
  
  Theorem equiv-is-an-equivalence
  { acl2::booleanp(equiv(x,y)) & (equiv(x,x) & ((equiv(x,y) -> equiv(y,x)) & (equiv(x,
                                                                                    y) & equiv(y,
                                                                                               z) -> equiv(x,
                                                                                                           z)))) }
   :rule-classes [:equivalence [:type-prescription  
   :corollary equiv(x,y) = t | equiv(x,y) = nil]];
  
  Theorem equiv-1-implies-equiv-op
  { equiv(x1,x2) -> equiv(op(x1,y),op(x2,y)) }
   :rule-classes :congruence;
  
  Theorem equiv-2-implies-equiv-op
  { equiv(y1,y2) -> equiv(op(x,y1),op(x,y2)) }
   :rule-classes :congruence;
  
  Theorem closure-of-op-for-pred { pred(x) & pred(y) -> pred(op(x,y)) };
  
  Theorem closure-of-id-for-pred { pred(id()) };
  
  Theorem closure-of-inv-for-pred { pred(x) -> pred(inv(x)) };
  
  Theorem commutativity-of-op
  { pred(x) & pred(y) -> equiv(op(x,y),op(y,x)) };
  
  Theorem associativity-of-op
  { pred(x) & (pred(y) & pred(z)) -> equiv(op(op(x,y),z),op(x,op(y,z))) };
  
  Theorem left-unicity-of-id-for-op { pred(x) -> equiv(op(id(),x),x) };
  
  Theorem right-inverse-of-inv-for-op
  { pred(x) -> equiv(op(x,inv(x)),id()) };
  
   };




function tex(x : integer, y : ignore ,z : p) { x + y + z;};


Theorem cancel_plus-lessp-correct
{ ev-plus-lessp(x,a) = ev-plus-lessp(cancel_plus-lessp(x),a) }
 :instructions [induct, prove, promote, dive(1), x, ==]
 :rule-classes [[:meta :trigger-fns [ + , < ]]];

'[3 4];

current-theory(:here); 

[ if , 4];