
in-package "ACL2";

constant *digits* = '[0 1 2 3 4 5 6 7 8 9];

Signature subr2(x, y) : t;      /*parse to (PROGN (DEFSTUB subr2 (x y ) TRUEP )) */

constant *open* = 'user::open;

constant *foo* = NIL;

constant *specialstring1* = "\"";

constant *specialstring2* = "\"ab";

macro mfoo(a,b) { a+b };

macro mbar(a,b) { bim(a) + (b * b) / a };

type foo = integer;

type bar = enum [a, b, c];

type bar2 = enum [1, b, "foo", [a.b]];

type xlist = [];

type ilist = foo* ;

type alist = [integer . char]* ;

type vlist = [integer, char, integer];

type struct = record (a : vlist, c, e : integer := 0, d := [a,b]);

type barlist = bar *;

Constant be-alist = '[[not . not] [and . b-and] [or . b-or] [exor . b-xor]];

function bim (x : integer): integer | boo(x) > x { 1+ x };

function bim2 (x : integer | boo(x) > x ): integer  { 1+ x };

function boo (x) : boolean { integerp(x) };

function oneb (a b : integer | a <= b) { [[a,b],[a]] };

function five (a : integer, b : foo) : cons
 { if a = b then a :> b else [b] };

function neq-bits (a, b : foo): bit { if a = b then 0 else 1 };
function neq-bits (a, b : foo): bit { 0 < -x = x < 0 };

function octal (): integer { -1 * 012 + -0234 };

function rat4 (): rational { -1/2 * mfoo(22/3, 8 / 2) };

function bam4 (a : bit, b : integer): rational { 4 * b * 1/2 - a };

function one (a, b : cons): cons { [[a,b],[b.car]] } ; 

function two () { '[[a.b] [a.car]] };

function three (a, b) {
  c := a :> b;
  d := c :> nil;
  g := c @ d;
  e := d \ a ;
  case a {
   1   : d;
   'a' : one(a,c);
   else : t  }};

/* looping is defined in /slocal/src/acl2/v1-9/books/public/utilities.lisp
   and loaded when /slocal/src/acl2/v1-9/books/public/structures is included. */

function loop1 (l : foo)
{ for x in l , collect x };

function loop2 (l : ilist) : ilist
{ for x in l , when x <= 3 , collect x };

function loop3 (l) : xlist
{ for x in l , when x.car <= 3 , append x.cdr  };

function loop4 (a , l) : xlist
{ for x in l , when x.car = a , return x.cdr  };

function loop5 (a , l) : boolean
{ for x in l , exists x.car = a  };


Function b-or(x, y)
{ if x then t
      elif y then t
      else nil }
 :mode :logic
 :verify-guards t;

theory foo = ground-zero union current-theory(lemma2) difference boo;       

Theorem expt-type-prescription-positive { 0 < r & rationalp(r) -> 0 < expt(r, i) }
 :rule-classes [:type-prescription :generalize];

/* theorem easy { bar(a) } 
   :hints [["Goal" :expand [ bar(), foo(a, b+c) ] :do-not generalize ]
           ["Goal.1.2.2" :in-theory t1 :do-not-induct t :expand [bar(), foo(a,b)]]] ; */

axiom bar { 1 = 2 };

include (:relative :back "boo" "bar");

include (:absolute "boo" "bar");

Theorem hack1
  { x < y & x * y = 1 -> y = /x };

Theorem hack1
  { acl2-numberp(x) & acl2-numberp(y) & x * y = 1 -> y = /x };

module {}
{ local Theorem hack1
  { (acl2-numberp(x) & acl2-numberp(y) & x * y = 1 -> y = /x ) }
};

Theorem foo
{   (x * y * z) = (x * y) * z
  & (x / y / z) = (x / y) / z
  & (x = y = z) = (x = y) = z
  & (x \ y \ z) = (x \ y) \ z
  & x.y.z = (x.y).z
  & (x * y + z) = (x * y) + z
};

Mutual recursion{
  function foo(X)
  { if x then 1 else bar(X) };
  function bar(X)
  {if x then foo(x) else nil}
};

Theorem div-preserves-positive { rationalp(x) -> (0 < /x <-> 0 < x) }
     :rule-classes [:rewrite [:corollary fc(rationalp(x)) -> 0 < /x = 0 < x]];

include (:absolute "boo" "bar")

