in-package("ACL2");

Theorem true-listp-append { true-listp(a @ b) = true-listp(b) }
 :rule-classes [[:rewrite  ] [:type-prescription  
 :corollary true-listp(b) -> true-listp(a @ b)]];




Theorem put-seg-fill-non-recursive-defun
{ integerp(i) & (0 <= i & (true-listp(l) & true-listp(seg))) -> put-seg-fill(i, seg, l, filler) = firstn(i, l) @ (make-list(max(i - len(l),0),
                                            :initial-element := filler) @ 
														  (seg @ nthcdr(i + len(seg),l))) }
:hints [["Goal" :induct put-seg-fill(i, seg, l, filler)]["Subgoal *1/2.2''" :use [:instance make-list-ac-rewrite
		[i := i, 
                 v := filler, 
                 ac := nil ]]
                 ]
     ["Subgoal *1/2.1''" :use [:instance make-list-ac-rewrite
                                         [i := 1, 
                                         v := filler, 
                                         ac := nil ]]
                              ]];

x/y;


Evaluator ev2, ev2-list 
 [
   binary-plus(x, y), 
   fix(x), 
   x = y, 
   acl2-numberp(x), 
   x < y, 
   if x then y
       else z
];


*zero*;
*nil*;


binary-$;

*0*;
local 

Module { }
{ 
  local Theorem times-cancel-left-better
  { left = x * y -> left = x * z = (fix(x) = 0 | fix(y) = fix(z)) };
  
  Theorem binary-op_tree-times-fringe-del
  { memb(summand, fringe) & (acl2-numberp(y) & fix(ev-times-equal(summand, a)) ~= 0) -> y = ev-times-equal(binary-op_tree('binary-mult,
                                                                                                                          1,
                                                                                                                          'fix,
                                                                                                                          del(summand,
                                                                                                                              fringe)),
                                                                                                           a) = (ev-times-equal(summand,
                                                                                                                                a) * y = ev-times-equal(binary-op_tree('binary-mult,
                                                                                                                                                                       1,
                                                                                                                                                                       'fix,
                                                                                                                                                                       fringe),
                                                                                                                                                        a)) }
   :hints [["Goal" :use binary-op_tree-times-fringe-del-lemma
                   :in-theory disable(commutativity-of-mult)]];
  
   };

foo("a");

Function ev1-list(x-lst, a)
{ if endp(x-lst) then nil
	   else ev1(car(x-lst), a) :> ev1-list(cdr(x-lst), a) }
  :measure acl2-count(x-lst);

IN-THEORY(*defevaluator-form-base-theory*);
set-inhibit-warnings("theory");

eq('a ,'b);

Mutual recursion { 

  Function ev(x,a) { x + a }
   :mode :logic;

  Function ev1-list(x-lst, a)
  { if endp(x-lst) then nil
	     else ev1(car(x-lst), a) :> ev1-list(cdr(x-lst), a) }
    :mode :logic;
};


local Mutual recursion { 
Function ev1(x, a)
  { if symbolp(x) then cdr(assoc-eq(x, a))
        elif eq(car(x), 'quote) then car(cdr(x))
        elif consp(car(x))
        then ev1(car(cdr(cdr(car(x)))), pairlis$(car(cdr(car(x))), ev1-list(cdr(x), a)))
        elif car(x) = binop-name() then binop(ev1(car(cdr(x)), a), ev1(car(cdr(cdr(x))), a))
        elif car(x) = binop-fix-name() then binop-fix(ev1(car(cdr(x)), a))
        elif car(x) = binop-rel-name()
        then binop-rel(ev1(car(cdr(x)), a), ev1(car(cdr(cdr(x))), a))
        elif car(x) = 'if
        then if ev1(car(cdr(x)), a) then ev1(car(cdr(cdr(x))), a)
                 else ev1(car(cdr(cdr(cdr(x)))), a)
		 else nil }
   :measure acl2-count(x)
   :mode :logic;
  
  Function ev1-list(x-lst, a)
  { if endp(x-lst) then nil
        else ev1(car(x-lst), a) :> ev1-list(cdr(x-lst), a) }
   :measure acl2-count(x-lst)
   :well-founded-relation e0-ord-<;
  
  };
  
Module 
{ binop(x, y) : t;
  binop-fix(x) : t;
  binop-rel(x, y) : t;
  binop-id() : t; } 
{ local 
  
  Function binop(x, y) { x + y };
  
  local 
  
  Function binop-fix(x) { fix(x) };
  
  local 
  
  Function binop-rel(x, y) { x = y };
  
  local 
  
  Function binop-id() { 0 };
  
  Theorem commutativity-of-binop { binop(x, y) = binop(y, x) };
  
  Theorem commutativity2-of-binop { binop(x, binop(y, z)) = binop(y, binop(x, z)) };
  
  Theorem associativity-of-binop { binop(binop(x, y), z) = binop(x, binop(y, z)) };
  
  Theorem binop-fix-binop { binop-fix(binop(x, y)) = binop(x, y) };
  
  Theorem binop-cancel-binop-rel
  { binop-rel(binop(x, y), binop(x, z)) = binop-rel(binop-fix(y), binop-fix(z)) };
  
  Theorem binop-binop-id { binop(binop-id(), x) = binop-fix(x) };
  
  Theorem binop-fix-binop-id { binop-fix(binop-id()) = binop-id() };
  
   };


skip-proofs { 
Theorem cancel_binop-rel-correct-lemma
{ binop-rel(ev1(binary-op_tree(binop-name(),
                               binop-id(),
                               binop-fix-name(),
                               bagdiff(binary-op_fringe(binop-name(), x1),
                                       bagint(binary-op_fringe(binop-name(), x1),
                                              binary-op_fringe(binop-name(), x2)))),
                a),
            ev1(binary-op_tree(binop-name(),
                               binop-id(),
                               binop-fix-name(),
                               bagdiff(binary-op_fringe(binop-name(), x2),
                                       bagint(binary-op_fringe(binop-name(), x1),
                                              binary-op_fringe(binop-name(), x2)))),
                a)) = binop-rel(binop-fix(ev1(x1, a)), binop-fix(ev1(x2, a))) };

 }
