
#ifndef TYPESTRUCTS
#define TYPESTRUCTS

PCELL guards;
PCELL arg_guards;
PCELL lemma_arg_type;

/* FUNCTION name (arg* [ : guard* ])[ : type [ | annotation ]] */

PSTRING function_name;
int     function_recursive;
int     macro_id_flag; 
int     set_macro_arg;
PCELL   function_args;
PCELL   function_guards;
PCELL   function_measure;
PCELL   function_type;
PCELL   function_annotation;
PCELL   lambda_value;
PCELL   macro_argument;

/*  Apr 22 97 MKS  */
PCELL   let_declare;
int     let_count;

PSTRING package;

int recursivep (PCELL p);

PCELL   type_axioms;
PSTRING type_suffix;
PSTRING our_strcat(PSTRING s1, PSTRING s2);
PSTRING make_name_suffix(PSTRING name, PSTRING suffix);
PSTRING make_constant_suffix(PSTRING name, PSTRING suffix);

int stringequal (char *x, char *y);

PCELL make_verify_guard();
PCELL make_guard();
PCELL add_measure(PCELL measure);
int ignore_function_type (PCELL x);
int ignore_function_types (PCELL x);
void  make_arg_guards(); 
PCELL function_guard (PCELL l);
PCELL guard_to_pred (PCELL l);
PCELL xarg_to_pred (PCELL l);

PCELL types_to_pred(PSTRING id, PCELL tail);
PCELL type_to_pred(PCELL l);

PSTRING name_of(PCELL l);
PSTRING strcat_package(PSTRING x);
PCELL function_name_of(PCELL l); 

PCELL make_name_acl2(PSTRING x);
PCELL make_name(PSTRING x);
PCELL make_type_name(PSTRING x);
PCELL cons_type_name_x (PCELL x, PSTRING type);
PCELL cons_terminal_package(PSTRING x, PCELL y);
PCELL make_id_from_key(PCELL key);


PCELL make_function_type_lemma(PSTRING kind);
PCELL make_function_type_lemma2(PSTRING kind, PSTRING name, PCELL args, PCELL guards, PCELL annotation, PCELL type);

PCELL make_defun_listp(PCELL name, PCELL type);
PCELL make_defun_vectorp(PCELL name, PCELL types);
PCELL make_defun_truelistp(PCELL name);
PCELL make_defun_alistp(PCELL name, PCELL type1, PCELL type2);
PCELL make_defun_setp(PCELL name, PCELL id, PCELL type, PCELL expr);

PCELL make_encapsulate(PCELL id, PCELL dcl, PCELL body);
PCELL make_function_requirement(PCELL name);
PCELL find_function_requirement(PSTRING name,PCELL axioms);

PCELL make_disable(PSTRING name);
PCELL make_theory_diff(PSTRING id, PSTRING from, PSTRING to);
PCELL make_current_theory(PSTRING th);

int forms_equal(PCELL a, PCELL b);
int cars_equal(PCELL a, PCELL b);
PCELL replace(PCELL old, PCELL new, PCELL form);
PCELL replace_args(PCELL args, PCELL form);

PCELL localize(PCELL form);

void save_function_info(PCELL name, PCELL args, PCELL annotation);

#endif TYPESTRUCTS
