

in-package("ACL2-ASG");

Include("/usr/cli/projects/cacl2/version12/infix-prelude");

Module 
{equiv(x,y) : t;
 pred(x) : t;
 op(x,y) : t;} 
{ local 
  
  Function equiv(x,y) { x = y }
   ;
  
  local 
  
  Function pred(x) { x = t | x = nil }
   :verify-guards t;
  
  local 
  
  Function op(x,y) { x | y & ~(x & y) }
   :guard pred(x) & pred(y);
  
  Theorem equiv-is-an-equivalence
  { acl2::booleanp(equiv(x,y)) & (equiv(x,x) & ((equiv(x,y) -> equiv(y,x)) & (equiv(x,
                                                                                    y) & equiv(y,
                                                                                               z) -> equiv(x,
                                                                                                           z)))) }
   :rule-classes :equivalence;
  
  Theorem equiv-2-implies-equiv-op
  { equiv(y1,y2) -> equiv(op(x,y1),op(x,y2)) }
   :rule-classes :congruence;
  
  Theorem closure-of-op-for-pred { pred(x) & pred(y) -> pred(op(x,y)) };
  
  Theorem associativity-of-op
  { pred(x) & (pred(y) & pred(z)) -> equiv(op(op(x,y),z),op(x,op(y,z))) };
  
  Theorem commutativity-of-op
  { pred(x) & pred(y) -> equiv(op(x,y),op(y,x)) };
  
   };

local 

Theorem commutativity-2-of-op-lemma
{ pred(x) & (pred(y) & pred(z)) -> equiv(op(op(x,y),z),op(op(y,x),z)) };

Theorem commutativity-2-of-op
{ pred(x) & (pred(y) & pred(z)) -> equiv(op(x,op(y,z)),op(y,op(x,z))) }
 :hints [["Goal" :in-theory acl2::disable(commutativity-of-op)
                 :use commutativity-2-of-op-lemma]];

Macro foo(x) =  x + 1;

Macro add-commutativity-2(equiv-name,
                          pred-name,
                          op-name,
                          commutativity-thm-name,
                          commutativity-2-thm-name) = 

Module { }
{ local 
  
  Theorem associativity-of-op-name
  { pred-name(x) & (pred-name(y) & pred-name(z)) -> equiv-name(op-name(op-name(x,
                                                                               y),
                                                                       z),
                                                               op-name(x,
                                                                       op-name(y,
                                                                               z))) }
   :hints [["Goal" :in-theory disable(commutativity-thm-name)]];
  
  Theorem commutativity-2-thm-name
  { pred-name(x) & (pred-name(y) & pred-name(z)) -> equiv-name(op-name(x,
                                                                       op-name(y,
                                                                               z)),
                                                               op-name(y,
                                                                       op-name(x,
                                                                               z))) }
   :hints [["Goal" :use [:functional-instance commutativity-2-of-op
                                              [equiv := lambda(x,y) { equiv-name(x,
                                                                               y) }, 
                                               pred := lambda(x) { pred-name(x) }, 
                                               op := lambda(x,y) { op-name(x,y) } ]]
                   ]];
  
   }

;


