
in-package("ACL2-CRG");

include-book("acl2-agp");

Function foo(x) { x + 1 };

encapsulate((equiv(x(y),t) pred(x(),t) plus(x(y),t) times(x(y),t) zero(nil,t) minus(x(),
                                                                                    t)),
            local(defun(equiv,x(y),x = y)),
            local(defun(pred,
                        x(),
                        declare(xargs(:verify-guards,t)),
                        x = t | x = nil)),
            local(defun(plus,
                        x(y),
                        declare(xargs(:guard,pred(x) & pred(y))),
                        (x | y) & ~(x & y))),
            local(defun(times,
                        x(y),
                        declare(xargs(:guard,pred(x) & pred(y))),
                        x & y)),
            local(defun(zero,nil,nil)),
            local(defun(minus,x(),declare(xargs(:guard,pred(x))),x)),
            defthm(equiv-is-an-equivalence,
                      booleanp(equiv(x,y))
                    & equiv(x,x)
                    & implies(equiv(x,y),equiv(y,x))
                    & implies(equiv(x,y) & equiv(y,z),equiv(x,z)),
                   :rule-classes,
                   [:equivalence (:type-prescription :corollary (or (equal (equiv x y) t) (equal (equiv x y) nil)))]),
            defthm(equiv-1-implies-equiv-plus,
                   implies(equiv(x1,x2),equiv(plus(x1,y),plus(x2,y))),
                   :rule-classes,
                   :congruence),
            defthm(equiv-2-implies-equiv-plus,
                   implies(equiv(y1,y2),equiv(plus(x,y1),plus(x,y2))),
                   :rule-classes,
                   :congruence),
            defthm(equiv-2-implies-equiv-times,
                   implies(equiv(y1,y2),equiv(times(x,y1),times(x,y2))),
                   :rule-classes,
                   :congruence),
            defthm(equiv-1-implies-equiv-minus,
                   implies(equiv(x1,x2),equiv(minus(x1),minus(x2))),
                   :rule-classes,
                   :congruence),
            defthm(closure-of-plus-for-pred,
                   implies(pred(x) & pred(y),pred(plus(x,y)))),
            defthm(closure-of-times-for-pred,
                   implies(pred(x) & pred(y),pred(times(x,y)))),
            defthm(closure-of-zero-for-pred,pred(zero())),
            defthm(closure-of-minus-for-pred,implies(pred(x),pred(minus(x)))),
            defthm(commutativity-of-plus,
                   implies(pred(x) & pred(y),equiv(plus(x,y),plus(y,x)))),
            defthm(commutativity-of-times,
                   implies(pred(x) & pred(y),equiv(times(x,y),times(y,x)))),
            defthm(associativity-of-plus,
                   implies(pred(x) & pred(y) & pred(z),
                           equiv(plus(plus(x,y),z),plus(x,plus(y,z))))),
            defthm(associativity-of-times,
                   implies(pred(x) & pred(y) & pred(z),
                           equiv(times(times(x,y),z),times(x,times(y,z))))),
            defthm(left-distributivity-of-times-over-plus,
                   implies(pred(x) & pred(y) & pred(z),
                           equiv(times(x,plus(y,z)),plus(times(x,y),times(x,z))))),
            defthm(left-unicity-of-zero-for-plus,
                   implies(pred(x),equiv(plus(zero(),x),x))),
            defthm(right-inverse-for-plus,
                   implies(pred(x),equiv(plus(x,minus(x)),zero()))));

defthm(right-distributivity-of-times-over-plus,
       implies(pred(x) & pred(y) & pred(z),
               equiv(times(plus(x,y),z),plus(times(x,z),times(y,z)))));

defthm(left-nullity-of-zero-for-times,
       implies(pred(x),equiv(times(zero(),x),zero())),
       :hints,
       (("Goal" :use (:instance(:functional-instance(acl2-agp::uniqueness-of-id-as-op-idempotent,
                                                     acl2-agp::equiv(equiv),
                                                     acl2-agp::pred(pred),
                                                     acl2-agp::op(plus),
                                                     acl2-agp::id(zero),
                                                     acl2-agp::inv(minus)),
                                acl2-agp::x(times(zero(),x))) :instance(left-distributivity-of-times-over-plus,
                                                                        y(zero()),
                                                                        z(zero()))))));

defthm(right-nullity-of-zero-for-times,
       implies(pred(x),equiv(times(x,zero()),zero())));

defthm(functional-commutativity-of-minus-times-right,
       implies(pred(x) & pred(y),equiv(times(x,minus(y)),minus(times(x,y)))),
       :hints,
       (("Goal" :use (:instance(:functional-instance(acl2-agp::uniqueness-of-op-inverses,
                                                     acl2-agp::equiv(equiv),
                                                     acl2-agp::pred(pred),
                                                     acl2-agp::op(plus),
                                                     acl2-agp::id(zero),
                                                     acl2-agp::inv(minus)),
                                acl2-agp::x(times(x,y)),
                                acl2-agp::y(times(x,minus(y)))) :instance(left-distributivity-of-times-over-plus,
                                                                          z(minus(y)))))));

defthm(functional-commutativity-of-minus-times-left,
       implies(pred(x) & pred(y),equiv(times(minus(x),y),minus(times(x,y)))));


