

in-package("ACL2");

Include("bdd-primitives");

Function p-cell(a,an,b,pa,pan,pb) { b-nand3(b-nand(a,pa),
                                            b-nand(an,pan),
                                            b-nand(b,pb)) };

Function g-cell(a,an,bn,ga,gan,gbn) { b-and3(b-nand(a,ga),
                                             b-nand(an,gan),
                                             b-nand(bn,gbn)) };

Function alu-cell(c,a,b,mpg)
{ gbn := car(mpg);
  { gan := cadr(mpg);
    { ga := caddr(mpg);
      { pb := cadddr(mpg);
        { pan := caddddr(mpg);
          { pa := cadddddr(mpg);
            { m := caddddddr(mpg);
              { an := b-not(a);
                { bn := b-not(b);
                  { p := p-cell(a,
                              an,
                              b,
                              pa,
                              pan,
                              pb);
                    { g := g-cell(a,
                                an,
                                bn,
                                ga,
                                gan,
                                gbn);
                      { mc := b-nand(c,
                                   m);
                        { z := b-equv3(mc,
                                     p,
                                     g);
                          [p, 
                           g, 
                           z
                           ]}}}}}}}}}}}}};

Function tv-alu-help(c,a,b,mpg,tree)
{ IF nlistp(tree) THEN alu-cell(c,car(a),car(b),mpg)
     ELSE { a-car := tfirstn(a,tree);
            { b-car := tfirstn(b,tree);
              { a-cdr := trestn(a,tree);
                { b-cdr := trestn(b,tree);
                  { lhs := tv-alu-help(c,
                                     a-car,
                                     b-car,
                                     mpg,
                                     car(tree));
                    { p-car := car(lhs);
                      { g-car := cadr(lhs);
                        { sum-car := cddr(lhs);
                          { c-car := t-carry(c,
                                           p-car,
                                           g-car);
                            { rhs := tv-alu-help(c-car,
                                               a-cdr,
                                               b-cdr,
                                               mpg,
                                               cdr(tree));
                              { p-cdr := car(rhs);
                                { g-cdr := cadr(rhs);
                                  { sum-cdr := cddr(rhs);
                                        b-and(p-car,
                                               p-cdr)
                                     :>     t-carry(g-car,
                                                     p-cdr,
                                                     g-cdr)
                                         :> (   sum-car
                                              @ sum-cdr)}}}}}}}}}}}}} };

Function shift-or-buf-cntl(c,an,zero,op0,op1,op2,op3)
{ op0- := b-not(op0);
  { op1- := b-not(op1);
    { op2- := b-not(op2);
      { decode-ror := b-and(op0-,op1-);
        { decode-asr := op0;
          { ror-si := b-and(decode-ror,c);
            { asr-si := b-and(decode-asr,
                            an);
              { si := b-or(asr-si,
                         ror-si);
                { t1 := b-nand(op2-,
                             op3);
                  { t2 := b-and(op0,
                              op1);
                    [b-or3(t2,
                           t1,
                           zero), 
                     si
                     ]}}}}}}}}}};

Function shift-or-buf(c,a,an,zero,op0,op1,op2,op3)
{ pass := car(shift-or-buf-cntl(c,an,zero,op0,op1,op2,op3));
  { si := cadr(shift-or-buf-cntl(c,an,zero,op0,op1,op2,op3));
    v-if(pass,a,v-shift-right(a,si))}};

Function carry-out-help(a0,result,zero,op0,op1,op2,op3)
{ result- := b-not(result);
  { zero- := b-not(zero);
    { op0- := b-not(op0);
      { op1- := b-not(op1);
        { op2- := b-not(op2);
          { op3- := b-not(op3);
            { op0 := b-not(op0-);
              { op1 := b-not(op1-);
                { op2 := b-not(op2-);
                  { op3 := b-not(op3-);
                    b-and(b-nand3(b-nand4(op3-,
                                          b-nand(op0-,
                                                 op1-),
                                          op2-,
                                          result),
                                  b-nand3(op3-,
                                          op2,
                                          result-),
                                  b-nand4(op3,
                                          op2-,
                                          b-nand(op0,
                                                 op1),
                                          a0)),
                          zero-)}}}}}}}}}};

Function overflow-help(rn,an,bn,zero,op0,op1,op2,op3)
{ an- := b-not(an);
  { zero- := b-not(zero);
    { op1- := b-not(op1);
      { op2- := b-not(op2);
        { op3- := b-not(op3);
          { an := b-not(an-);
            { op2 := b-not(op2-);
              b-if(rn,
                   b-nor(b-nand(b-nor(b-nand3(op3-,
                                              b-or3(op1-,
                                                    op2-,
                                                    b-xor(an,
                                                          bn)),
                                              b-nand3(op1-,
                                                      op2,
                                                      an-)),
                                      b-nand(b-nand3(op1,
                                                     op2-,
                                                     b-xor(an,
                                                           bn)),
                                             b-nand3(op1-,
                                                     op2-,
                                                     an))),
                                zero-),
                         b-nand3(b-nand(op2,
                                        an-),
                                 b-nand3(op0,
                                         op1-,
                                         an),
                                 b-nand(op2-,
                                        an))),
                   b-nor(b-nand(b-nor(b-nand3(op3-,
                                              b-or3(op1-,
                                                    op2-,
                                                    b-xor(an,
                                                          bn)),
                                              b-nand3(op1-,
                                                      op2,
                                                      an-)),
                                      b-nand(b-nand3(op1,
                                                     op2-,
                                                     b-xor(an,
                                                           bn)),
                                             b-nand3(op1-,
                                                     op2-,
                                                     an))),
                                zero-),
                         b-not(b-nand3(b-nand(op2,
                                              an-),
                                       b-nand3(op0,
                                               op1-,
                                               an),
                                       b-nand(op2-,
                                              an)))))}}}}}}};

Function core-alu(c,a,b,zero,mpg,op,tree)
{ op0 := car(op);
  { op1 := cadr(op);
    { op2 := caddr(op);
      { op3 := cadddr(op);
        { last-bit := sub1(len(a));
          { alu-help := tv-alu-help(c,
                                  a,
                                  b,
                                  mpg,
                                  tree);
            { alu-p := car(alu-help);
              { alu-g := cadr(alu-help);
                { alu-sum := cddr(alu-help);
                  { alu-carry := t-carry(c,
                                       alu-p,
                                       alu-g);
                    { out := shift-or-buf(c,
                                        alu-sum,
                                        a[sub1(len(a))],
                                        zero,
                                        op0,
                                        op1,
                                        op2,
                                        op3);
                          carry-out-help(a[0],
                                          alu-carry,
                                          zero,
                                          op0,
                                          op1,
                                          op2,
                                          op3)
                       :>     overflow-help(alu-sum[last-bit],
                                             a[last-bit],
                                             b[last-bit],
                                             zero,
                                             op0,
                                             op1,
                                             op2,
                                             op3)
                           :>     v-zerop(out)
                               :> out}}}}}}}}}}};

/* ;;;;;;;;; v-alu */Function cvzbv(carry,overflow,vector) {     carry
                                         :> overflow :> v-zerop(vector) :> vector };

Function v-adder(c,a,b)
{ IF nlistp(a) THEN boolfix(c) :> nil
     ELSE     b-xor3(c,car(a),car(b))
           :> v-adder(b-or(b-and(car(a),car(b)),
                           b-or(b-and(car(a),c),b-and(car(b),c))),
                      cdr(a),
                      cdr(b)) };

Function v-adder-carry-out(c,a,b) { v-adder(c,a,b)[len(a)] };

Function v-adder-output(c,a,b) { firstn(len(a),v-adder(c,a,b)) };

Function v-adder-overflowp(c,a,b)
{ b-and(b-equv(a[sub1(len(a))],b[sub1(len(b))]),
        b-xor(a[sub1(len(a))],v-adder-output(c,a,b)[sub1(len(a))])) };

Function cvzbv-v-adder(c,a,b)
{ cvzbv(v-adder-carry-out(c,a,b),v-adder-overflowp(c,a,b),v-adder-output(c,a,b)) };

Function cvzbv-inc(a) { cvzbv-v-adder(t,a,nat-to-v(0,len(a))) };

Function v-subtracter-carry-out(c,a,b) { b-not(v-adder-carry-out(b-not(c),
                                                                 v-not(a),
                                                                 b)) };

Function v-subtracter-overflowp(c,a,b) { v-adder-overflowp(b-not(c),v-not(a),b) };

Function v-subtracter-output(c,a,b) { v-adder-output(b-not(c),v-not(a),b) };

Function cvzbv-v-subtracter(c,a,b)
{ cvzbv(v-subtracter-carry-out(c,a,b),
        v-subtracter-overflowp(c,a,b),
        v-subtracter-output(c,a,b)) };

Function cvzbv-neg(a) { cvzbv-v-subtracter(nil,a,nat-to-v(0,len(a))) };

Function cvzbv-dec(a) { cvzbv-v-subtracter(t,nat-to-v(0,len(a)),a) };

Function v-ror(a,si) { v-shift-right(a,si) };

Function cvzbv-v-ror(c,a)
{ cvzbv(IF nlistp(a) THEN c
           ELSE a[0],
        nil,
        v-ror(a,c)) };

Function v-asr(a) { v-shift-right(a,a[sub1(len(a))]) };

Function cvzbv-v-asr(a)
{ cvzbv(IF listp(a) THEN a[0]
           ELSE nil,
        nil,
        v-asr(a)) };

Function v-lsr(a) { v-shift-right(a,nil) };

Function cvzbv-v-lsr(a)
{ cvzbv(IF listp(a) THEN a[0]
           ELSE nil,
        nil,
        v-lsr(a)) };

Function cvzbv-v-not(a) { cvzbv(nil,nil,v-not(a)) };

Function v-alu(c,a,b,op)
{ IF op = '[nil nil nil nil] THEN cvzbv(nil,nil,v-buf(a))
     ELIF op = '[t nil nil nil] THEN cvzbv-inc(a)
     ELIF op = '[nil t nil nil] THEN cvzbv-v-adder(c,a,b)
     ELIF op = '[t t nil nil] THEN cvzbv-v-adder(nil,a,b)
     ELIF op = '[nil nil t nil] THEN cvzbv-neg(a)
     ELIF op = '[t nil t nil] THEN cvzbv-dec(a)
     ELIF op = '[nil t t nil] THEN cvzbv-v-subtracter(c,a,b)
     ELIF op = '[t t t nil] THEN cvzbv-v-subtracter(nil,a,b)
     ELIF op = '[nil nil nil t] THEN cvzbv-v-ror(c,a)
     ELIF op = '[t nil nil t] THEN cvzbv-v-asr(a)
     ELIF op = '[nil t nil t] THEN cvzbv-v-lsr(a)
     ELIF op = '[t t nil t] THEN cvzbv(nil,nil,v-xor(a,b))
     ELIF op = '[nil nil t t] THEN cvzbv(nil,nil,v-or(a,b))
     ELIF op = '[t nil t t] THEN cvzbv(nil,nil,v-and(a,b))
     ELIF op = '[nil t t t] THEN cvzbv-v-not(a)
     ELSE cvzbv(nil,nil,v-buf(a)) };

Function carry-in-help(czop)
{ c := car(czop);
  { z := cadr(czop);
    { op0 := caddr(czop);
      { op1 := cadddr(czop);
        { op2 := caddddr(czop);
          { op3 := cadddddr(czop);
            { c- := b-not(c);
              { op0- := b-not(op0);
                { op1- := b-not(op1);
                  { op2- := b-not(op2);
                    { op3- := b-not(op3);
                      { c := b-not(c-);
                        { op0 := b-not(op0-);
                          { op1 := b-not(op1-);
                            { op2 := b-not(op2-);
                              { op3 := b-not(op3-);
                                b-or(b-nand3(b-nand3(op1-,
                                                     op2-,
                                                     op3-),
                                             b-nand3(op0-,
                                                     op1-,
                                                     op2),
                                             b-nand3(op0,
                                                     op1,
                                                     op2)),
                                     b-nand3(b-nand(op3,
                                                    c),
                                             b-nand3(op0-,
                                                     op2-,
                                                     c),
                                             b-nand3(op0-,
                                                     op2,
                                                     c-)))}}}}}}}}}}}}}}}};

Function decode-gen(zero,swap,op0,op1,op2,op3)
{ zero- := b-not(zero);
  { swap- := b-not(swap);
    { op0- := b-not(op0);
      { op1- := b-not(op1);
        { op2- := b-not(op2);
          { op3- := b-not(op3);
            { zero := b-not(zero-);
              { swap := b-not(swap-);
                { op0 := b-not(op0-);
                  { op1 := b-not(op1-);
                    { op2 := b-not(op2-);
                      { op3 := b-not(op3-);
                        [b-nand3(b-nand3(op0,
                                         op3,
                                         b-xor(op1,
                                               op2)),
                                 b-nand3(op2,
                                         op3-,
                                         b-nand(op1-,
                                                swap-)),
                                 b-nand3(op1,
                                         op2-,
                                         op3-)), 
                         b-nor(b-nand(b-nand4(op0,
                                              op1,
                                              op2-,
                                              op3),
                                      b-nand3(op2,
                                              op3-,
                                              b-nand(op1-,
                                                     swap-))),
                               zero), 
                         b-nor(b-nand3(b-nand3(op0,
                                               op3,
                                               b-xor(op1,
                                                     op2)),
                                       b-nand3(op0,
                                               op1-,
                                               op2),
                                       b-nand3(op1,
                                               op2-,
                                               op3-)),
                               zero)
                         ]}}}}}}}}}}}};

Function decode-prop(zero,swap,op0,op1,op2,op3)
{ zero- := b-not(zero);
  { swap- := b-not(swap);
    { op0- := b-not(op0);
      { op1- := b-not(op1);
        { op2- := b-not(op2);
          { op3- := b-not(op3);
            { zerop := b-not(zero-);
              { swap := b-not(swap-);
                { op0 := b-not(op0-);
                  { op1 := b-not(op1-);
                    { op2 := b-not(op2-);
                      { op3 := b-not(op3-);
                        [b-nand3(b-nand4(op0-,
                                         op1-,
                                         op2,
                                         op3),
                                 b-nand(op1,
                                        op3-),
                                 b-nand3(op2-,
                                         op3-,
                                         swap)), 
                         b-nor(op2-,
                               b-nor(op3-,
                                     b-nor(op0,
                                           op1-))), 
                         b-and(b-nand3(b-nand(op3,
                                              b-equv(op0,
                                                     op1)),
                                       b-nand(op2-,
                                              b-nand(swap,
                                                     op3-)),
                                       b-nand4(op0,
                                               op1-,
                                               op2,
                                               op3-)),
                               zero-)
                         ]}}}}}}}}}}}};

Function decode-mode(op0,op1,op2,op3) { b-nor(b-nor3(op0,op1,op2),op3) };

Function mpg(zsop)
{ zero := car(zsop);
  { swap := cadr(zsop);
    { op0 := caddr(zsop);
      { op1 := cadddr(zsop);
        { op2 := caddddr(zsop);
          { op3 := cadddddr(zsop);
               decode-gen(zero,
                           swap,
                           op0,
                           op1,
                           op2,
                           op3)
             @ decode-prop(zero,
                           swap,
                           op0,
                           op1,
                           op2,
                           op3)
             @ [decode-mode(op0,
                            op1,
                            op2,
                            op3)
                ]}}}}}};


