

in-package("ACL2");

Include("/usr/cli/projects/cacl2/version12/infix-prelude");

Function b-and(x,y)     { IF x
                               then IF y then t
                                         else nil
                               else nil }
 :mode :logic
 :verify-guards t;

Function b-or(x,y)     { IF x then t
                              elif y then t
                              else nil }
 :mode :logic
 :verify-guards t;

Function b-xor(a,b)     { IF a
                               then IF b then nil
                                         else t
                               elif b then t
                               else nil }
 :mode :logic
 :verify-guards t;

Theorem b-and-comm { b-and(x,y) = b-and(y,x) };

Theorem b-or-comm { b-or(x,y) = b-or(y,x) };

Theorem b-xor-comm { b-xor(x,y) = b-xor(y,x) };

Theorem b-xor-x-x { b-xor(x,x) = nil };

Theorem b-and-x-x
{ b-and(x,x) = (IF x then t
                     else nil) };

Theorem b-or-x-x
{ b-or(x,x) = (IF x then t
                    else nil) };

Theorem b-xor-t-x
{ b-xor(t,x) = (IF x then nil
                     else t) };

Theorem b-xor-nil-x
{ b-xor(nil,x) = (IF x then t
                       else nil) };

Theorem b-and-t-x
{ b-and(t,x) = (IF x then t
                     else nil) };

Theorem b-and-nil-x { b-and(nil,x) = nil };

Theorem b-or-t-x { b-or(t,x) = t };

Theorem b-or-nil-x
{ b-or(nil,x) = (IF x then t
                      else nil) };


