

Include("/usr/cli/projects/cacl2/version13/infix-prelude");

in-package("ACL2");

Include("list-defuns");

Include("utilities");

Module 
{elem-type00(x) : boolean;
 list-type00(l) : boolean;} 
{ 
  local IN-THEORY('[ground-zero]);
  
  local Function elem-type00(x) { integerp(x) };
  
  local Function list-type00(l)
  { IF atom(l) THEN eq(l,nil)
       ELSE elem-type00(car(l)) & list-type00(cdr(l)) };
  
  Theorem list-type00-defun
  {      list-type00(l)
     <-> IF atom(l) THEN eq(l,nil)
           ELSE elem-type00(car(l)) & list-type00(cdr(l)) }
   :rule-classes [[:rewrite  
   :corollary atom(l) -> list-type00(l) = null(l)] [:rewrite  
   :corollary list-type00(x :> l) = (elem-type00(x) & list-type00(l))]];
  
   };

Module 
{elem-type10(x,a) : boolean;
 list-type10(l,a) : boolean;} 
{ 
  local IN-THEORY('[ground-zero]);
  
  local Function elem-type10(x,a : ignore) { integerp(x) };
  
  local Function list-type10(l,a)
  { IF atom(l) THEN eq(l,nil)
       ELSE elem-type10(car(l),a) & list-type10(cdr(l),a) };
  
  Theorem list-type10-defun
  {      list-type10(l,a)
     <-> IF atom(l) THEN eq(l,nil)
           ELSE elem-type10(car(l),a) & list-type10(cdr(l),a) }
   :rule-classes [[:rewrite  
   :corollary atom(l) -> list-type10(l,a) = null(l)] [:rewrite  
   :corollary list-type10(x :> l,a) = (elem-type10(x,a) & list-type10(l,a))]];
  
   };

Module 
{elem-type11(a,x) : boolean;
 list-type11(a,l) : boolean;} 
{ 
  local IN-THEORY('[ground-zero]);
  
  local Function elem-type11(a : ignore,x) { integerp(x) };
  
  local Function list-type11(a,l)
  { IF atom(l) THEN eq(l,nil)
       ELSE elem-type11(a,car(l)) & list-type11(a,cdr(l)) };
  
  Theorem list-type11-defun
  {      list-type11(a,l)
     <-> IF atom(l) THEN eq(l,nil)
           ELSE elem-type11(a,car(l)) & list-type11(a,cdr(l)) }
   :rule-classes [[:rewrite  
   :corollary atom(l) -> list-type11(a,l) = null(l)] [:rewrite  
   :corollary list-type11(a,x :> l) = (elem-type11(a,x) & list-type11(a,l))]];
  
   };

Function replace-equal(a,b,l)
{ IF endp(l) THEN nil
     ELIF car(l) = a THEN b :> replace-equal(a,b,cdr(l))
     ELSE car(l) :> replace-equal(a,b,cdr(l)) }
 :guard true-listp(l);

Function my-conjoin(termlist1,termlist2)
{ termlist := termlist1 @ termlist2;
  IF len(termlist) == 1 THEN car(termlist)
     ELSE fcons-term('and,termlist)}
 :guard    true-listp(termlist1)
         & true-listp(termlist2)
         & consp(termlist1) | consp(termlist2);

Mutual-Recursion {
 
 Function my-conjuncts(term)
 { IF eq(term,t) THEN nil
      ELIF atom(term) THEN [term]
      ELIF eq(car(term),'and) THEN my-conjuncts-list(cdr(term))
      ELSE [term] };
 
 Function my-conjuncts-list(termlist)
 { IF atom(termlist) THEN nil
      ELSE my-conjuncts(car(termlist)) @ my-conjuncts-list(cdr(termlist)) };
 
 };

Macro list-type-true-listp-lemma(elem-type-fn : ignore,
                                 list-type-fn,
                                 formals,
                                 &optional 
                                 guard := 't) # 
['implies, 
 my-conjoin(my-conjuncts(guard),[list*(list-type-fn,formals)]), 
 '[true-listp l]
 ]
 ;

Theorem list-type-true-listp00
{ list-type-true-listp-lemma(elem-type00,list-type00,l()) }
 :hints [["Goal" :induct t]];

Theorem list-type-true-listp10
{ list-type-true-listp-lemma(elem-type10,list-type10,l(a)) }
 :hints [["Goal" :induct t]];

Theorem list-type-true-listp11
{ list-type-true-listp-lemma(elem-type11,list-type11,a(l)) }
 :hints [["Goal" :induct t]];

Macro list-type-cons-lemma(elem-type-fn,
                           list-type-fn,
                           formals,
                           &optional 
                           guard := 't) # 
{ vars := u::unique-symbols(1,
                          intern-in-package-of-symbol("X",list-type-fn),
                          formals);
  var := car(vars);
  ['implies, 
   my-conjoin(my-conjuncts(guard),
              [list*(elem-type-fn,
                     IF symbolp(elem-type-fn)
                        THEN replace-equal('l,var,formals)
                        ELSE [var]), 
               list*(list-type-fn,formals)
               ]), 
   list*(list-type-fn,replace-equal('l,['cons, var, 'l],formals))
   ]};

Theorem list-type-cons00
{ list-type-cons-lemma(elem-type00,list-type00,l()) };

Theorem list-type-cons10
{ list-type-cons-lemma(elem-type10,list-type10,l(a)) };

Theorem list-type-cons11
{ list-type-cons-lemma(elem-type11,list-type11,a(l)) };

Macro list-type-cdr-lemma(elem-type-fn : ignore,
                          list-type-fn,
                          formals,
                          &optional 
                          guard := 't) # 
['implies, 
 my-conjoin(my-conjuncts(guard),[list*(list-type-fn,formals)]), 
 list*(list-type-fn,replace-equal('l,'[cdr l],formals))
 ]
 ;

Theorem list-type-cdr00
{ list-type-cdr-lemma(elem-type00,list-type00,l()) };

Theorem list-type-cdr10
{ list-type-cdr-lemma(elem-type10,list-type10,l(a)) };

Theorem list-type-cdr11
{ list-type-cdr-lemma(elem-type11,list-type11,a(l)) };

IN-THEORY(disable(list-type-cdr00,list-type-cdr10,list-type-cdr11));

Macro list-type-member-equal-lemma(elem-type-fn,
                                   list-type-fn,
                                   formals,
                                   &optional 
                                   guard := 't) # 
{ vars := u::unique-symbols(1,
                          intern-in-package-of-symbol("X",list-type-fn),
                          formals);
  var := car(vars);
  ['implies, 
   my-conjoin(my-conjuncts(guard),
              [['member-equal, var, 'l], list*(list-type-fn,formals)]), 
   list*(elem-type-fn,
         IF symbolp(elem-type-fn) THEN replace-equal('l,var,formals)
            ELSE [var])
   ]};

Theorem list-type-member-equal00
{ list-type-member-equal-lemma(elem-type00,list-type00,l()) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr00)]];

Theorem list-type-member-equal10
{ list-type-member-equal-lemma(elem-type10,list-type10,l(a)) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr10)]];

Theorem list-type-member-equal11
{ list-type-member-equal-lemma(elem-type11,list-type11,a(l)) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr11)]];

Macro list-type-append-lemma(elem-type-fn : ignore,
                             list-type-fn,
                             formals,
                             &optional 
                             guard := 't) # 
{ vars := u::unique-symbols(2,
                          intern-in-package-of-symbol("L",list-type-fn),
                          formals);
  var1 := car(vars);
  var2 := cadr(vars);
  ['implies, 
   my-conjoin(my-conjuncts(guard),[['true-listp, var1]]), 
   ['equal, 
    list*(list-type-fn,replace-equal('l,['append, var1, var2],formals)), 
    ['and, 
     list*(list-type-fn,replace-equal('l,var1,formals)), 
     list*(list-type-fn,replace-equal('l,var2,formals))
     ]
    ]
   ]}
 ;

Theorem list-type-append00
{ list-type-append-lemma(elem-type00,list-type00,l()) }
 :hints [["Goal" :induct t]];

Theorem list-type-append10
{ list-type-append-lemma(elem-type10,list-type10,l(a)) }
 :hints [["Goal" :induct t]];

Theorem list-type-append11
{ list-type-append-lemma(elem-type11,list-type11,a(l)) }
 :hints [["Goal" :induct t]];

Macro list-type-firstn-lemma(elem-type-fn : ignore,
                             list-type-fn,
                             formals,
                             &optional 
                             guard := 't) # 
{ vars := u::unique-symbols(1,
                          intern-in-package-of-symbol("N",list-type-fn),
                          formals);
  var := car(vars);
  ['implies, 
   my-conjoin(my-conjuncts(guard),[list*(list-type-fn,formals)]), 
   list*(list-type-fn,replace-equal('l,['firstn, var, 'l],formals))
   ]}
 ;

Theorem list-type-firstn00
{ list-type-firstn-lemma(elem-type00,list-type00,l()) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr00)]];

Theorem list-type-firstn10
{ list-type-firstn-lemma(elem-type10,list-type10,l(a)) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr10)]];

Theorem list-type-firstn11
{ list-type-firstn-lemma(elem-type11,list-type11,a(l)) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr11)]];

Macro list-type-last-lemma(elem-type-fn : ignore,
                           list-type-fn,
                           formals,
                           &optional 
                           guard := 't) # 
['implies, 
 my-conjoin(my-conjuncts(guard),[list*(list-type-fn,formals)]), 
 list*(list-type-fn,replace-equal('l,'[last l],formals))
 ]
 ;

Theorem list-type-last00
{ list-type-last-lemma(elem-type00,list-type00,l()) }
 :hints [["Goal" :induct t]];

Theorem list-type-last10
{ list-type-last-lemma(elem-type10,list-type10,l(a)) }
 :hints [["Goal" :induct t]];

Theorem list-type-last11
{ list-type-last-lemma(elem-type11,list-type11,a(l)) }
 :hints [["Goal" :induct t]];

Macro list-type-make-list-lemma(elem-type-fn,
                                list-type-fn,
                                formals,
                                &optional 
                                guard1 := 't) # 
{ vars := u::unique-symbols(3,
                          intern-in-package-of-symbol("X",list-type-fn),
                          formals);
  var1 := car(vars);
  var2 := cadr(vars);
  var3 := caddr(vars);
  guards2 := my-conjuncts(guard);
  rule := ['iff, 
         list*(list-type-fn,
               replace-equal('l,['make-list-ac, var1, var2, var3],formals)), 
         ['and, 
          ['or, 
           ['zp, var1], 
           list*(elem-type-fn,
                 IF symbolp(elem-type-fn) THEN replace-equal('l,var2,formals)
                    ELSE [var2])
           ], 
          list*(list-type-fn,replace-equal('l,var3,formals))
          ]
         ];
  IF guards2 THEN ['implies, my-conjoin(guards2,nil), rule]
     ELSE rule};

Theorem list-type-make-list00
{ list-type-make-list-lemma(elem-type00,list-type00,l()) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr00)]];

Theorem list-type-make-list10
{ list-type-make-list-lemma(elem-type10,list-type10,l(a)) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr10)]];

Theorem list-type-make-list11
{ list-type-make-list-lemma(elem-type11,list-type11,a(l)) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr11)]];

Macro list-type-nthcdr-lemma(elem-type-fn : ignore,
                             list-type-fn,
                             formals,
                             &optional 
                             guard := 't) # 
{ vars := u::unique-symbols(1,
                          intern-in-package-of-symbol("N",list-type-fn),
                          formals);
  var := car(vars);
  ['implies, 
   my-conjoin(my-conjuncts(guard),[list*(list-type-fn,formals)]), 
   list*(list-type-fn,replace-equal('l,['nthcdr, var, 'l],formals))
   ]}
 ;

Theorem list-type-nthcdr00
{ list-type-nthcdr-lemma(elem-type00,list-type00,l()) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr00)]];

Theorem list-type-nthcdr10
{ list-type-nthcdr-lemma(elem-type10,list-type10,l(a)) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr10)]];

Theorem list-type-nthcdr11
{ list-type-nthcdr-lemma(elem-type11,list-type11,a(l)) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr11)]];

Macro list-type-nth-seg-lemma(elem-type-fn : ignore,
                              list-type-fn,
                              formals,
                              &optional 
                              guard := 't) # 
{ vars := u::unique-symbols(2,
                          intern-in-package-of-symbol("N",list-type-fn),
                          formals);
  var1 := car(vars);
  var2 := cadr(vars);
  ['implies, 
   my-conjoin(my-conjuncts(guard),[list*(list-type-fn,formals)]), 
   list*(list-type-fn,replace-equal('l,['nth-seg, var1, var2, 'l],formals))
   ]}
 ;

Theorem list-type-nth-seg00
{ list-type-nth-seg-lemma(elem-type00,list-type00,l()) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr00)]];

Theorem list-type-nth-seg10
{ list-type-nth-seg-lemma(elem-type10,list-type10,l(a)) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr10)]];

Theorem list-type-nth-seg11
{ list-type-nth-seg-lemma(elem-type11,list-type11,a(l)) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr11)]];

Macro list-type-put-seg-lemma(elem-type-fn : ignore,
                              list-type-fn,
                              formals,
                              &optional 
                              guard := 't) # 
{ vars := u::unique-symbols(2,
                          intern-in-package-of-symbol("N",list-type-fn),
                          formals);
  var1 := car(vars);
  var2 := cadr(vars);
  ['implies, 
   my-conjoin(my-conjuncts(guard),
              [list*(list-type-fn,formals), 
               list*(list-type-fn,replace-equal('l,var2,formals))
               ]), 
   list*(list-type-fn,replace-equal('l,['put-seg, var1, var2, 'l],formals))
   ]}
 ;

Theorem list-type-put-seg00
{ list-type-put-seg-lemma(elem-type00,list-type00,l()) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr00)]];

Theorem list-type-put-seg10
{ list-type-put-seg-lemma(elem-type10,list-type10,l(a)) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr10)]];

Theorem list-type-put-seg11
{ list-type-put-seg-lemma(elem-type11,list-type11,a(l)) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr11)]];

Macro list-type-put-seg-fill-lemma(elem-type-fn,
                                   list-type-fn,
                                   formals,
                                   &optional 
                                   guard := 't) # 
{ vars := u::unique-symbols(3,
                          intern-in-package-of-symbol("N",list-type-fn),
                          formals);
  var1 := car(vars);
  var2 := cadr(vars);
  var3 := caddr(vars);
  ['implies, 
   my-conjoin(my-conjuncts(guard),
              [list*(list-type-fn,formals), 
               list*(list-type-fn,replace-equal('l,var2,formals))
               ]), 
   ['iff, 
    list*(list-type-fn,
          replace-equal('l,['put-seg-fill, var1, var2, 'l, var3],formals)), 
    ['or, 
     ['<=, ['nfix, var1], '[len l]], 
     list*(elem-type-fn,
           IF symbolp(elem-type-fn) THEN replace-equal('l,var3,formals)
              ELSE [var3])
     ]
    ]
   ]};

Theorem list-type-put-seg-fill00
{ list-type-put-seg-fill-lemma(elem-type00,list-type00,l()) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr00)]];

Theorem list-type-put-seg-fill10
{ list-type-put-seg-fill-lemma(elem-type10,list-type10,l(a)) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr10)]];

Theorem list-type-put-seg-fill11
{ list-type-put-seg-fill-lemma(elem-type11,list-type11,a(l)) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr11)]];

Macro list-type-put-nth-lemma(elem-type-fn,
                              list-type-fn,
                              formals,
                              &optional 
                              guard := 't) # 
{ vars := u::unique-symbols(2,
                          intern-in-package-of-symbol("N",list-type-fn),
                          formals);
  var1 := car(vars);
  var2 := cadr(vars);
  ['implies, 
   my-conjoin(my-conjuncts(guard),[list*(list-type-fn,formals)]), 
   ['iff, 
    list*(list-type-fn,replace-equal('l,['put-nth, var1, var2, 'l],formals)), 
    ['if, 
     ['<, ['nfix, var1], '[len l]], 
     list*(elem-type-fn,
           IF symbolp(elem-type-fn) THEN replace-equal('l,var2,formals)
              ELSE [var2]), 
     t
     ]
    ]
   ]};

Theorem list-type-put-nth00
{ list-type-put-nth-lemma(elem-type00,list-type00,l()) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr00)]];

Theorem list-type-put-nth10
{ list-type-put-nth-lemma(elem-type10,list-type10,l(a)) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr10)]];

Theorem list-type-put-nth11
{ list-type-put-nth-lemma(elem-type11,list-type11,a(l)) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr11)]];

Macro list-type-put-nth-fill-lemma(elem-type-fn,
                                   list-type-fn,
                                   formals,
                                   &optional 
                                   guard := 't) # 
{ vars := u::unique-symbols(3,
                          intern-in-package-of-symbol("N",list-type-fn),
                          formals);
  var1 := car(vars);
  var2 := cadr(vars);
  var3 := caddr(vars);
  ['implies, 
   my-conjoin(my-conjuncts(guard),[list*(list-type-fn,formals)]), 
   ['iff, 
    list*(list-type-fn,
          replace-equal('l,['put-nth-fill, var1, var2, 'l, var3],formals)), 
    ['and, 
     list*(elem-type-fn,
           IF symbolp(elem-type-fn) THEN replace-equal('l,var2,formals)
              ELSE [var2]), 
     ['or, 
      ['<=, ['nfix, var1], '[len l]], 
      list*(elem-type-fn,
            IF symbolp(elem-type-fn) THEN replace-equal('l,var3,formals)
               ELSE [var3])
      ]
     ]
    ]
   ]};

Theorem list-type-put-nth-fill00
{ list-type-put-nth-fill-lemma(elem-type00,list-type00,l()) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr00)]];

Theorem list-type-put-nth-fill10
{ list-type-put-nth-fill-lemma(elem-type10,list-type10,l(a)) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr10)]];

Theorem list-type-put-nth-fill11
{ list-type-put-nth-fill-lemma(elem-type11,list-type11,a(l)) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr11)]];

Macro list-type-remove-equal-lemma(elem-type-fn : ignore,
                                   list-type-fn,
                                   formals,
                                   &optional 
                                   guard := 't) # 
{ vars := u::unique-symbols(1,
                          intern-in-package-of-symbol("N",list-type-fn),
                          formals);
  var := car(vars);
  ['implies, 
   my-conjoin(my-conjuncts(guard),[list*(list-type-fn,formals)]), 
   list*(list-type-fn,replace-equal('l,['remove-equal, var, 'l],formals))
   ]}
 ;

Theorem list-type-remove-equal00
{ list-type-remove-equal-lemma(elem-type00,list-type00,l()) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr00)]];

Theorem list-type-remove-equal10
{ list-type-remove-equal-lemma(elem-type10,list-type10,l(a)) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr10)]];

Theorem list-type-remove-equal11
{ list-type-remove-equal-lemma(elem-type11,list-type11,a(l)) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr11)]];

Macro list-type-revappend-lemma(elem-type-fn : ignore,
                                list-type-fn,
                                formals,
                                &optional 
                                guard := 't) # 
{ vars := u::unique-symbols(2,
                          intern-in-package-of-symbol("L",list-type-fn),
                          formals);
  var1 := car(vars);
  var2 := cadr(vars);
  ['implies, 
   my-conjoin(my-conjuncts(guard),
              [list*(list-type-fn,replace-equal('l,var1,formals)), 
               list*(list-type-fn,replace-equal('l,var2,formals))
               ]), 
   list*(list-type-fn,replace-equal('l,['revappend, var1, var2],formals))
   ]}
 ;

Theorem list-type-revappend00
{ list-type-revappend-lemma(elem-type00,list-type00,l()) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr00)]];

Theorem list-type-revappend10
{ list-type-revappend-lemma(elem-type10,list-type10,l(a)) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr10)]];

Theorem list-type-revappend11
{ list-type-revappend-lemma(elem-type11,list-type11,a(l)) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr11)]];

IN-THEORY(disable(list-type-revappend00,
                  list-type-revappend10,
                  list-type-revappend11));

Macro list-type-reverse-lemma(elem-type-fn : ignore,
                              list-type-fn,
                              formals,
                              &optional 
                              guard := 't) # 
['implies, 
 my-conjoin(my-conjuncts(guard),[list*(list-type-fn,formals)]), 
 list*(list-type-fn,replace-equal('l,'[reverse l],formals))
 ]
 ;

Theorem list-type-reverse00
{ list-type-reverse-lemma(elem-type00,list-type00,l()) }
 :hints [["Goal" :do-not-induct t
                 :in-theory enable(list-type-revappend00)]];

Theorem list-type-reverse10
{ list-type-reverse-lemma(elem-type10,list-type10,l(a)) }
 :hints [["Goal" :do-not-induct t
                 :in-theory enable(list-type-revappend10)]];

Theorem list-type-reverse11
{ list-type-reverse-lemma(elem-type11,list-type11,a(l)) }
 :hints [["Goal" :do-not-induct t
                 :in-theory enable(list-type-revappend11)]];

Macro list-type-take$-lemma(elem-type-fn : ignore,
                            list-type-fn,
                            formals,
                            &optional 
                            guard := 't) # 
{ vars := u::unique-symbols(1,
                          intern-in-package-of-symbol("N",list-type-fn),
                          formals);
  var := car(vars);
  ['implies, 
   my-conjoin(my-conjuncts(guard),
              [list*(list-type-fn,formals), ['<=, var, '[len l]]]), 
   list*(list-type-fn,replace-equal('l,['take$, var, 'l],formals))
   ]}
 ;

Theorem list-type-take$00
{ list-type-take$-lemma(elem-type00,list-type00,l()) }
 :hints [["Goal" :induct t]];

Theorem list-type-take$10
{ list-type-take$-lemma(elem-type10,list-type10,l(a)) }
 :hints [["Goal" :induct t]];

Theorem list-type-take$11
{ list-type-take$-lemma(elem-type11,list-type11,a(l)) }
 :hints [["Goal" :induct t]];

IN-THEORY(disable(list-type-take$00,list-type-take$10,list-type-take$11));

Macro list-type-butlast$-lemma(elem-type-fn : ignore,
                               list-type-fn,
                               formals,
                               &optional 
                               guard := 't) # 
{ vars := u::unique-symbols(1,
                          intern-in-package-of-symbol("N",list-type-fn),
                          formals);
  var := car(vars);
  ['implies, 
   my-conjoin(my-conjuncts(guard),[list*(list-type-fn,formals), 
                                   ['<=, 0, var]
                                   ]), 
   list*(list-type-fn,replace-equal('l,['butlast$, 'l, var],formals))
   ]}
 ;

Theorem list-type-butlast$00
{ list-type-butlast$-lemma(elem-type00,list-type00,l()) }
 :hints [["Goal" :do-not-induct t
                 :in-theory enable(list-type-take$00,butlast$)]];

Theorem list-type-butlast$10
{ list-type-butlast$-lemma(elem-type10,list-type10,l(a)) }
 :hints [["Goal" :do-not-induct t
                 :in-theory enable(list-type-take$10,butlast$)]];

Theorem list-type-butlast$11
{ list-type-butlast$-lemma(elem-type11,list-type11,a(l)) }
 :hints [["Goal" :do-not-induct t
                 :in-theory enable(list-type-take$11,butlast$)]];

Macro list-type-car-lemma(elem-type-fn,list-type-fn,formals,&optional guard := 't) # 
['implies, 
 my-conjoin(my-conjuncts(guard),[list*(list-type-fn,formals), 'l]), 
 list*(elem-type-fn,
       IF symbolp(elem-type-fn) THEN replace-equal('l,'[car l],formals)
          ELSE ['[car l]])
 ];

Theorem list-type-car00
{ list-type-car-lemma(elem-type00,list-type00,l()) };

Theorem list-type-car10
{ list-type-car-lemma(elem-type10,list-type10,l(a)) };

Theorem list-type-car11
{ list-type-car-lemma(elem-type11,list-type11,a(l)) };

Macro list-type-nth-lemma(elem-type-fn,list-type-fn,formals,&optional guard := 't) # 
{ vars := u::unique-symbols(1,
                          intern-in-package-of-symbol("N",list-type-fn),
                          formals);
  var := car(vars);
  ['implies, 
   my-conjoin(my-conjuncts(guard),
              [list*(list-type-fn,formals), ['<, ['nfix, var], '[len l]]]), 
   list*(elem-type-fn,
         IF symbolp(elem-type-fn)
            THEN replace-equal('l,['nth, var, 'l],formals)
            ELSE [['nth, var, 'l]])
   ]};

Theorem list-type-nth00
{ list-type-nth-lemma(elem-type00,list-type00,l()) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr00)]];

Theorem list-type-nth10
{ list-type-nth-lemma(elem-type10,list-type10,l(a)) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr10)]];

Theorem list-type-nth11
{ list-type-nth-lemma(elem-type11,list-type11,a(l)) }
 :hints [["Goal" :induct t
                 :in-theory enable(list-type-cdr11)]];

Function pack-intern-names(name1,name2) { u::pack-intern(name1,name1,"-",name2) };

Function pack-intern-all-names(name,l) { FOR x in l, 
                                              collect pack-intern-names(name,x) };

Function deflist-defthms(list-type-fn,
                         formals,
                         elem-type-fn,
                         guard1,
                         theory1,
                         car-rule-classes,
                         nth-rule-classes)
{ FOR fn in theory1, 
       collect { lemmaname := pack-intern-names(list-type-fn,fn);
                 { lemma-macro-name := u::pack-intern(list-type-fn,
                                                    'list-type,
                                                    fn,
                                                    'lemma);
                   { rule-classes := CASE fn {
                      car :  car-rule-classes ;
                      nth :  nth-rule-classes ;
                      true-listp :  '[:rewrite :forward-chaining] ;
                      t :  '[:rewrite] ;
                      };
                     { hints1 := IF    consp(my-conjuncts(guard1))
                                   | len(formals) > 2
                                  THEN '[["Goal" :induct t]]
                                  ELSE { numparams :=    len(formals)
                                                     - 1;
                                         posn := position-equal('l,
                                                              formals);
                                         numparams-string := coerce(explode-nonnegative-integer(numparams,
                                                                                              nil),
                                                                  'string);
                                         posn-string := coerce(explode-nonnegative-integer(posn,
                                                                                         nil),
                                                             'string);
                                         canonical-elem-type-fn := u::pack-intern(list-type-fn,
                                                                                'elem-type,
                                                                                numparams-string,
                                                                                posn-string);
                                         canonical-list-type-fn := u::pack-intern(list-type-fn,
                                                                                'list-type,
                                                                                numparams-string,
                                                                                posn-string);
                                         lemma-name := u::pack-intern(list-type-fn,
                                                                    'list-type-,
                                                                    fn,
                                                                    numparams-string,
                                                                    posn-string);
                                         elem-type-instance := IF    consp(elem-type-fn)
                                                                 & eq(car(elem-type-fn),
                                                                     'lambda)
                                                                THEN elem-type-fn
                                                                ELSE { elem-formals := replace-equal('l,
                                                                                                   'x,
                                                                                                   formals);
                                                                       ['lambda, 
                                                                        elem-formals, 
                                                                        list*(elem-type-fn,
                                                                              elem-formals)
                                                                        ]};
                                         subst := CASE length(formals) {
                                          2 : 
                                               [['a, 
                                                 car(remove('l,
                                                            formals))
                                                 ]
                                                ] ;
                                          t :  nil ;
                                          };
                                         [["Goal", 
                                           :do-not-induct, 
                                           t, 
                                           :use, 
                                           [:functional-instance, 
                                            list*(:instance,
                                                  lemma-name,
                                                  subst), 
                                            [canonical-elem-type-fn, 
                                             elem-type-instance
                                             ], 
                                            [canonical-list-type-fn, 
                                             list-type-fn
                                             ]
                                            ]
                                           ]
                                          ]};
                       ['defthm, 
                        lemmaname, 
                        [lemma-macro-name, 
                         elem-type-fn, 
                         list-type-fn, 
                         formals, 
                         guard
                         ], 
                        :rule-classes, 
                        rule-classes, 
                        :hints, 
                        hints1
                        ]}}}} };

Constant *deflist-options* = 
 '[:car-rule-classes :nth-rule-classes :theory :omit-defun :theory-name]
 ;

Constant *deflist-theory-options* = 
 '[[append]
   [butlast$ take$]
   [car]
   [cdr]
   [cons]
   [firstn]
   [last]
   [make-list]
   [member-equal]
   [nth]
   [nth-seg]
   [nthcdr]
   [put-nth]
   [put-nth-fill]
   [put-seg]
   [put-seg-fill]
   [remove-equal]
   [revappend]
   [reverse revappend]
   [take$]
   [true-listp]]
 ;

Function my-set-difference(l1,l2)
{ IF atom(l1) THEN nil
     ELIF car(l1) in l2 THEN my-set-difference(cdr(l1),l2)
     ELSE car(l1) :> my-set-difference(cdr(l1),l2) };

Function insert-dependencies(l,alist,already-seen)
{ IF atom(l) THEN nil
     ELIF car(l) member already-seen
     THEN insert-dependencies(cdr(l),alist,already-seen)
     ELSE { pair := assoc-equal(car(l),alist);
            { new := my-set-difference(cdr(pair),already-seen);
                 new
               @ [car(l)]
               @ insert-dependencies(cdr(l),
                                    alist,
                                        car(l)
                                     :> (new @ already-seen))}} };

Theory minimal-theory-for-deflist :=        current-theory('ground-zero)
                                      union current-theory('list-defuns);

Function deflist-check-syntax(name,formals,body)
{ IF ~(symbolp(name))
     THEN u::bomb('deflist,
                  "The function name must be a symbol, but ~p0 is not.",
                  name)
     ELIF ~(true-listp(formals))
     THEN u::bomb('deflist,"The argument list ~p0 is not a true list.",formals)
     ELIF ~(arglistp(formals))
     THEN {  <elmt, msg> := find-first-bad-arg(formals);
            u::bomb('deflist,
                    "The argument list ~p0 is not valid because the ~
                         element ~p1 ~@2.",
                    formals,
                    elmt,
                    msg) }
     ELIF { formal-strings := u::mapcar-string(formals);
            l-tail := "L" in formal-strings;
            multiple-ls := "L" in cdr(l-tail);
            ~l-tail | multiple-ls}
     THEN u::bomb('deflist,
                  "The formal argument list to DEFLIST must be a valid ~
                       functional argument list that contains exactly 1 ~
                       symbol whose print-name is \"L\", but ~p0 is not.",
                  formals)
     ELIF null(body) THEN u::bomb('deflist,"The function body is empty!")
     ELSE { last-form := car(last(body));
            options? :=    len(body) >= 2
                       & true-listp(last-form)
                       & eq(car(last-form),:options);
            predicate := IF options? THEN car(last(butlast$(body,1)))
                          ELSE last-form;
            IF    symbolp(predicate)
                |    true-listp(predicate)
                  & len(predicate) = 3
                  & eq(first(predicate),'lambda)
                  & arglistp(second(predicate))
                  & len(second(predicate)) <= 2 THEN nil
               ELSE u::bomb('deflist,
                            "The DEFLIST predicate designator must either ~
                             be a symbol, or a 1 or 2-argument LAMBDA function, ~
                             but ~p0 is not.",
                            predicate)} }
 :mode :program;

Macro deflist(name,formals,&rest body) # 
{ syntax-err := deflist-check-syntax(name,formals,body);
  last-form := car(last(body));
  options? := len(body) >= 2 & true-listp(last-form) & eq(car(last-form),:options);
  option-list := IF options? THEN cdr(last-form)
                  ELSE nil;
  predicate := IF options? THEN car(last(butlast$(body,1)))
                ELSE last-form;
  guard := u::get-guards-from-body(body);
  ctx := 'deflist;
  option-err := u::get-option-check-syntax(ctx,
                                         option-list,
                                         *deflist-options*,
                                         nil,
                                         nil);
  omit-defun := u::get-option-as-flag(ctx,:omit-defun,option-list);
  theory1 := insert-dependencies(u::get-option-subset(ctx,
                                                    :theory,
                                                    option-list,
                                                    strip-cars(*deflist-theory-options*),
                                                    strip-cars(*deflist-theory-options*)),
                               *deflist-theory-options*,
                               nil);
  theory-name := u::get-option-argument(ctx,
                                      :theory-name,
                                      option-list,
                                      :form,
                                      u::pack-intern(name,name,"-THEORY"),
                                      u::pack-intern(name,name,"-THEORY"));
  car-rule-classes := u::get-option-argument(ctx,
                                           :car-rule-classes,
                                           option-list,
                                           :form,
                                           :rewrite,
                                           :rewrite);
  nth-rule-classes := u::get-option-argument(ctx,
                                           :nth-rule-classes,
                                           option-list,
                                           :form,
                                           :rewrite,
                                           :rewrite);
     syntax-err
   | option-err
   | { theory1 := union-equal('[true-listp],theory);
       list*('encapsulate,
             nil,
             '[local [deflabel deflist-reserved-label]],
             '[local
               [in-theory [theory 'minimal-theory-for-deflist]]],
                (IF omit-defun THEN nil
                     ELSE [list*('defun,
                                 name,
                                 formals,
                                    butlast$(body,
                                             IF options?
                                                THEN 2
                                                ELSE 1)
                                  @ [['cond, 
                                     '[[atom l] [eq l nil]], 
                                     [t, 
                                      ['and, 
                                       list*(predicate,
                                             replace-equal('l,
                                                           '[car
                                                             l],
                                                           formals)), 
                                       list*(name,
                                             replace-equal('l,
                                                           '[cdr
                                                             l],
                                                           formals))
                                       ]
                                      ]
                                     ]
                                    ])
                           ])
              @ deflist-defthms(name,
                               formals,
                               predicate,
                               guard,
                               theory1,
                               car-rule-classes,
                               nth-rule-classes)
              @ [['deftheory, 
                 theory-name, 
                 ['quote, pack-intern-all-names(name,theory1)]
                 ]
                ])}};




