

Include("/usr/cli/projects/cacl2/version13/infix-prelude");

Function car-cdr-symbolp1(lst)
{ IF null(lst) THEN nil
     ELIF eql(car(lst),'R') THEN null(cdr(lst))
     ELSE car(lst) in '[ 'A' 'D'] & car-cdr-symbolp1(cdr(lst)) }
 :mode :program;

Function car-cdr-symbolp(x)
{    symbolp(x)
   & symbol-package-name(x) = "NQTHM"
   & { lst := coerce(symbol-name(x),'list);
       lst & eql(car(lst),'C') & car-cdr-symbolp1(cdr(lst))} }
 :mode :program;

Function make-nqthm-car-cdr-nest1(lst,arg)
{ IF null(lst) THEN nil
     ELIF null(cdr(lst)) THEN arg
     ELIF eql(car(lst),'A')
     THEN ['nqthm::car, make-nqthm-car-cdr-nest1(cdr(lst),arg)]
     ELSE ['nqthm::cdr, make-nqthm-car-cdr-nest1(cdr(lst),arg)] }
 :mode :program;

Function make-nqthm-car-cdr-nest(sym,arg)
{ make-nqthm-car-cdr-nest1(cdr(coerce(symbol-name(sym),'list)),arg) }
 :mode :program;

Mutual-Recursion {
 
 Function nqthm-sublis(alist,term)
 { IF atom(term)
      THEN IF symbolp(term)
              THEN { temp := assoc-eq(term,alist);
                     IF temp THEN cdr(temp)
                        ELSE term}
              ELSE term
      ELIF eq(car(term),'quote) THEN term
      ELSE car(term) :> nqthm-sublis-lst(alist,cdr(term)) }
  :mode :program;
 
 Function nqthm-sublis-lst(alist,lst)
 { IF null(lst) THEN nil
      ELSE     nqthm-sublis(alist,car(lst))
            :> nqthm-sublis-lst(alist,cdr(lst)) }
  :mode :program;
 
 };

Label nqthm::nqthm;

Label nqthm::nqthm-evaluation;

Label nqthm::nqthm-commands;

Label nqthm::nqthm-translate;

Mutual-Recursion {
 
 Function nqthm-translate(term)
 { IF atom(term)
      THEN IF eq(term,'nqthm::t) THEN *t*
              ELIF eq(term,'nqthm::f) THEN *nil*
              ELIF eq(term,'nqthm::nil) THEN ''nqthm::nil
              ELIF symbolp(term) THEN term
              ELSE ['quote, convert-nqthm-evg(term)]
      ELIF eq(car(term),'quote) THEN ['quote, convert-nqthm-evg(cadr(term))]
      ELIF car(term) in '[nqthm::and nqthm::or nqthm::plus nqthm::times]
      THEN xxxjoin(car(term),nqthm-translate-lst(cdr(term)))
      ELIF car-cdr-symbolp(car(term))
      THEN make-nqthm-car-cdr-nest(car(term),nqthm-translate(cadr(term)))
      ELIF eq(car(term),'nqthm::cond)
      THEN IF eq(car(cadr(term)),'nqthm::t)
              THEN nqthm-translate(cadr(cadr(term)))
              ELSE ['if, 
                    nqthm-translate(car(cadr(term))), 
                    nqthm-translate(cadr(cadr(term))), 
                    nqthm-translate('nqthm::cond :> cddr(term))
                    ]
      ELIF eq(car(term),'nqthm::case)
      THEN IF eq(car(caddr(term)),'nqthm::otherwise)
              THEN nqthm-translate(cadr(caddr(term)))
              ELSE ['if, 
                    nqthm-translate(['equal, 
                                     cadr(term), 
                                     ['quote, car(caddr(term))]
                                     ]), 
                    nqthm-translate(cadr(caddr(term))), 
                    nqthm-translate(list*('nqthm::case,
                                          cadr(term),
                                          cdddr(term)))
                    ]
      ELIF eq(car(term),'nqthm::let)
      THEN nqthm-sublis(pairlis$(strip-cars(cadr(term)),
                                 nqthm-translate-lst(strip-cadrs(cadr(term)))),
                        nqthm-translate(caddr(term)))
      ELIF eq(car(term),'nqthm::list)
      THEN xxxjoin('nqthm::cons,nqthm-translate-lst(cdr(term)) @ [''nqthm::nil])
      ELIF eq(car(term),'nqthm::list)
      THEN xxxjoin('nqthm::cons,nqthm-translate-lst(cdr(term)))
      ELSE car(term) :> nqthm-translate-lst(cdr(term)) }
  :mode :program;
 
 Function nqthm-translate-lst(lst)
 { IF atom(lst) THEN nil
      ELSE nqthm-translate(car(lst)) :> nqthm-translate-lst(cdr(lst)) };
 
 };

Label nqthm::one-quote-notation;

Function nqthm::numberp(x) { integerp(x) & ~(x < 0) };

Function nqthm::zero() { 0 };

Function nqthm::add1(x)
{ IF integerp(x) & ~(x < 0) THEN 1 + x
     ELSE 1 };

Function nqthm::sub1(x)
{ IF integerp(x)
     THEN IF x == 0 THEN 0
             ELIF x < 0 THEN 0
             ELSE x - 1
     ELSE 0 };

Function nqthm::negativep(x) { (integerp(x) & x < 0) | x = *minus-0* };

Function nqthm::minus(x)
{ IF integerp(x) & 0 < x THEN -x
     ELSE *minus-0* };

Function nqthm::negative-guts(x)
{ IF integerp(x) & x < 0 THEN -x
     ELSE 0 };

Function listp-escapep(x)
{    consp(x)
   & eq(car(x),*one-shell-quote-mark*)
   & consp(cdr(x))
   & eq(cadr(x),'nqthm::cons)
   & consp(cddr(x))
   & eq(caddr(x),*one-shell-quote-mark*)
   & consp(cdddr(x))
   & null(cddddr(x)) };

Function nqthm::listp(x)
{ consp(x) & ~(eq(car(x),*one-shell-quote-mark*)) | listp-escapep(x) };

Function nqthm::nlistp(x) { ~(nqthm::listp(x)) };

Function nqthm::car(x)
{ IF consp(x)
     THEN IF eq(car(x),*one-shell-quote-mark*)
             THEN IF listp-escapep(x) THEN *one-shell-quote-mark*
                     ELSE 0
             ELSE car(x)
     ELSE 0 };

Function nqthm::cdr(x)
{ IF consp(x)
     THEN IF eq(car(x),*one-shell-quote-mark*)
             THEN IF listp-escapep(x) THEN cadddr(x)
                     ELSE 0
             ELSE cdr(x)
     ELSE 0 };

Function nqthm::my-cons(x,y)
{ IF eq(x,*one-shell-quote-mark*) THEN [*one-shell-quote-mark*, 
                                        'nqthm::my-cons, 
                                        x, 
                                        y
                                        ]
     ELSE x :> y };

Function ascii-code(x) { the(integer(0,127),char-code(the(character,x))) }
 :guard characterp(x) & standard-char-p(x);

Function ascii-code-lst(lst)
{ IF endp(lst) THEN 0
     ELSE ascii-code(car(lst)) :> ascii-code-lst(cdr(lst)) }
 :guard standard-char-listp(lst)
  :hints [["Goal" :in-theory disable(member)]]
 :guard-hints[["Goal" :in-theory     '[:definition standard-char-listp]
                                  :> disable(member)]];

Function ascii-code-to-char-alist(lst)
{ IF endp(lst) THEN nil
     ELSE     (ascii-code(car(lst)) :> car(lst))
           :> ascii-code-to-char-alist(cdr(lst)) }
 :guard standard-char-listp(lst)
  :hints [["Goal" :in-theory disable(member)]]
 :guard-hints[["Goal" :in-theory     '[:definition standard-char-listp]
                                  :> disable(member)]];

Constant *ascii-code-to-char-table* = 
 Compress1('ascii-code-to-char-table, 
               [:header, 
                :dimensions, 
                '[128], 
                :maximum-length, 
                129, 
                :default, 
                nil, 
                :name, 
                'ascii-code-to-char-table
                ]
            :> ascii-code-to-char-alist(*standard-chars*)
           )
 ;

Function ascii-char-ug(n)
{ IF integerp(n) & 0 <= n & n <= 127
     THEN Aref1('ascii-code-to-char-table, *ascii-code-to-char-table*, n)
     ELSE nil };

Function ascii-char-lst(lst)
{ IF atom(lst) THEN nil
     ELSE ascii-char-ug(car(lst)) :> ascii-char-lst(cdr(lst)) };

Function nqthm-litatom-char-codep(n)
{ IF         n
      member '[36 38 42 43 45 48 49 50 51 52 53 54 55 56 57 60 61 62 63 65 66 67
              68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89
              90 94 95 123 125 126] THEN t
     ELSE nil };

Function all-nqthm-litatom-char-codep(lst)
{ IF atom(lst) THEN lst = 0
     ELSE    nqthm-litatom-char-codep(car(lst))
           & all-nqthm-litatom-char-codep(cdr(lst)) };

Function unpacked-nqthm-litatomp(lst)
{ all-nqthm-litatom-char-codep(lst) & lst ~= 0 & 65 <= car(lst) & car(lst) <= 90 };

Function litatom-escapep(x)
{    consp(x)
   & eq(car(x),*one-shell-quote-mark*)
   & consp(cdr(x))
   & eq(cadr(x),'nqthm::pack)
   & consp(cddr(x))
   & ~(unpacked-nqthm-litatomp(caddr(x)))
   & null(cdddr(x)) };

Function nqthm::litatom(x)
{ IF symbolp(x)
     THEN    eq(x,'if)
           | eq(x,'equal)
           | eq(x,'not)
           | eq(x,'implies)
           | eq(x,'iff)
           | eq(x,'quote)
           |    symbol-package-name(x) = "NQTHM"
             & standard-char-listp(coerce(symbol-name(x),'list))
             & unpacked-nqthm-litatomp(ascii-code-lst(coerce(symbol-name(x),
                                                            'list)))
     ELSE litatom-escapep(x) };

Function nqthm::unpack(x)
{ IF nqthm::litatom(x)
     THEN IF symbolp(x) THEN ascii-code-lst(coerce(symbol-name(x),'list))
             ELSE caddr(x)
     ELSE 0 }
 :guard-hints[["Goal" :in-theory disable(ascii-code)]];

Theorem nqthm-litatom-char-codep-implies-characterp
{ nqthm-litatom-char-codep(n) -> characterp(ascii-char-ug(n)) };

Theorem nqthm-litatom-char-codep-implies-standard-char-p
{ nqthm-litatom-char-codep(n) -> standard-char-p(ascii-char-ug(n)) };

Theorem nqthm-litatom-char-codep-implies-ascii-code-inverts-ascii-char-ug
{ nqthm-litatom-char-codep(n) -> ascii-code(ascii-char-ug(n)) = n };

Theorem ascii-char-ug-inverts-ascii-code
{ characterp(ch) & standard-char-p(ch) -> ascii-char-ug(ascii-code(ch)) = ch };

IN-THEORY(disable(nqthm-litatom-char-codep,ascii-char-ug,ascii-code));

Theorem all-nqthm-litatom-char-codep-implies-standard-char-listp
{ all-nqthm-litatom-char-codep(lst) -> standard-char-listp(ascii-char-lst(lst)) };

Theorem unpacked-nqthm-litatomp-implies-standard-char-listp
{ unpacked-nqthm-litatomp(lst) -> standard-char-listp(ascii-char-lst(lst)) };

Function nqthm::pack(lst)
{ IF unpacked-nqthm-litatomp(lst)
     THEN { str := coerce(ascii-char-lst(lst),'string);
            IF str = "IF" THEN 'if
               ELIF str = "EQUAL" THEN 'equal
               ELIF str = "NOT" THEN 'not
               ELIF str = "IMPLIES" THEN 'implies
               ELIF str = "IFF" THEN 'iff
               ELIF str = "QUOTE" THEN 'quote
               ELSE intern-in-package-of-symbol(str,'nqthm::pack)}
     ELSE [*one-shell-quote-mark*, 'nqthm::pack, lst] }
 :guard-hints[["[1]Goal" :in-theory enable(nqthm-litatom-char-codep)]];

Theorem all-nqthm-litatom-char-codep-implies-ascii-code-lst-inverts-ascii-char-lst
{ all-nqthm-litatom-char-codep(lst) -> ascii-code-lst(ascii-char-lst(lst)) = lst };

Theorem unpacked-nqthm-litatomp-implies-ascii-code-lst-inverts-ascii-char-lst
{ unpacked-nqthm-litatomp(lst) -> ascii-code-lst(ascii-char-lst(lst)) = lst };

Theorem ascii-char-lst-inverts-ascii-code-lst
{ standard-char-listp(lst) -> ascii-char-lst(ascii-code-lst(lst)) = lst };

Theorem ascii-char-ug-elim
{ ascii-char-ug(n) -> ascii-code(ascii-char-ug(n)) = n }
 :rule-classes :elim
 :hints [["Goal" :in-theory enable(ascii-char-ug)]];

Theorem equal-c-ascii-char-ug-implies-equal-k-n
{     characterp(c) & standard-char-p(c)
   -> c = ascii-char-ug(n) = (ascii-code(c) = n) };

Theorem symbol-name-intern-nqthm
{     stringp(s)
   ->    symbolp(intern-in-package-of-symbol(s,'nqthm::pack))
      & symbol-name(intern-in-package-of-symbol(s,'nqthm::pack)) = s
      & stringp(symbol-package-name(intern-in-package-of-symbol(s,'nqthm::pack))) }
 :hints [["Goal" :in-theory disable(symbol-name-intern-in-package-of-symbol)
                 :use [:instance symbol-name-intern-in-package-of-symbol
                                 [any-symbol := 'nqthm::pack ]]
                 ]];

Function sum-lst(lst)
{ IF atom(lst) THEN 0
     ELSE    (IF integerp(car(lst)) THEN car(lst)
                  ELSE 0)
           + sum-lst(cdr(lst)) };

Function nqthm-count-symbol(s)
{    1
   + length(symbol-name(s))
   + sum-lst(ascii-code-lst(coerce(symbol-name(s),'list))) }
 :guard nqthm::litatom(s) & symbolp(s);

Theorem nqthm-litatom-char-codep-implies-non-negative-integerp
{ nqthm-litatom-char-codep(x) -> integerp(x) & 0 < x }
 :rule-classes :compound-recognizer
 :hints [["Goal" :in-theory enable(nqthm-litatom-char-codep)]];

Function count-fn(flg,x)
{ IF eq(flg,'sum)
     THEN IF atom(x) THEN 0
             ELSE count-fn(t,car(x)) + count-fn('sum,cdr(x))
     ELIF eq(x,t) THEN 0
     ELIF eq(x,nil) THEN 0
     ELIF nqthm::numberp(x) THEN x
     ELIF nqthm::negativep(x) THEN 1 + nqthm::negative-guts(x)
     ELIF nqthm::listp(x)
     THEN 1 + count-fn(t,nqthm::car(x)) + count-fn(t,nqthm::cdr(x))
     ELIF nqthm::litatom(x)
     THEN IF symbolp(x) THEN nqthm-count-symbol(x)
             ELSE 1 + count-fn(t,nqthm::unpack(x))
     ELIF    consp(x)
           & eq(car(x),*one-shell-quote-mark*)
           & consp(cdr(x))
           & symbolp(cadr(x))
           & true-listp(cddr(x)) THEN 1 + count-fn('sum,cddr(x))
     ELSE 0 };

Theorem nqthm::numberp-compound-recognizer
{ nqthm::numberp(x) = (integerp(x) & x >= 0) }
 :rule-classes :compound-recognizer;

Theorem nqthm::numberp-type-set-inverter1
{ (nqthm::numberp(x) & x ~= 0) = (integerp(x) & 0 < x) }
 :rule-classes [[:type-set-inverter  
 :type-set 2]];

Theorem nqthm::numberp-type-set-inverter2
{ nqthm::numberp(x) = ((nqthm::numberp(x) & x ~= 0) | x = 0) }
 :rule-classes [[:type-set-inverter  
 :type-set 3]];

Theorem integerp-count-fn { integerp(count-fn(flg,x)) }
 :rule-classes :type-prescription
 :hints [["Goal" :in-theory disable(nqthm::listp,nqthm::litatom)]];

Verify guards count-fn;

Theorem sum-lst-ascii-code-lst
{ standard-char-listp(lst) -> 0 <= sum-lst(ascii-code-lst(lst)) }
 :rule-classes :linear;

Theorem sum-lst-ascii-code-lst-coerce-symbol-name
{     nqthm::litatom(x) & symbolp(x)
   -> 0 <= sum-lst(ascii-code-lst(coerce(symbol-name(x),'list))) }
 :rule-classes :linear;

Theorem non-negative-count-fn
{ integerp(count-fn(flg,x)) & 0 <= count-fn(flg,x) }
 :rule-classes :type-prescription
 :hints [["Goal" :in-theory disable(nqthm::listp,nqthm::litatom)]];

Function nqthm::count(x) { count-fn(t,x) };

Theorem len-ascii-code-lst
{ standard-char-listp(x) -> len(ascii-code-lst(x)) = len(x) };

Theorem len-plus-sum-lst-is-count-fn
{ all-nqthm-litatom-char-codep(lst) -> len(lst) + sum-lst(lst) = count-fn(t,lst) }
 :hints [["Goal" :in-theory disable(nqthm-litatom-char-codep)]];

Theorem nqthm-count-symbol-is-count-fn-unpack
{     nqthm::litatom(x) & symbolp(x)
   -> nqthm-count-symbol(x) = 1 + count-fn(t,nqthm::unpack(x)) }
 :hints [["Goal" :use [:instance len-plus-sum-lst-is-count-fn
                                 [lst := ascii-code-lst(coerce(symbol-name(x),
                                                             'list)) ]]
                 ]];

Macro nqthm::defn(fn,args,body,&rest rst) # 
list*('defun,
      fn,
      nqthm-translate-lst(args),
         (IF null(rst) THEN nil
              ELIF keywordp(car(rst)) THEN [['declare, list*('xargs,rst)]]
              ELIF null(cdr(rst)) & null(cdr(car(rst)))
              THEN [['declare, 
                     ['xargs, 
                      :well-founded-relation, 
                      car(car(car(rst))), 
                      :measure, 
                      cadr(car(car(rst)))
                      ]
                     ]
                    ]
              ELSE [['declare, 
                     ['xargs, :well-founded-relations-and-measures, rst]
                     ]
                    ])
       @ [nqthm-translate(body)]);

Mutual-Recursion {
 
 Function find-fn-applied-to-distinct-vars(term)
 { IF atom(term) THEN nil
      ELIF eq(car(term),'quote) THEN nil
      ELIF symbol-listp(cdr(term)) & no-duplicatesp(cdr(term)) THEN term
      ELSE find-fn-applied-to-distinct-vars-lst(cdr(term)) }
  :mode :program;
 
 Function find-fn-applied-to-distinct-vars-lst(lst)
 { IF endp(lst) THEN nil
      ELSE    find-fn-applied-to-distinct-vars(car(lst))
            | find-fn-applied-to-distinct-vars-lst(cdr(lst)) };
 
 };

Function probable-nqthm-type-prescriptionp1(obj,term)
{ IF atom(term) THEN nil
     ELIF eq(car(term),'quote) THEN nil
     ELIF car(term) member '[implies nqthm::and nqthm::or]
     THEN    probable-nqthm-type-prescriptionp1(obj,cadr(term))
           & probable-nqthm-type-prescriptionp1(obj,caddr(term))
     ELIF eq(car(term),'not)
     THEN probable-nqthm-type-prescriptionp1(obj,cadr(term))
     ELIF eq(car(term),'equal)
     THEN    (obj = cadr(term) & caddr(term) member cdr(obj))
           | (obj = caddr(term) & cadr(term) member cdr(obj))
           | (obj = cadr(term) & consp(caddr(term)) & null(cdr(caddr(term))))
           | obj = caddr(term) & consp(cadr(term)) & null(cdr(cadr(term)))
     ELSE null(cddr(term)) & cadr(term) = obj }
 :mode :program;

Function probable-nqthm-type-prescriptionp(term)
{ obj := find-fn-applied-to-distinct-vars(term);
  obj & probable-nqthm-type-prescriptionp1(obj,term)}
 :mode :program;

Function probable-type-set-term1(op,var,term)
{ IF atom(term) THEN nil
     ELIF eq(car(term),'quote) THEN nil
     ELIF eq(car(term),op)
     THEN    probable-type-set-term1(op,var,cadr(term))
           & probable-type-set-term1(op,var,caddr(term))
     ELIF eq(op,'nqthm::or) THEN null(cddr(term)) & cadr(term) = var
     ELSE    eq(car(term),'not)
           & null(cddr(cadr(term)))
           & cadr(cadr(term)) = var }
 :mode :program;

Function probable-type-set-term(var,term)
{    probable-type-set-term1('nqthm::or,var,term)
   | probable-type-set-term1('nqthm::and,var,term) }
 :mode :program;

Function probable-nqthm-compound-recognizerp(term)
{ CASE-MATCH term {
   [ 'implies [ 'not [& x]] ts] :  symbolp(x) & probable-type-set-term(x,ts) ;
   [ 'implies [& x] ts] :  symbolp(x) & probable-type-set-term(x,ts) ;
   [ 'equal [& x] ts] :  symbolp(x) & probable-type-set-term(x,ts) ;
   & :  nil ;
   } }
 :mode :program;

Function probable-nqthm-linearp(term)
{ CASE-MATCH term {
   [ 'nqthm::lessp & &] :  t ;
   [ 'not [ 'nqthm::lessp & &]] :  t ;
   [ 'implies & [ 'nqthm::lessp & &]] :  t ;
   [ 'implies & [ 'not [ 'nqthm::lessp & &]]] :  t ;
   & :  nil ;
   } }
 :mode :program;

Function nqthm-flatten-ands-in-lit(term)
{ IF atom(term)
     THEN IF term = *t* THEN nil
             ELSE [term]
     ELIF eq(car(term),'if)
     THEN { c1 := cadr(term);
            { c2 := caddr(term);
              { c3 := cadddr(term);
                IF c2 = *nil*
                   THEN    nqthm-flatten-ands-in-lit(IF    consp(c1)
                                                         & eq(car(c1),
                                                             'not)
                                                        THEN cadr(c1)
                                                        ELSE ['not, 
                                                              c1
                                                              ])
                         @ nqthm-flatten-ands-in-lit(c3)
                   ELIF c3 = *nil*
                   THEN    nqthm-flatten-ands-in-lit(c1)
                         @ nqthm-flatten-ands-in-lit(c2)
                   ELSE [term]}}}
     ELIF eq(car(term),'nqthm::and)
     THEN    nqthm-flatten-ands-in-lit(cadr(term))
           @ nqthm-flatten-ands-in-lit(caddr(term))
     ELSE [term] }
 :mode :program;

Function nqthm-unprettyify1(hyps,pairs)
{ IF null(pairs) THEN nil
     ELSE     ((hyps @ caar(pairs)) :> cdar(pairs))
           :> nqthm-unprettyify1(hyps,cdr(pairs)) }
 :mode :program;

Function make-rewrite-corollaries(pairs)
{ IF null(pairs) THEN nil
     ELSE     [:rewrite, 
               :corollary, 
               { hyps := caar(pairs);
                 { concl := cdar(pairs);
                   IF null(hyps) THEN concl
                      ELIF null(cdr(hyps))
                      THEN ['implies, car(hyps), concl]
                      ELSE ['implies, 
                            'and :> hyps, 
                            concl
                            ]}}
               ]
           :> make-rewrite-corollaries(cdr(pairs)) }
 :mode :program;

Function nqthm-to-acl2-rule-classes(term,lst)
{ IF atom(lst) THEN nil
     ELIF eq(car(lst),'nqthm::rewrite)
     THEN    (IF probable-nqthm-type-prescriptionp(term)
                  THEN '[:type-prescription]
                  ELIF probable-nqthm-compound-recognizerp(term)
                  THEN '[:compound-recognizer]
                  ELIF probable-nqthm-linearp(term) THEN '[:linear]
                  ELSE make-rewrite-corollaries(nqthm-unprettyify(term)))
           @ nqthm-to-acl2-rule-classes(term,cdr(lst))
     ELIF eq(car(lst),'nqthm::elim)
     THEN :elim :> nqthm-to-acl2-rule-classes(term,cdr(lst))
     ELIF eq(car(lst),'nqthm::generalize)
     THEN :generalize :> nqthm-to-acl2-rule-classes(term,cdr(lst))
     ELIF consp(car(lst)) & eq(caar(lst),'nqthm::meta)
     THEN (:meta :> cdr(car(lst))) :> nqthm-to-acl2-rule-classes(term,cdr(lst))
     ELSE car(lst) :> nqthm-to-acl2-rule-classes(term,cdr(lst)) }
 :mode :program;

Macro nqthm::prove-lemma(name,rule-classes,term,&rest rst) # 
{ term := nqthm-translate(term);
  list*('defthm,
        name,
        term,
        :rule-classes,
        nqthm-to-acl2-rule-classes(term,rule-classes),
        rst)};

Macro nqthm::add-axiom(name,rule-classes,term) # 
{ term := nqthm-translate(term);
  ['defaxiom, 
   name, 
   term, 
   :rule-classes, 
   nqthm-to-acl2-rule-classes(term,rule-classes)
   ]};

Macro nqthm::disable(&rest rst) = 
IN-THEORY(disable(rst));

Macro nqthm::enable(&rest rst) = 
IN-THEORY(enable(rst));

Function type-restriction-term1(tp,x)
{ IF null(tp) THEN nil
     ELSE [car(tp), x] :> type-restriction-term1(cdr(tp),x) }
 :mode :program;

Function type-restriction-term(tp,x)
{ IF eq(car(tp),'nqthm::one-of)
     THEN IF null(cdr(tp)) THEN nil
             ELIF null(cddr(tp)) THEN car(type-restriction-term1(cdr(tp),x))
             ELSE 'nqthm::or :> type-restriction-term1(cdr(tp),x)
     ELIF null(cdr(tp)) THEN t
     ELIF null(cddr(tp)) THEN ['not, car(type-restriction-term1(cdr(tp),x))]
     ELSE ['not, 'nqthm::or :> type-restriction-term1(cdr(tp),x)] }
 :mode :program;

Function add-shell-const1(tuples)
{ IF null(tuples) THEN nil
     ELSE { var := car(car(tuples));
            tr := type-restriction-term(cadr(car(tuples)),var);
            dv := [caddr(car(tuples))];
                (IF eq(tr,t) THEN var
                     ELSE ['if, tr, var, dv])
             :> add-shell-const1(cdr(tuples))} }
 :mode :program;

Function add-shell-destructor-defuns(btm,recog,tuples,cdr-term)
{ IF null(tuples) THEN nil
     ELSE { dest := car(car(tuples));
            { dv := [caddr(car(tuples))];
                  ['defun, 
                   dest, 
                   '[x], 
                   ['if, 
                    IF btm
                       THEN ['and, 
                             [recog, 'x], 
                             ['not, 
                              ['equal, 
                               '[cadr x], 
                               ['quote, [btm]]
                               ]
                              ]
                             ]
                       ELSE [recog, 'x], 
                    ['car, cdr-term], 
                    dv
                    ]
                   ]
               :> add-shell-destructor-defuns(btm,
                                             recog,
                                             cdr(tuples),
                                             ['cdr, 
                                              cdr-term
                                              ])}} }
 :mode :program;

Function type-restriction-terms(tuples,x)
{ IF null(tuples) THEN nil
     ELSE     type-restriction-term(cadr(car(tuples)),['car, x])
           :> type-restriction-terms(cdr(tuples),['cdr, x]) }
 :mode :program;

Function add-shell-routines(const,btm,recog,tuples)
{    (IF null(btm) THEN nil
          ELSE [['defun, 
                 btm, 
                 nil, 
                 ['list, '*oneshell-quote-mark*, ['quote, [btm]]]
                 ]])
   @ list*(['defun, 
           recog, 
           '[x], 
           '[declare
             [xargs :well-founded-relation e0-ord-< :measure [acl2-count x]]], 
           ['and, 
            '[consp x], 
            '[eq [car x] *one-shell-quote-mark*], 
            '[true-listp [cdr x]], 
            IF btm
               THEN ['if, 
                     ['equal, '[cadr x], ['quote, [btm]]], 
                     '[null [cddr x]], 
                     list*('and,
                           ['eq, '[cadr x], ['quote, const]],
                           ['=, '[length [cddr x]], length(tuples)],
                           type-restriction-terms(tuples,'[cddr x]))
                     ]
               ELSE list*('and,
                          ['eq, '[cadr x], ['quote, const]],
                          ['=, '[length [cddr x]], length(tuples)],
                          type-restriction-terms(tuples,'[cddr x]))
            ]
           ],
          ['defun, 
           const, 
           strip-cars(tuples), 
           list*('list,
                 '*one-shell-quote-mark*,
                 ['quote, const],
                 add-shell-const1(tuples))
           ],
          add-shell-destructor-defuns(btm,recog,tuples,'[cddr x])) }
 :mode :program;

Function packnqthm(lst)
{ intern-in-package-of-symbol(coerce(packn1(lst),'string),'nqthm::pack) }
 :mode :program;

Function add-type-set-lemmas-destructors(tuples)
{ IF null(tuples) THEN nil
     ELSE { dest := car(car(tuples));
            { tp := cadr(car(tuples));
              IF length(tp) == 2
                 THEN     ['defthm, 
                           packnqthm([dest, "-TYPE"]), 
                           type-restriction-term(tp,
                                                 [dest, 
                                                  'nqthm::x
                                                  ])
                           ]
                       :> add-type-set-lemmas-destructors(cdr(tuples))
                 ELIF       tp
                          = '[nqthm::one-of nqthm::truep
                             nqthm::falsep]
                       |    tp
                         = '[nqthm::one-of nqthm::falsep
                            nqthm::truep]
                 THEN     list*('defthm,
                                packnqthm([dest, "-TYPE"]),
                                ['booleanp, [dest, 'nqthm::x]],
                                '[:rule-classes
                                  :type-prescription])
                       :> add-type-set-lemmas-destructors(cdr(tuples))
                 ELSE add-type-set-lemmas-destructors(cdr(tuples))}} }
 :mode :program;

Function add-type-set-lemmas-for-imperfect-recognizers1(past-imperfect-recognizers,
                                                        recog)
{ IF null(past-imperfect-recognizers) THEN nil
     ELSE     ['defthm, 
               packnqthm([recog, "-V-", car(past-imperfect-recognizers), "!"]), 
               ['and, 
                ['implies, 
                 [recog, 'nqthm::x], 
                 ['not, [car(past-imperfect-recognizers), 'nqthm::x]]
                 ], 
                ['implies, 
                 [car(past-imperfect-recognizers), 'nqthm::x], 
                 ['not, [recog, 'nqthm::x]]
                 ]
                ], 
               :hints, 
               [["Goal", 
                 :in-theory, 
                 ['enable, car(past-imperfect-recognizers)]
                 ]
                ]
               ]
           :> add-type-set-lemmas-for-imperfect-recognizers1(cdr(past-imperfect-recognizers),
                                                            recog) }
 :mode :program;

Function add-type-set-lemmas-for-imperfect-recognizers(past-imperfect-recognizers,
                                                       recog)
{ list*(list*('defthm,
              packnqthm([recog, "-COMPOUND-RECOGNIZER!"]),
              ['implies, [recog, 'nqthm::x], '[consp nqthm::x]],
              '[:rule-classes :compound-recognizer]),
        add-type-set-lemmas-for-imperfect-recognizers1(past-imperfect-recognizers,
                                                       recog)) }
 :mode :program;

Function add-type-set-lemmas(const,recog,tuples,past-imperfect-recognizers)
{    add-type-set-lemmas-for-imperfect-recognizers(past-imperfect-recognizers,
                                                   recog)
   @ list*(['defthm, 
           packnqthm([recog, "-", const, "!"]), 
           [recog, list*(const,strip-cars(tuples))]
           ],
          add-type-set-lemmas-destructors(tuples)) }
 :mode :program;

Function add-destructor-lemmas(const,btm,recog,tuples,shell-expr)
{ IF null(tuples) THEN nil
     ELSE { dest := car(car(tuples));
            tr := type-restriction-term(cadr(car(tuples)),dest);
            dv := [caddr(car(tuples))];
               list*(['defthm, 
                      packnqthm([dest, "-", const]), 
                      ['equal, 
                       [dest, shell-expr], 
                       IF eq(tr,t) THEN dest
                          ELSE ['if, tr, dest, dv]
                       ]
                      ],
                     ['defthm, 
                      packnqthm([dest, "-N", recog]), 
                      ['implies, 
                       ['not, [recog, 'nqthm::x]], 
                       ['equal, [dest, 'nqthm::x], dv]
                       ]
                      ],
                        (IF ~(eq(tr,t))
                             THEN [['defthm, 
                                    packnqthm([dest, 
                                               "-TYPE-RESTRICTION"
                                               ]), 
                                    ['implies, 
                                     ['not, tr], 
                                     ['equal, 
                                      shell-expr, 
                                      subst(dv,dest,shell-expr)
                                      ]
                                     ]
                                    ]
                                   ]
                             ELSE nil)
                      @ [list*('defthm,
                              packnqthm([dest, "-LESSP"]),
                              ['implies, 
                               IF btm
                                  THEN ['and, 
                                        [recog, 'nqthm::x], 
                                        ['not, 
                                         ['equal, 'nqthm::x, [btm]]
                                         ]
                                        ]
                                  ELSE [recog, 'nqthm::x], 
                               ['nqthm::lessp, 
                                ['nqthm::count, [dest, 'nqthm::x]], 
                                '[nqthm::count nqthm::x]
                                ]
                               ],
                              '[:rule-classes
                                [:rewrite :built-in-clause :linear]
                                :hints
                                [["Goal" :in-theory
                                  [enable nqthm::count nqthm::fix
                                   lessp-is- <]]]]), 
                        list*('defthm,
                              packnqthm([dest, "-LESSEQP"]),
                              ['not, 
                               ['nqthm::lessp, 
                                '[nqthm::count nqthm::x], 
                                ['nqthm::count, [dest, 'nqthm::x]]
                                ]
                               ],
                              '[:rule-classes
                                [:rewrite :linear]
                                :hints
                                [["Goal" :in-theory
                                  [enable nqthm::count nqthm::fix
                                   lessp-is- <]]]])
                        ])
             @ add-destructor-lemmas(const,
                                    btm,
                                    recog,
                                    cdr(tuples),
                                    shell-expr)} }
 :mode :program;

Function packnqthm-lst(lst,str)
{ IF null(lst) THEN nil
     ELSE packnqthm([car(lst), str]) :> packnqthm-lst(cdr(lst),str) }
 :mode :program;

Function add-shell-const-equal1(tuples)
{ IF null(tuples) THEN nil
     ELSE { var1 := car(car(tuples));
            var2 := packnqthm([var1, "-"]);
            tr1 := type-restriction-term(cadr(car(tuples)),var1);
            tr2 := type-restriction-term(cadr(car(tuples)),var2);
            dv := [caddr(car(tuples))];
                (IF tr1 = t THEN ['equal, var1, var2]
                     ELSE ['if, 
                           tr1, 
                           ['if, 
                            tr2, 
                            ['equal, var1, var2], 
                            ['equal, var1, dv]
                            ], 
                           ['if, tr2, ['equal, dv, var2], t]
                           ])
             :> add-shell-const-equal1(cdr(tuples))} }
 :mode :program;

Function interpose(x,lst)
{ IF null(lst) THEN nil
     ELSE x :> car(lst) :> interpose(x,cdr(lst)) }
 :mode :program;

Function plusjoin(lst)
{ IF null(lst) THEN 0
     ELIF null(cdr(lst)) THEN car(lst)
     ELSE ['nqthm::plus, car(lst), plusjoin(cdr(lst))] }
 :mode :program;

Function count-destructor-tuples(tuples)
{ IF null(tuples) THEN nil
     ELSE { var := car(car(tuples));
            tr := type-restriction-term(cadr(car(tuples)),var);
                (IF eq(tr,t) THEN ['nqthm::count, var]
                     ELSE ['if, tr, ['nqthm::count, var], 0])
             :> count-destructor-tuples(cdr(tuples))} }
 :mode :program;

Function past-user-defined-recognizers(prev-event)
{ IF null(prev-event) | eq(prev-event,'nqthm::nil) THEN nil
     ELSE     cadddr(prev-event)
           :> past-user-defined-recognizers(cadr(cddddr(prev-event))) }
 :mode :program;

Function add-shell0(const,btm,recog,tuples,prev-event)
{ list*('encapsulate,
        nil,
           add-shell-routines(const,btm,recog,tuples)
         @ add-type-set-lemmas(const,
                              recog,
                              tuples,
                                 '[nqthm::listp nqthm::litatom]
                               @ past-user-defined-recognizers(prev-event))
         @ add-destructor-lemmas(const,
                                btm,
                                recog,
                                tuples,
                                list*(const,strip-cars(tuples)))
         @ list*(['defthm, 
                 packnqthm([const, "-EQUAL"]), 
                 ['equal, 
                  ['equal, 
                   list*(const,strip-cars(tuples)), 
                   list*(const,packnqthm-lst(strip-cars(tuples),"-"))
                   ], 
                  conjoin(add-shell-const-equal1(tuples))
                  ]
                 ],
                '[local
                  [defthm equal-rearraanger
                   [implies
                    [and
                     [syntaxp [and [quotep i] [quotep j]]]
                     [rationalp i]
                     [rationalp j]
                     [rationalp x]]
                    [equal [equal [+ i x] j] [equal x [- j i]]]]]],
                '[local
                  [defthm equal-len-0 [equal [equal [len x] 0] [atom x]]]],
                ['defthm, 
                 packnqthm(const :> interpose("-",strip-cars(tuples))), 
                 ['equal, 
                  list*(const,pairlis-x2(strip-cars(tuples),'[nqthm::x])), 
                  ['if, 
                   IF btm
                      THEN ['nqthm::and, 
                            [recog, 'nqthm::x], 
                            ['not, ['equal, 'nqthm::x, [btm]]]
                            ]
                      ELSE [recog, 'nqthm::x], 
                   'nqthm::x, 
                   list*(const,pairlis-x2(strip-caddrs(tuples),nil))
                   ]
                  ]
                 ],
                list*('defthm,
                      packnqthm(    const
                                 :> (   interpose("-",strip-cars(tuples))
                                      @ '["-ELIM"])),
                      ['implies, 
                       IF btm
                          THEN ['nqthm::and, 
                                [recog, 'nqthm::x], 
                                ['not, ['equal, 'nqthm::x, [btm]]]
                                ]
                          ELSE [recog, 'nqthm::x], 
                       ['equal, 
                        list*(const,pairlis-x2(strip-cars(tuples),'[nqthm::x])), 
                        'nqthm::x
                        ]
                       ],
                      '[:rule-classes :elim :otf-flg t]),
                list*('defthm,
                      packnqthm(["COUNT-", const]),
                      ['equal, 
                       ['nqthm::count, list*(const,strip-cars(tuples))], 
                       ['nqthm::add1, plusjoin(count-destructor-tuples(tuples))]
                       ],
                      '[:hints
                        [["Goal" :in-theory
                          [enable nqthm::count nqthm::add1 plus-is- +]]]]),
                   (IF null(tuples) & btm
                        THEN [['defthm, 
                               packnqthm([recog, "-ELIMINATOR"]), 
                               ['equal, 
                                [recog, 'nqthm::x], 
                                ['nqthm::or, 
                                 ['equal, 'nqthm::x, [btm]], 
                                 ['equal, 'nqthm::x, [const]]
                                 ]
                                ]
                               ]
                              ]
                        ELSE nil)
                 @ [['in-theory, 
                    list*('disable,
                          const,
                             (IF btm THEN [btm]
                                  ELSE nil)
                           @ list*(recog,strip-cars(tuples)))
                    ]
                   ])) }
 :mode :program;

Function acceptable-add-shellp1(tuples)
{ IF atom(tuples) THEN eq(tuples,nil)
     ELIF true-listp(car(tuples)) & length(car(tuples)) = 3
     THEN { dest := car(car(tuples));
            { tr := cadr(car(tuples));
              { df := caddr(car(tuples));
                   symbolp(dest)
                 & consp(tr)
                 &         car(tr)
                   member '[nqthm::one-of nqthm::none-of]
                 & symbol-listp(cdr(tr))
                 & symbolp(df)
                 & acceptable-add-shellp1(cdr(tuples))}}}
     ELSE nil }
 :mode :program;

Function acceptable-add-shellp(const,btm,recog,tuples,prev-event)
{    symbolp(const)
   & symbolp(btm)
   & symbolp(recog)
   & acceptable-add-shellp1(tuples)
   &    null(prev-event)
     | eq(prev-event,'nqthm::nil)
     |    true-listp(prev-event)
       & length(prev-event) == 6
       & eq(car(prev-event),'nqthm::add-shell)
       & acceptable-add-shellp(cadr(prev-event),
                              caddr(prev-event),
                              cadddr(prev-event),
                              car(cddddr(prev-event)),
                              cadr(cddddr(prev-event))) }
 :mode :program;

Macro nqthm::add-shell(const,btm,recog,tuples,prev-event) # 
IF acceptable-add-shellp(const,btm,recog,tuples,prev-event)
   THEN add-shell0(const,
                   IF btm = 'nqthm::nil THEN nil
                      ELSE btm,
                   recog,
                   tuples,
                   prev-event)
   ELSE '[illegal 'add-shell "Bad shell" nil];

Macro nqthm::thm(&rest x) # 
list*('thm,nqthm-translate(car(x)),cdr(x));

Macro nqthm::in-package(&rest x) = 
in-package(x);

Function constrain-alistp(x)
{ IF atom(x) THEN x = nil
     ELIF    consp(car(x))
           & symbolp(caar(x))
           & consp(cdar(x))
           & null(cddar(x))
           & consp(cadar(x))
           & true-listp(cadar(x))
           & eq(car(cadar(x)),'nqthm::lambda)
           & true-listp(cadr(cadar(x))) THEN constrain-alistp(cdr(x))
     ELSE illegal('constrain,
                  "The alist arg of Nqthm's CONSTRAIN must pair symbols with ~
                     LAMBDA expressions so Acl2 can recover the arity of each ~
                     constrained function.",
                  car(x)) }
 :mode :program;

Function constrain-sigs(alist)
{ IF null(alist) THEN nil
     ELSE     [car(car(alist)), cadr(cadr(car(alist))), t]
           :> constrain-sigs(cdr(alist)) }
 :mode :program;

Function constrain-witnesses(alist)
{ IF null(alist) THEN nil
     ELSE     { formals := nqthm-translate-lst(cadr(cadr(car(alist))));
                 { body := nqthm-translate(caddr(cadr(car(alist))));
                   ['local, 
                    ['defun, 
                     car(car(alist)), 
                     formals, 
                     ['declare, 
                      list*('ignore,
                            set-difference-eq(formals,
                                              all-vars(body)))
                      ], 
                     body
                     ]
                    ]}}
           :> constrain-witnesses(cdr(alist)) }
 :mode :program;

Macro nqthm::constrain(name,rule-classes,term,alist,&rest rst) # 
list*('encapsulate,
      constrain-sigs(alist),
         constrain-witnesses(alist)
       @ [{ term := nqthm-translate(term);
           list*('defthm,
                 name,
                 term,
                 :rule-classes,
                 nqthm-to-acl2-rule-classes(term,rule-classes),
                 rst)}
         ])
 :guard constrain-alistp(alist);

Macro nqthm::note-lib(name,&optional compile-flg) # 
['include-book, 
 name, 
 IF null(compile-flg) | eq(compile-flg,'nqthm::nil) THEN nil
    ELSE t
 ];


