

Include("/usr/cli/projects/cacl2/version13/infix-prelude");

in-package("acl2");

Module 
{equiv(x,y) : t;
 pred(x) : t;
 op(x,y) : t;} 
{ 
  local Function equiv(x,y) { x = y };
  
  local Function pred(x) { x = t | x = nil }
   :verify-guards t;
  
  local Function op(x,y) { (x | y) & ~(x & y) }
   :guard pred(x) & pred(y);
  
  Theorem equiv-is-an-equivalence
  {    booleanp(equiv(x,y))
     & equiv(x,x)
     & (equiv(x,y) -> equiv(y,x))
     & (equiv(x,y) & equiv(y,z) -> equiv(x,z)) }
   :rule-classes :equivalence;
  
  Theorem equiv-2-implies-equiv-op
  { equiv(y1,y2) -> equiv(op(x,y1),op(x,y2)) }
   :rule-classes :congruence;
  
  Theorem closure-of-op-for-pred { pred(x) & pred(y) -> pred(op(x,y)) };
  
  Theorem associativity-of-op
  { pred(x) & pred(y) & pred(z) -> equiv(op(op(x,y),z),op(x,op(y,z))) };
  
  Theorem commutativity-of-op
  { pred(x) & pred(y) -> equiv(op(x,y),op(y,x)) };
  
   };


