

Include("/usr/cli/projects/cacl2/version13/infix-prelude");

in-package("ACL2");

Include("bdd-primitives");

Function full-adder(c,a,b)
{ [b-xor3(c,a,b), b-or(b-and(a,b),b-or(b-and(a,c),b-and(b,c)))] };

Function v-inc(x)
{ IF nlistp(x) THEN nil
     ELIF car(x) = nil THEN t :> cdr(x)
     ELSE nil :> v-inc(cdr(x)) };

Theorem len-v-inc { len(v-inc(x)) = len(x) };

Theorem bvp-v-inc { bvp(x) -> bvp(v-inc(x)) };

Theorem v-if-is-if
{     bv2p(x,y)
   ->    v-if(a,x,y)
      = (IF a THEN x
            ELSE y) };

Module { }
{ 
  local Theorem hack { hide(v-inc(x)) = v-inc(x) }
   :hints [["Goal" :expand hide(v-inc(x))]];
  
  Theorem v-inc-cons
  { x := a :> y;
       v-inc(x)
     = IF* bvp(y) THEN b-not(a) :> v-if(a,v-inc(y),y)
         ELSE hide(v-inc(x))}
   :hints [["Goal" :use [[:instance hack
                                    [x := a :> y ]][:instance hack
                                                              [x := nil :> y ]][:instance hack
                                                                                          [x :=     t
                                                                                                 :> y ]]]]];
  
   };

Function v-logcount(input,acc)
{ IF nlistp(input) THEN acc
     ELSE v-logcount(cdr(input),v-if(car(input),v-inc(acc),acc)) };

Theorem v-logcount-nil { v-logcount(nil,acc) = acc };

Theorem v-logcount-cons
{ v-logcount(a :> x,acc) = v-logcount(x,v-if(a,v-inc(acc),acc)) };

Function hamming(input)
{ s0-15 := firstn(16,input);
  s16-19 := restn(16,input);
  v0 := s0-15[0];
  v1 := s0-15[1];
  v2 := s0-15[2];
  v3 := s0-15[3];
  v4 := s0-15[4];
  v5 := s0-15[5];
  v6 := s0-15[6];
  v7 := s0-15[7];
  v8 := s0-15[8];
  v9 := s0-15[9];
  v10 := s0-15[10];
  v11 := s0-15[11];
  v12 := s0-15[12];
  v13 := s0-15[13];
  v14 := s0-15[14];
  v15 := s0-15[15];
  v16 := s16-19[0];
  v17 := s16-19[1];
  v18 := s16-19[2];
  v19 := s16-19[3];
  m11 := full-adder(nil,v18,v19);
  m11o := m11[0];
  m11c := m11[1];
  m12 := full-adder(v15,v16,v17);
  m12o := m12[0];
  m12c := m12[1];
  m13 := full-adder(v12,v13,v14);
  m13o := m13[0];
  m13c := m13[1];
  m14 := full-adder(v9,v10,v11);
  m14o := m14[0];
  m14c := m14[1];
  m15 := full-adder(v6,v7,v8);
  m15o := m15[0];
  m15c := m15[1];
  m16 := full-adder(v3,v4,v5);
  m16o := m16[0];
  m16c := m16[1];
  m17 := full-adder(v0,v1,v2);
  m17o := m17[0];
  m17c := m17[1];
  m7 := full-adder(m13o,m12o,m11o);
  m7o := m7[0];
  m7c := m7[1];
  m8 := full-adder(m13c,m12c,m11c);
  m8o := m8[0];
  m8c := m8[1];
  m9 := full-adder(m16o,m15o,m14o);
  m9o := m9[0];
  m9c := m9[1];
  m10 := full-adder(m16c,m15c,m14c);
  m10o := m10[0];
  m10c := m10[1];
  m6 := full-adder(m17c,m9c,m7c);
  m6o := m6[0];
  m6c := m6[1];
  m4 := full-adder(m6o,m10o,m8o);
  m4o := m4[0];
  m4c := m4[1];
  m5 := full-adder(m10c,m8c,m6c);
  m5o := m5[0];
  m5c := m5[1];
  m0 := full-adder(m17o,m7o,m9o);
  m0o := m0[0];
  m0c := m0[1];
  m1 := full-adder(m0c,nil,m4o);
  m1o := m1[0];
  m1c := m1[1];
  m2 := full-adder(m1c,m4c,m5o);
  m2o := m2[0];
  m2c := m2[1];
  m3 := full-adder(m2c,m5c,nil);
  m3o := m3[0];
  m3c := m3[1];
  [m0o, m1o, m2o, m3o, m3c]};

Theorem hamming-correct
{ input := [i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i13, i14, i15, i16, i17, i18, i19];
  bvp(input) -> hamming(input) = v-logcount(input,make-nils(5))}
 :hints [["Goal" :bdd [:vars := t
                 ]]];

Theorem hamming-correct-vars-reversed
{ input := [i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i13, i14, i15, i16, i17, i18, i19];
  bvp(input) -> hamming(input) = v-logcount(input,make-nils(5))}
 :hints [["Goal" :bdd [:vars := [i19, 
                                 i18, 
                                 i17, 
                                 i16, 
                                 i15, 
                                 i14, 
                                 i13, 
                                 i12, 
                                 i11, 
                                 i10, 
                                 i9, 
                                 i8, 
                                 i7, 
                                 i6, 
                                 i5, 
                                 i4, 
                                 i3, 
                                 i2, 
                                 i1, 
                                 i0]
                 ]]];

Theorem hamming-correct-v-20-bit-logcount
{ input := [i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i13, i14, i15, i16, i17, i18, i19];
      bvp(input)
   -> hamming(input) = v-trunc(v-logcount(input,make-nils(20)),5)}
 :hints [["Goal" :bdd [:vars := t
                 ]]];

Theorem hamming-correct-v-20-bit-logcount-vars-reversed
{ input := [i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i13, i14, i15, i16, i17, i18, i19];
      bvp(input)
   -> hamming(input) = v-trunc(v-logcount(input,make-nils(20)),5)}
 :hints [["Goal" :bdd [:vars := [i19, 
                                 i18, 
                                 i17, 
                                 i16, 
                                 i15, 
                                 i14, 
                                 i13, 
                                 i12, 
                                 i11, 
                                 i10, 
                                 i9, 
                                 i8, 
                                 i7, 
                                 i6, 
                                 i5, 
                                 i4, 
                                 i3, 
                                 i2, 
                                 i1, 
                                 i0]
                 ]]];

Thm 
{ input := [i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i13, i14, i15, i16, i17, i18, i19];
  bvp(input) -> hamming(input) = v-logcount(cddr(input),make-nils(5))}
 :hints [["Goal" :bdd [:vars := t
                 ]]];


