

Include("/usr/cli/projects/cacl2/version13/infix-prelude");

in-package("ACL2");

Include("term-lemmas");

Module 
{binop(x,y) : t;
 binop-fix(x) : t;
 binop-rel(x,y) : t;
 binop-id() : t;} 
{ 
  local Function binop(x,y) { x + y };
  
  local Function binop-fix(x) { fix(x) };
  
  local Function binop-rel(x,y) { x = y };
  
  local Function binop-id() { 0 };
  
  Theorem commutativity-of-binop { binop(x,y) = binop(y,x) };
  
  Theorem commutativity2-of-binop
  { binop(x,binop(y,z)) = binop(y,binop(x,z)) };
  
  Theorem associativity-of-binop
  { binop(binop(x,y),z) = binop(x,binop(y,z)) };
  
  Theorem binop-fix-binop { binop-fix(binop(x,y)) = binop(x,y) };
  
  Theorem binop-cancel-binop-rel
  { binop-rel(binop(x,y),binop(x,z)) = binop-rel(binop-fix(y),binop-fix(z)) };
  
  Theorem binop-binop-id { binop(binop-id(),x) = binop-fix(x) };
  
  Theorem binop-fix-binop-id { binop-fix(binop-id()) = binop-id() };
  
   };

Module 
{ev1(x,a) : t;
 ev1-list(x-lst,a) : t;
 binop-name() : t;
 binop-fix-name() : t;
 binop-rel-name() : t;} 
{ 
  set-inhibit-warnings("theory");
  
  local IN-THEORY(*defevaluator-form-base-theory*);
  
  local Function binop-name() { 'binop };
  
  local Function binop-fix-name() { 'binop-fix };
  
  local Function binop-rel-name() { 'binop-rel };
  
  Theorem symbolp-binop-name
  { symbolp(binop-name()) & binop-name() ~= t & binop-name() ~= nil }
   :rule-classes :type-prescription;
  
  Theorem symbolp-binop-fix-name
  { symbolp(binop-fix-name()) & binop-fix-name() ~= t & binop-fix-name() ~= nil }
   :rule-classes :type-prescription;
  
  Theorem symbolp-binop-rel-name
  { symbolp(binop-rel-name()) & binop-rel-name() ~= t & binop-rel-name() ~= nil }
   :rule-classes :type-prescription;
  
  Theorem binop-name-not-quote { binop-name() ~= 'quote };
  
  Theorem binop-rel-name-not-quote { binop-rel-name() ~= 'quote };
  
  Theorem binop-fix-name-not-quote { binop-fix-name() ~= 'quote };
  
  local Mutual-Recursion {
   
   Function ev1(x,a)
   { IF symbolp(x) THEN cdr(assoc-eq(x,a))
        ELIF eq(car(x),'quote) THEN car(cdr(x))
        ELIF consp(car(x))
        THEN ev1(car(cdr(cdr(car(x)))),
                 pairlis$(car(cdr(car(x))),ev1-list(cdr(x),a)))
        ELIF car(x) = binop-name()
        THEN binop(ev1(car(cdr(x)),a),ev1(car(cdr(cdr(x))),a))
        ELIF car(x) = binop-fix-name() THEN binop-fix(ev1(car(cdr(x)),a))
        ELIF car(x) = binop-rel-name()
        THEN binop-rel(ev1(car(cdr(x)),a),ev1(car(cdr(cdr(x))),a))
        ELIF car(x) = 'if
        THEN IF ev1(car(cdr(x)),a) THEN ev1(car(cdr(cdr(x))),a)
                ELSE ev1(car(cdr(cdr(cdr(x)))),a)
        ELSE nil }
    :measure acl2-count(x)
    :mode :logic
    :well-founded-relation e0-ord-<;
   
   Function ev1-list(x-lst,a)
   { IF endp(x-lst) THEN nil
        ELSE ev1(car(x-lst),a) :> ev1-list(cdr(x-lst),a) }
    :measure acl2-count(x-lst)
    :well-founded-relation e0-ord-<;
   
   };
  
  Theorem ev1-constraint-1
  { symbolp(x) -> ev1(x,a) = cdr(assoc-eq(x,a)) };
  
  Theorem ev1-constraint-2
  { consp(x) & car(x) = 'quote -> ev1(x,a) = cadr(x) };
  
  Theorem ev1-constraint-3
  {     consp(x) & consp(car(x))
     -> ev1(x,a) = ev1(caddar(x),pairlis$(cadar(x),ev1-list(cdr(x),a))) };
  
  Theorem ev1-constraint-4 { ~(consp(x-lst)) -> ev1-list(x-lst,a) = nil };
  
  Theorem ev1-constraint-5
  {     consp(x-lst)
     -> ev1-list(x-lst,a) = ev1(car(x-lst),a) :> ev1-list(cdr(x-lst),a) };
  
  Theorem ev1-constraint-6
  {     consp(x) & car(x) = binop-name()
     -> ev1(x,a) = binop(ev1(cadr(x),a),ev1(caddr(x),a)) };
  
  Theorem ev1-constraint-7
  { consp(x) & car(x) = binop-fix-name() -> ev1(x,a) = binop-fix(ev1(cadr(x),a)) };
  
  Theorem ev1-constraint-8
  {     consp(x) & car(x) = binop-rel-name()
     -> ev1(x,a) = binop-rel(ev1(cadr(x),a),ev1(caddr(x),a)) };
  
  Theorem ev1-constraint-9
  {     consp(x) & car(x) = 'if
     ->    ev1(x,a)
        = (IF ev1(cadr(x),a) THEN ev1(caddr(x),a)
              ELSE ev1(cadddr(x),a)) };
  
   };

Module 
{cancel_binop-rel$1(x) : t;} 
{ 
  local Function cancel_binop-rel$1(x) { x };
  
  Theorem cancel_binop-rel$1-property
  {     consp(x) & eq(car(x),binop-rel-name())
     -> ev1(cancel_binop-rel$1(x),a) = ev1(x,a) };
  
   };

Function cancel_binop-rel(x)
{ IF consp(x) & eq(car(x),binop-rel-name())
     THEN IF    consp(cadr(x))
              & eq(car(cadr(x)),binop-name())
              & consp(caddr(x))
              & eq(car(caddr(x)),binop-name())
             THEN { lt-side := binary-op_fringe(binop-name(),cadr(x));
                    rt-side := binary-op_fringe(binop-name(),caddr(x));
                    int := bagint(lt-side,rt-side);
                    IF int
                       THEN [binop-rel-name(), 
                             binary-op_tree(binop-name(),
                                            binop-id(),
                                            binop-fix-name(),
                                            bagdiff(lt-side,int)), 
                             binary-op_tree(binop-name(),
                                            binop-id(),
                                            binop-fix-name(),
                                            bagdiff(rt-side,int))
                             ]
                       ELSE x}
             ELSE cancel_binop-rel$1(x)
     ELSE x };


skip-proofs { 
 
 Theorem cancel_binop-rel-correct-lemma
 {    binop-rel(ev1(binary-op_tree(binop-name(),
                                   binop-id(),
                                   binop-fix-name(),
                                   bagdiff(binary-op_fringe(binop-name(),x1),
                                           bagint(binary-op_fringe(binop-name(),
                                                                   x1),
                                                  binary-op_fringe(binop-name(),
                                                                   x2)))),
                    a),
                ev1(binary-op_tree(binop-name(),
                                   binop-id(),
                                   binop-fix-name(),
                                   bagdiff(binary-op_fringe(binop-name(),x2),
                                           bagint(binary-op_fringe(binop-name(),
                                                                   x1),
                                                  binary-op_fringe(binop-name(),
                                                                   x2)))),
                    a))
    = binop-rel(binop-fix(ev1(x1,a)),binop-fix(ev1(x2,a))) };
 
  };


Theorem cancel_binop-rel-correct
{ ev1(x,a) = ev1(cancel_binop-rel(x),a) };


