
/* Here are the meta rules which cancel like terms from two +-terms   when the two +-terms are the operands to the binary relations EQUAL   or <.   Also, here is a meta rule which cancels like terms from two *-terms   when they are operands to EQUAL.   Original rule (for +-terms, EQUAL, and RATIONALP hyps) by   M. Kaufmann & Yuan Yu, April 1994.  Modified June 1994 (for   +-terms, EQUAL, and Acl2-numberp hyps),(for +-terms, <, and   RATIONALP hyps), and (for *-terms, EQUAL, and Acl2-numberp hyps) by   John Cowles, University of Wyoming. Modification finished July   1994. Modified August 1994 for Version 1.6.  Modified March 1995   for Version 1.8.   Modifications include removing duplicate hyps and extra forces   included in the original rule.(certify-book "meta" 0) */





















in-package("ACL2");

Include("term-lemmas");

Module 
{ binop(x, y) : t;
  binop-fix(x) : t;
  binop-rel(x, y) : t;
  binop-id() : t; } 
{ local 
  
  Function binop(x, y) { x + y };
  
  local 
  
  Function binop-fix(x) { fix(x) };
  
  local 
  
  Function binop-rel(x, y) { x = y };
  
  local 
  
  Function binop-id() { 0 };
  
  Theorem commutativity-of-binop { binop(x, y) = binop(y, x) };
  
  Theorem commutativity2-of-binop { binop(x, binop(y, z)) = binop(y, binop(x, z)) };
  
  Theorem associativity-of-binop { binop(binop(x, y), z) = binop(x, binop(y, z)) };
  
  Theorem binop-fix-binop { binop-fix(binop(x, y)) = binop(x, y) };
  
  Theorem binop-cancel-binop-rel
  { binop-rel(binop(x, y), binop(x, z)) = binop-rel(binop-fix(y), binop-fix(z)) };
  
  Theorem binop-binop-id { binop(binop-id(), x) = binop-fix(x) };
  
  Theorem binop-fix-binop-id { binop-fix(binop-id()) = binop-id() };
  
   };

Module 
{ ev1(x, a) : t;
  ev1-list(x-lst, a) : t;
  binop-name() : t;
  binop-fix-name() : t;
  binop-rel-name() : t; } 
{ 
  set-inhibit-warnings("theory");
  
  local 
  
  IN-THEORY(*defevaluator-form-base-theory*);
  
  local 
  
  Function binop-name() { 'binop };
  
  local 
  
  Function binop-fix-name() { 'binop-fix };
  
  local 
  
  Function binop-rel-name() { 'binop-rel };
  
  Theorem symbolp-binop-name
  { symbolp(binop-name()) & (binop-name() ~= t & binop-name() ~= nil) }
   :rule-classes :type-prescription;
  
  Theorem symbolp-binop-fix-name
  { symbolp(binop-fix-name()) & (binop-fix-name() ~= t & binop-fix-name() ~= nil) }
   :rule-classes :type-prescription;
  
  Theorem symbolp-binop-rel-name
  { symbolp(binop-rel-name()) & (binop-rel-name() ~= t & binop-rel-name() ~= nil) }
   :rule-classes :type-prescription;
  
  Theorem binop-name-not-quote { binop-name() ~= 'quote };
  
  Theorem binop-rel-name-not-quote { binop-rel-name() ~= 'quote };
  
  Theorem binop-fix-name-not-quote { binop-fix-name() ~= 'quote };
  
  local 
  
  Mutual recursion { Function ev1(x, a)
  { if symbolp(x) then cdr(assoc-eq(x, a))
        elif eq(car(x), 'quote) then car(cdr(x))
        elif consp(car(x))
        then ev1(car(cdr(cdr(car(x)))), pairlis$(car(cdr(car(x))), ev1-list(cdr(x), a)))
        elif car(x) = binop-name() then binop(ev1(car(cdr(x)), a), ev1(car(cdr(cdr(x))), a))
        elif car(x) = binop-fix-name() then binop-fix(ev1(car(cdr(x)), a))
        elif car(x) = binop-rel-name()
        then binop-rel(ev1(car(cdr(x)), a), ev1(car(cdr(cdr(x))), a))
        elif car(x) = 'if
        then if ev1(car(cdr(x)), a) then ev1(car(cdr(cdr(x))), a)
                 else ev1(car(cdr(cdr(cdr(x)))), a)
        else nil }
   :measure acl2-count(x)
   :mode :logic
   :well-founded-relation e0-ord-<;
  
  Function ev1-list(x-lst, a)
  { if endp(x-lst) then nil
        else ev1(car(x-lst), a) :> ev1-list(cdr(x-lst), a) }
   :measure acl2-count(x-lst)
   :well-founded-relation e0-ord-<;
  
  };
  
  Theorem ev1-constraint-1 { symbolp(x) -> ev1(x, a) = cdr(assoc-eq(x, a)) };
  
  Theorem ev1-constraint-2 { consp(x) & car(x) = 'quote -> ev1(x, a) = cadr(x) };
  
  Theorem ev1-constraint-3
  { consp(x) & consp(car(x)) -> ev1(x, a) = ev1(caddar(x), pairlis$(cadar(x), ev1-list(cdr(x), a))) };
  
  Theorem ev1-constraint-4 { ~(consp(x-lst)) -> ev1-list(x-lst, a) = nil };
  
  Theorem ev1-constraint-5
  { consp(x-lst) -> ev1-list(x-lst, a) = ev1(car(x-lst), a) :> ev1-list(cdr(x-lst), a) };
  
  Theorem ev1-constraint-6
  { consp(x) & car(x) = binop-name() -> ev1(x, a) = binop(ev1(cadr(x), a), ev1(caddr(x), a)) };
  
  Theorem ev1-constraint-7
  { consp(x) & car(x) = binop-fix-name() -> ev1(x, a) = binop-fix(ev1(cadr(x), a)) };
  
  Theorem ev1-constraint-8
  { consp(x) & car(x) = binop-rel-name() -> ev1(x, a) = binop-rel(ev1(cadr(x), a), ev1(caddr(x), a)) };
  
  Theorem ev1-constraint-9
  { consp(x) & car(x) = 'if -> ev1(x, a) = if ev1(cadr(x), a) then ev1(caddr(x), a)
                                               else ev1(cadddr(x), a) };
  
   };

Module 
{ cancel_binop-rel$1(x) : t; } 
{ local 
  
  Function cancel_binop-rel$1(x) { x };
  
  Theorem cancel_binop-rel$1-property
  { consp(x) & eq(car(x), binop-rel-name()) -> ev1(cancel_binop-rel$1(x), a) = ev1(x, a) };
  
   };

Function cancel_binop-rel(x)
{ if consp(x) & eq(car(x), binop-rel-name())
      then if consp(cadr(x)) & (eq(car(cadr(x)), binop-name()) & (consp(caddr(x)) & eq(car(caddr(x)),
                                                                                       binop-name())))
               then { lt-side := binary-op_fringe(binop-name(), cadr(x));
                      rt-side := binary-op_fringe(binop-name(), caddr(x));
                      int := bagint(lt-side, rt-side);
                      if int
                          then [binop-rel-name(), 
                                binary-op_tree(binop-name(),
                                               binop-id(),
                                               binop-fix-name(),
                                               bagdiff(lt-side, int)), 
                                binary-op_tree(binop-name(),
                                               binop-id(),
                                               binop-fix-name(),
                                               bagdiff(rt-side, int))
                                ]
                          else x}
               else cancel_binop-rel$1(x)
      else x };

/* Local stuff starts here.
(defun binop-list (lst)  (cond   ((atom lst) (binop-id))   (t (binop (car lst)             (binop-list (cdr lst))))))(in-theory (disable (binop-list)))(encapsulate () (local  (defthm binop-binop-id-reverse    (equal (binop-fix x)           (binop (binop-id) x)))) (local (in-theory (disable binop-binop-id))) (local  (defthm binop-binop-id-binop    (equal (binop (binop-id) (binop x y))           (binop x y))    :hints (("Goal" :use binop-fix-binop)))) (defthm binop-binop-fix-1   (equal (binop (binop-fix x) y)          (binop x y))) (defthm binop-binop-fix-2   (equal (binop x (binop-fix y))          (binop x y))) )(defthm ev1-binary-op_tree+  (implies (true-listp fringe)           (equal (ev1 (binary-op_tree+                        (binop-name)                        (binop-id)                        (binop-fix-name)                        fringe)                       a)                  (binop-list (ev1-list fringe a))))  :hints (("Goal" :induct (true-listp fringe))))(defthm binop-fix-binop-id  (equal (binop-fix (binop-id))         (binop-id)))(defthm binop-fix-binop-list  (equal (binop-fix (binop-list x))         (binop-list x)))(defthm binop-list-append  (equal (binop-list (append x y))         (binop (binop-list x) (binop-list y))))(defthm ev1-constraint-5-explicit  (equal (ev1-list (cons b x-lst) a)         (cons (ev1 b a)               (ev1-list x-lst a))))(defthm ev1-list-append  (implies (true-listp x)           (equal (ev1-list (append x y) a)                  (append (ev1-list x a) (ev1-list y a)))))(defthm binop-rel-ev1-ev1-list  (binop-rel (binop-fix (ev1 x a))             (binop-list (ev1-list (binary-op_fringe (binop-name) x) a)))) */






skip-proofs { 
Theorem cancel_binop-rel-correct-lemma
{ binop-rel(ev1(binary-op_tree(binop-name(),
                               binop-id(),
                               binop-fix-name(),
                               bagdiff(binary-op_fringe(binop-name(), x1),
                                       bagint(binary-op_fringe(binop-name(), x1),
                                              binary-op_fringe(binop-name(), x2)))),
                a),
            ev1(binary-op_tree(binop-name(),
                               binop-id(),
                               binop-fix-name(),
                               bagdiff(binary-op_fringe(binop-name(), x2),
                                       bagint(binary-op_fringe(binop-name(), x1),
                                              binary-op_fringe(binop-name(), x2)))),
                a)) = binop-rel(binop-fix(ev1(x1, a)), binop-fix(ev1(x2, a))) };

 }
Theorem cancel_binop-rel-correct { ev1(x, a) = ev1(cancel_binop-rel(x), a) };


