

Include("/usr/cli/projects/cacl2/version13/infix-prelude");

in-package("ACL2");

Include("term-defuns");

local Include("term-lemmas");

Evaluator( ev-plus-lessp, ev-plus-lessp-list )
 [ binary-plus(x,y), 
   x < y, 
   IF x THEN y
      ELSE z
    ];

Function cancel_plus-lessp1(x)
{ IF consp(cadr(x)) & eq(car(cadr(x)),'binary-plus)
     THEN IF fringe-occur('binary-plus,caddr(x),cadr(x))
             THEN ['less, 
                   binary-op_tree-simple('binary-plus,
                                         0,
                                         del(caddr(x),
                                             binary-op_fringe('binary-plus,
                                                              cadr(x)))), 
                   *zero*
                   ]
             ELSE x
     ELIF consp(caddr(x)) & eq(car(caddr(x)),'binary-plus)
     THEN IF fringe-occur('binary-plus,cadr(x),caddr(x))
             THEN ['less, 
                   *zero*, 
                   binary-op_tree-simple('binary-plus,
                                         0,
                                         del(cadr(x),
                                             binary-op_fringe('binary-plus,
                                                              caddr(x))))
                   ]
             ELSE x
     ELSE x }
 :guard pseudo-termp(x) & consp(x) & car(x) ~= 'quote
 :guard-hints[["Goal" :expand [pseudo-termp(list_start(x1,'binary-plus :> x6,x4))
                               ]]];

Function cancel_plus-lessp(x)
{ IF consp(x) & eq(car(x),'lessp)
     THEN IF    consp(cadr(x))
              & eq(car(cadr(x)),'binary-plus)
              & consp(caddr(x))
              & eq(car(caddr(x)),'binary-plus)
             THEN { lt-side := binary-op_fringe('binary-plus,cadr(x));
                    rt-side := binary-op_fringe('binary-plus,caddr(x));
                    int := bagint(lt-side,rt-side);
                    IF int
                       THEN ['less, 
                             binary-op_tree-simple('binary-plus,
                                                   0,
                                                   bagdiff(lt-side,int)), 
                             binary-op_tree-simple('binary-plus,
                                                   0,
                                                   bagdiff(rt-side,int))
                             ]
                       ELSE x}
             ELSE cancel_plus-lessp1(x)
     ELSE x }
 :guard pseudo-termp(x);

local IN-THEORY(disable(binary-op_tree-simple));

local Theorem ev-plus-lessp-binary-op_tree-simple-append
{     consp(fringe1) & consp(fringe2)
   ->    ev-plus-lessp(binary-op_tree-simple('binary-plus,0,fringe1 @ fringe2),
                        a)
       =    ev-plus-lessp(binary-op_tree-simple('binary-plus,0,fringe1),a)
          + ev-plus-lessp(binary-op_tree-simple('binary-plus,0,fringe2),a) }
 :hints [["Goal" :induct fringe1 @ fringe2]];

local Theorem ev-plus-lessp-binary-op_tree-simple-fringe
{    ev-plus-lessp(binary-op_tree-simple('binary-plus,
                                          0,
                                          binary-op_fringe('binary-plus,x)),
                    a)
   = ev-plus-lessp(x,a) };

local Theorem qual-iff { booleanp(x) & booleanp(y) -> x = y <-> x <-> y };

local Theorem plus-cancel-left { x + y < x + z = fix(y) < fix(z) };

local Theorem binary-op_tree-simple-plus-fringe-del-lemma
{     memb(summand,fringe)
   ->       ev-plus-lessp(summand,a)
           + ev-plus-lessp(binary-op_tree-simple('binary-plus,
                                                 0,
                                                 del(summand,fringe)),
                           a)
       = fix(ev-plus-lessp(binary-op_tree-simple('binary-plus,0,fringe),a)) }
 :hints [["Goal" :expand [binary-op_tree-simple('binary-plus,0,cdr(fringe))]]];

local Theorem binary-op_tree-simple-plus-fringe-del-1
{     memb(summand,fringe)
   ->       y
           < ev-plus-lessp(binary-op_tree-simple('binary-plus,
                                                 0,
                                                 del(summand,fringe)),
                           a)
       =    y + ev-plus-lessp(summand,a)
          < ev-plus-lessp(binary-op_tree-simple('binary-plus,0,fringe),a) }
 :hints [["Goal" :use binary-op_tree-simple-plus-fringe-del-lemma]];

local Theorem binary-op_tree-simple-plus-fringe-del-2
{     memb(summand,fringe)
   ->       ev-plus-lessp(binary-op_tree-simple('binary-plus,
                                                  0,
                                                  del(summand,fringe)),
                            a)
           < y
       =    ev-plus-lessp(binary-op_tree-simple('binary-plus,0,fringe),a)
          < y + ev-plus-lessp(summand,a) }
 :hints [["Goal" :use binary-op_tree-simple-plus-fringe-del-lemma]];

local Theorem cancel_plus-lessp1-property
{     consp(x) & car(x) = 'less
   -> ev-plus-lessp(cancel_plus-lessp1(x),a) = ev-plus-lessp(x,a) };

local IN-THEORY(disable(cancel_plus-lessp1));

local Theorem binary-op_tree-simple-plus-fringe-del
{     memb(summand,fringe) & acl2-numberp(y)
   ->       y
           = ev-plus-lessp(binary-op_tree-simple('binary-plus,
                                                 0,
                                                 del(summand,fringe)),
                           a)
       = (   acl2-numberp(ev-plus-lessp(binary-op_tree-simple('binary-plus,
                                                               0,
                                                               del(summand,
                                                                   fringe)),
                                         a))
           &    y + ev-plus-lessp(summand,a)
              = fix(ev-plus-lessp(binary-op_tree-simple('binary-plus,0,fringe),
                                  a))) }
 :hints [["Goal" :use binary-op_tree-simple-plus-fringe-del-lemma]];

local Theorem binary-op_tree-simple-plus-fringe-del-not-acl2-numberp
{        ~(acl2-numberp(ev-plus-lessp(binary-op_tree-simple('binary-plus,
                                                              0,
                                                              del(summand,
                                                                  fringe)),
                                        a)))
        & memb(summand,fringe)
   ->    ev-plus-lessp(binary-op_tree-simple('binary-plus,0,fringe),a)
       = fix(ev-plus-lessp(summand,a)) }
 :hints [["Goal" :expand [del(summand,fringe), 
                          del(summand,cdr(fringe)), 
                          binary-op_tree-simple('binary-plus,0,fringe)
                          ]]];

local Module { }
{ 
  local Theorem binary-op_tree-simple-opener-extra-1
  {     consp(fringe) & ~(consp(cdr(fringe)))
     -> binary-op_tree-simple('binary-plus,0,fringe) = car(fringe) };
  
  local Theorem cancel_plus-lessp-correct-lemma-1
  {     subbagp(fringe2,fringe1)
     ->       ev-plus-lessp(binary-op_tree-simple('binary-plus,
                                                    0,
                                                    bagdiff(fringe1,fringe2)),
                              a)
             + ev-plus-lessp(binary-op_tree-simple('binary-plus,0,fringe2),a)
         = fix(ev-plus-lessp(binary-op_tree-simple('binary-plus,0,fringe1),a)) };
  
   };

local Theorem cancel_plus-lessp-correct-lemma
{       ev-plus-lessp(binary-op_tree-simple('binary-plus,
                                              0,
                                              bagdiff(binary-op_fringe('binary-plus,
                                                                       x1),
                                                      bagint(binary-op_fringe('binary-plus,
                                                                              x1),
                                                             binary-op_fringe('binary-plus,
                                                                              x2)))),
                        a)
       < ev-plus-lessp(binary-op_tree-simple('binary-plus,
                                             0,
                                             bagdiff(binary-op_fringe('binary-plus,
                                                                      x2),
                                                     bagint(binary-op_fringe('binary-plus,
                                                                             x1),
                                                            binary-op_fringe('binary-plus,
                                                                             x2)))),
                       a)
   = ev-plus-lessp(x1,a) < ev-plus-lessp(x2,a) }
 :hints [["Goal" :use [[:instance cancel_plus-lessp-correct-lemma-1
                                  [fringe1 := binary-op_fringe('binary-plus,x1), 
                                   fringe2 := bagint(binary-op_fringe('binary-plus,
                                                                    x1),
                                                   binary-op_fringe('binary-plus,
                                                                    x2)) ]]
                       [:instance cancel_plus-lessp-correct-lemma-1
                                  [fringe1 := binary-op_fringe('binary-plus,x2), 
                                   fringe2 := bagint(binary-op_fringe('binary-plus,
                                                                    x1),
                                                   binary-op_fringe('binary-plus,
                                                                    x2)) ]]
                       ]]];

Theorem cancel_plus-lessp-correct
{ ev-plus-lessp(x,a) = ev-plus-lessp(cancel_plus-lessp(x),a) }
 :rule-classes [[:meta  
 :trigger-fns [<]]];


