

in-package("ACL2");

Include("meta-generic-plus");

Evaluator( ev2, ev2-list )
 [ binary-plus(x,y), 
   fix(x), 
   x = y, 
   acl2-numberp(x), 
   x < y, 
   IF x THEN y
      ELSE z
    ];

Function cancel_plus1(x)
{  <elt, term> := IF consp(cadr(x)) & eq(car(cadr(x)),'binary-plus)
                THEN <caddr(x), cadr(x)>
                ELIF consp(caddr(x)) & eq(car(caddr(x)),'binary-plus)
                THEN <cadr(x), caddr(x)>
                ELSE <nil, nil>;
  IF elt & fringe-occur('binary-plus,elt,term)
     THEN ['if, 
           ['acl2-numberp, elt], 
           ['equal, 
            *zero*, 
            binary-op_tree('binary-plus,
                           0,
                           'fix,
                           del(elt,binary-op_fringe('binary-plus,term)))
            ], 
           *nil*
           ]
     ELSE x }
 :guard pseudo-termp(x) & consp(x);

Function cancel_plus-equal(x)
{ IF consp(x) & eq(car(x),'equal)
     THEN IF    consp(cadr(x))
              & eq(car(cadr(x)),'binary-plus)
              & consp(caddr(x))
              & eq(car(caddr(x)),'binary-plus)
             THEN { lt-side := binary-op_fringe('binary-plus,cadr(x));
                    rt-side := binary-op_fringe('binary-plus,caddr(x));
                    int := bagint(lt-side,rt-side);
                    IF int
                       THEN ['equal, 
                             binary-op_tree('binary-plus,
                                            0,
                                            'fix,
                                            bagdiff(lt-side,int)), 
                             binary-op_tree('binary-plus,
                                            0,
                                            'fix,
                                            bagdiff(rt-side,int))
                             ]
                       ELSE x}
             ELSE cancel_plus1(x)
     ELSE x }
 :guard pseudo-termp(x);

Theorem acl2-numberp-ev2-binary-op-tree
{ acl2-numberp(ev2(binary-op_tree('binary-plus,0,'fix,fringe),a)) };

IN-THEORY(disable(binary-op_tree));

Theorem ev2-binary-op_tree-append
{    ev2(binary-op_tree('binary-plus,0,'fix,fringe1 @ fringe2),a)
   =    ev2(binary-op_tree('binary-plus,0,'fix,fringe1),a)
     + ev2(binary-op_tree('binary-plus,0,'fix,fringe2),a) }
 :hints [["Goal" :induct fringe1 @ fringe2]];

Theorem ev2-binary-op_tree-fringe
{    ev2(binary-op_tree('binary-plus,0,'fix,binary-op_fringe('binary-plus,x)),a)
   = fix(ev2(x,a)) };

Theorem plus-cancel-left { x + y = x + z = (fix(y) = fix(z)) };

Theorem binary-op_tree-plus-fringe-del-lemma
{     memb(summand,fringe)
   ->       ev2(summand,a)
         + ev2(binary-op_tree('binary-plus,0,'fix,del(summand,fringe)),a)
      = ev2(binary-op_tree('binary-plus,0,'fix,fringe),a) }
 :hints [["Goal" :expand [binary-op_tree('binary-plus,0,'fix,fringe2)]]];

Theorem binary-op_tree-plus-fringe-del
{     memb(summand,fringe)
   ->    0 = ev2(binary-op_tree('binary-plus,0,'fix,del(summand,fringe)),a)
      = (fix(ev2(summand,a)) = ev2(binary-op_tree('binary-plus,0,'fix,fringe),a)) }
 :hints [["Goal" :use binary-op_tree-plus-fringe-del-lemma]];

Theorem ev2-acl2-numberp-hack-1
{ car(y) = 'binary-plus -> acl2-numberp(ev2(y,a)) };

Theorem ev2-acl2-numberp-hack-2
{ ev2(x,a) = ev2(y,a) & car(y) = 'binary-plus -> acl2-numberp(ev2(x,a)) };

Theorem cancel_plus1-property
{ consp(x) & car(x) = 'equal -> ev2(cancel_plus1(x),a) = ev2(x,a) }
 :hints [["Goal" :in-theory disable(binary-op_tree-opener,
                                    binary-op_fringe,
                                    ev2-constraint-6)]];

IN-THEORY(disable(cancel_plus1));

Theorem cancel_plus-equal-correct
{ ev2(x,a) = ev2(cancel_plus-equal(x),a) }
 :hints [["Goal" :by [:functional-instance cancel_binop-rel-correct
                                           [ev1 := ev2, 
                                            ev1-list := ev2-list, 
                                            binop := binary-plus, 
                                            binop-fix := fix, 
                                            binop-rel := equal, 
                                            binop-id := lambda() { 0 }, 
                                            binop-name := lambda() { 'binary-plus }, 
                                            binop-fix-name := lambda() { 'fix }, 
                                            binop-rel-name := lambda() { 'equal }, 
                                            cancel_binop-rel$1 := cancel_plus$1, 
                                            cancel_binop-rel := cancel_plus-equal ]]]];


