

Include("/usr/cli/projects/cacl2/version13/infix-prelude");

in-package("ACL2");

Include("term-defuns");

Include("term-lemmas");

Include((:relative :back "arithmetic" "equalities"));

Evaluator( ev-times-equal, ev-times-equal-list )
 [ binary-mult(x,y), 
   fix(x), 
   x = y, 
   acl2-numberp(x), 
   IF x THEN y
      ELSE z
    ];

Function cancel_times-equal$1(x)
{  <elt, term> := IF consp(cadr(x)) & eq(car(cadr(x)),'binary-mult)
                THEN <caddr(x), cadr(x)>
                ELIF consp(caddr(x)) & eq(car(caddr(x)),'binary-mult)
                THEN <cadr(x), caddr(x)>
                ELSE <nil, nil>;
  IF elt & fringe-occur('binary-mult,elt,term)
     THEN ['if, 
           ['acl2-numberp, elt], 
           ['if, 
            ['equal, elt, *0*], 
            *t*, 
            ['equal, 
             *1*, 
             binary-op_tree('binary-mult,
                            1,
                            'fix,
                            del(elt,binary-op_fringe('binary-mult,term)))
             ]
            ], 
           *nil*
           ]
     ELSE x }
 :guard pseudo-termp(x) & consp(x);

Function formal-some-zerop(lst)
{ IF endp(cdr(lst)) THEN ['equal, *0*, ['fix, car(lst)]]
     ELIF memb(car(lst),cdr(lst)) THEN formal-some-zerop(cdr(lst))
     ELSE ['if, ['equal, *0*, ['fix, car(lst)]], *t*, formal-some-zerop(cdr(lst))] }
 :guard consp(lst) & true-listp(lst);

Function cancel_times-equal(x)
{ IF consp(x) & eq(car(x),'equal)
     THEN IF    consp(cadr(x))
              & eq(car(cadr(x)),'binary-mult)
              & consp(caddr(x))
              & eq(car(caddr(x)),'binary-mult)
             THEN { lt-side := binary-op_fringe('binary-mult,cadr(x));
                    rt-side := binary-op_fringe('binary-mult,caddr(x));
                    int := bagint(lt-side,rt-side);
                    IF int
                       THEN ['if, 
                             formal-some-zerop(int), 
                             *t*, 
                             ['equal, 
                              binary-op_tree('binary-mult,
                                             1,
                                             'fix,
                                             bagdiff(lt-side,int)), 
                              binary-op_tree('binary-mult,
                                             1,
                                             'fix,
                                             bagdiff(rt-side,int))
                              ]
                             ]
                       ELSE x}
             ELSE cancel_times-equal$1(x)
     ELSE x }
 :guard pseudo-termp(x);

local Theorem acl2-numberp-ev-times-equal
{ acl2-numberp(ev-times-equal(binary-op_tree('binary-mult,1,'fix,fringe),a)) }
 :rule-classes :type-prescription;

local IN-THEORY(disable(binary-op_tree));

local Theorem ev-times-equal-binary-op_tree-append
{    ev-times-equal(binary-op_tree('binary-mult,1,'fix,fringe1 @ fringe2),a)
   =    ev-times-equal(binary-op_tree('binary-mult,1,'fix,fringe1),a)
     * ev-times-equal(binary-op_tree('binary-mult,1,'fix,fringe2),a) }
 :hints [["Goal" :induct fringe1 @ fringe2]];

local Theorem ev-times-equal-binary-op_tree-fringe
{    ev-times-equal(binary-op_tree('binary-mult,
                                   1,
                                   'fix,
                                   binary-op_fringe('binary-mult,x)),
                    a)
   = fix(ev-times-equal(x,a)) };

local Theorem times-cancel-left
{ x * y = x * z = (fix(x) = 0 | fix(y) = fix(z)) };

local Theorem binary-op_tree-times-fringe-del-lemma
{     memb(summand,fringe)
   ->       ev-times-equal(summand,a)
         * ev-times-equal(binary-op_tree('binary-mult,1,'fix,del(summand,fringe)),
                         a)
      = ev-times-equal(binary-op_tree('binary-mult,1,'fix,fringe),a) }
 :hints [["Goal" :expand [binary-op_tree('binary-mult,1,'fix,cdr(fringe))]]];

Module { }
{ 
  local Theorem times-cancel-left-better
  { left = x * y -> left = x * z = (fix(x) = 0 | fix(y) = fix(z)) };
  
  Theorem binary-op_tree-times-fringe-del
  {        memb(summand,fringe)
         & acl2-numberp(y)
         & fix(ev-times-equal(summand,a)) ~= 0
     ->       y
           = ev-times-equal(binary-op_tree('binary-mult,
                                          1,
                                          'fix,
                                          del(summand,fringe)),
                           a)
        = (   ev-times-equal(summand,a) * y
            = ev-times-equal(binary-op_tree('binary-mult,1,'fix,fringe),a)) }
   :hints [["Goal" :use binary-op_tree-times-fringe-del-lemma
                   :in-theory disable(commutativity-of-mult)]];
  
   };

local Theorem memb-of-fringe-non-zero
{        memb(x,binary-op_fringe('binary-mult,term))
       & acl2-numberp(ev-times-equal(term,a))
       & ev-times-equal(term,a) ~= 0
   -> ev-times-equal(x,a) ~= 0 & acl2-numberp(ev-times-equal(x,a)) };

local Theorem cancel_times-equal$1-property
{     consp(x) & car(x) = 'equal
   -> ev-times-equal(cancel_times-equal$1(x),a) = ev-times-equal(x,a) };

local IN-THEORY(disable(cancel_times-equal$1));

local Theorem ev-times-equal-binary-op_tree-is-zero
{     memb(x,fringe) & fix(ev-times-equal(x,a)) = 0
   -> ev-times-equal(binary-op_tree('binary-mult,1,'fix,fringe),a) = 0 };

local Theorem ev-times-equal-binary-op_tree-is-zero-from-del
{     ev-times-equal(binary-op_tree('binary-mult,1,'fix,del(x,fringe)),a) = 0
   -> ev-times-equal(binary-op_tree('binary-mult,1,'fix,fringe),a) = 0 }
 :hints [["Goal" :expand [binary-op_tree('binary-mult,1,'fix,fringe), 
                          binary-op_tree('binary-mult,1,'fix,cdr(fringe))
                          ]]];

Module { }
{ 
  local Theorem binary-op_tree-opener-extra-1
  {     consp(fringe) & ~(consp(cdr(fringe)))
     -> binary-op_tree('binary-mult,1,op,fringe) = [op, car(fringe)] };
  
  local Theorem cancel_equal-times-correct-lemma-1-lemma
  {     memb(x,fringe)
     ->       ev-times-equal(x,a)
           * ev-times-equal(binary-op_tree('binary-mult,1,'fix,del(x,fringe)),a)
        = fix(ev-times-equal(binary-op_tree('binary-mult,1,'fix,fringe),a)) }
   :hints [["Goal" :use [[:instance binary-op_tree-times-fringe-del
                                    [summand := x, 
                                     y := ev-times-equal(binary-op_tree('binary-mult,
                                                                      1,
                                                                      'fix,
                                                                      del(x,
                                                                          fringe)),
                                                       a), 
                                     fringe := fringe, 
                                     a := a ]]]
                   :in-theory disable(binary-op_tree-times-fringe-del)]];
  
  Theorem cancel_equal-times-correct-lemma-1
  {     subbagp(fringe2,fringe1)
     ->       ev-times-equal(binary-op_tree('binary-mult,1,'fix,fringe2),a)
           * ev-times-equal(binary-op_tree('binary-mult,
                                          1,
                                          'fix,
                                          bagdiff(fringe1,fringe2)),
                           a)
        = ev-times-equal(binary-op_tree('binary-mult,1,'fix,fringe1),a) }
   :hints [["Goal" :expand [binary-op_tree('binary-mult,1,'fix,fringe2)]]];
  
   };

Module { }
{ 
  local Theorem times-cancel-right-left-better
  { left = y * x -> left = x * z = (fix(x) = 0 | fix(y) = fix(z)) };
  
  Theorem cancel_equal-times-correct-lemma-2
  {        subbagp(fringe2,fringe1)
         & ev-times-equal(binary-op_tree('binary-mult,1,'fix,fringe2),a) ~= 0
         & acl2-numberp(y)
     ->       y
           = ev-times-equal(binary-op_tree('binary-mult,
                                          1,
                                          'fix,
                                          bagdiff(fringe1,fringe2)),
                           a)
        = (   ev-times-equal(binary-op_tree('binary-mult,1,'fix,fringe2),a) * y
            = ev-times-equal(binary-op_tree('binary-mult,1,'fix,fringe1),a)) }
   :hints [["Goal" :use cancel_equal-times-correct-lemma-1
                   :in-theory disable(cancel_equal-times-correct-lemma-1)]];
  
   };

local Theorem acl2-numberp-ev-times-equal-again
{ acl2-numberp(ev-times-equal('binary-mult :> x8,a)) }
 :rule-classes :type-prescription;

local Theorem ev-times-equal-binary-op_tree-is-zero-alternate
{     memb(x,fringe) & fix(ev-times-equal(x,a)) = 0
   -> ev-times-equal(formal-some-zerop(fringe),a) };

local Theorem ev-times-equal-formal-some-zerop-0
{     consp(fringe)
   ->    ev-times-equal(formal-some-zerop(fringe),a)
      = (fix(ev-times-equal(binary-op_tree('binary-mult,1,'fix,fringe),a)) = 0) }
 :hints [["Goal" :expand [binary-op_tree('binary-mult,1,'fix,fringe)]
                 :restrict [ ev-times-equal-binary-op_tree-is-zero-alternate [x := car(fringe) ] ]]];

local Theorem consp-bagint { consp(bagint(x,y)) <-> bagint(x,y) };

local Theorem cancel_equal-times-correct-lemma
{ int := bagint(binary-op_fringe('binary-mult,x1),
              binary-op_fringe('binary-mult,x2));
      int & ~(ev-times-equal(formal-some-zerop(int),a))
   ->       ev-times-equal(binary-op_tree('binary-mult,
                                         1,
                                         'fix,
                                         bagdiff(binary-op_fringe('binary-mult,
                                                                  x1),
                                                 int)),
                          a)
         = ev-times-equal(binary-op_tree('binary-mult,
                                        1,
                                        'fix,
                                        bagdiff(binary-op_fringe('binary-mult,
                                                                 x2),
                                                int)),
                         a)
      = (fix(ev-times-equal(x1,a)) = fix(ev-times-equal(x2,a)))}
 :hints [["Goal" :use [[:instance cancel_equal-times-correct-lemma-1
                                  [fringe1 := binary-op_fringe('binary-mult,x1), 
                                   fringe2 := bagint(binary-op_fringe('binary-mult,
                                                                    x1),
                                                   binary-op_fringe('binary-mult,
                                                                    x2)) ]][:instance cancel_equal-times-correct-lemma-1
                                                                                      [fringe1 := binary-op_fringe('binary-mult,
                                                                                                                 x2), 
                                                                                       fringe2 := bagint(binary-op_fringe('binary-mult,
                                                                                                                        x1),
                                                                                                       binary-op_fringe('binary-mult,
                                                                                                                        x2)) ]]]]];

local Theorem formal-some-zerop-bagint-yields-0
{        ev-times-equal(formal-some-zerop(fringe),a)
       & subbagp(fringe,binary-op_fringe('binary-mult,term))
       & acl2-numberp(ev-times-equal(term,a))
       & consp(fringe)
   -> ev-times-equal(term,a) = 0 };

Theorem cancel_times-equal-correct
{ ev-times-equal(x,a) = ev-times-equal(cancel_times-equal(x),a) }
 :rule-classes [[:meta  
                 :trigger-fns [=]]]
 :hints [["Goal" :in-theory disable(ev-times-equal-constraint-6,
                                    ev-times-equal-formal-some-zerop-0)]];


