

Include("/usr/cli/projects/cacl2/version13/infix-prelude");

in-package("ACL2");

Function intersection-equal(x,y)
{ IF endp(x) THEN nil
     ELIF car(x) in y THEN car(x) :> intersection-equal(cdr(x),y)
     ELSE intersection-equal(cdr(x),y) }
 :guard true-listp(x) & true-listp(y);

Function set-equal(a,b) { subsetp-equal(a,b) & subsetp-equal(b,a) }
 :guard true-listp(a) & true-listp(b);

Function excess-element(s1,s2)
{ IF endp(s1) THEN nil
     ELIF car(s1) in s2 THEN excess-element(cdr(s1),s2)
     ELSE car(s1) }
 :guard true-listp(s1) & true-listp(s2);

Theorem subsetp-equal-cons
{ subsetp-equal(a,b) -> subsetp-equal(a,x :> b) };

Theorem subsetp-equal-reflexive { subsetp-equal(l,l) };

Theorem subsetp-equal-transitive
{ subsetp-equal(a,b) & subsetp-equal(b,c) -> subsetp-equal(a,c) };

Theorem set-equal-reflexive { set-equal(l,l) };

Theorem set-equal-symmetric { set-equal(a,b) -> set-equal(b,a) };

Theorem set-equal-transitive
{ set-equal(a,b) & set-equal(b,c) -> set-equal(a,c) }
 :hints [["Goal" :do-not-induct t
                 :use [[:instance subsetp-equal-transitive
                                  [a := a, b := b, c := c ]]
                       [:instance subsetp-equal-transitive
                                  [a := c, b := b, c := a ]]
                       ]]];

Theorem member-equal-subsetp-equal
{ x in a & subsetp-equal(a,b) -> x in b };

Theorem member-equal-set-equal { set-equal(a,b) -> x in a <-> x in b }
 :hints [["Goal" :do-not-induct t
                 :use [[:instance member-equal-subsetp-equal
                                  [x := x, a := a, b := b ]]
                       [:instance member-equal-subsetp-equal
                                  [x := x, a := b, b := a ]]
                       ]]];

Theorem member-equal-intersection-equal
{ x in intersection-equal(a,b) <-> x in a & x in b };

Theorem member-equal-set-difference-equal
{ x in set-difference-equal(a,b) <-> x in a & x ~in b };

Theorem member-equal-union-equal
{ x in union-equal(a,b) <-> x in a | x in b };

Theorem member-equal-excess-element
{ ~(subsetp-equal(s1,s2)) -> excess-element(s1,s2) ~in s2 };


