

Include("/usr/cli/projects/cacl2/version13/infix-prelude");

in-package("ACL2");

/* Verify guards, unless :verify-guards is NIL. */
set-verify-guards-eagerness(2);


Theorem append-true-listp-type-prescription
{ true-listp(x) & true-listp(y) -> true-listp(x @ y) }
 :rule-classes :type-prescription;

Function memb(a,x)
{ IF consp(x) THEN a = car(x) | memb(a,cdr(x))
     ELSE nil };

Function del(x,y)
{ IF consp(y)
     THEN IF x = car(y) THEN cdr(y)
             ELSE car(y) :> del(x,cdr(y))
     ELSE y };

Theorem true-listp-del { true-listp(x) -> true-listp(del(a,x)) }
 :rule-classes :type-prescription;

Function subbagp(x,y)
{ IF consp(x)
     THEN IF memb(car(x),y) THEN subbagp(cdr(x),del(car(x),y))
             ELSE nil
     ELSE t };

Function bagdiff(x,y)
{ IF consp(y)
     THEN IF memb(car(y),x) THEN bagdiff(del(car(y),x),cdr(y))
             ELSE bagdiff(x,cdr(y))
     ELSE x };

Theorem true-listp-bagdiff { true-listp(x) -> true-listp(bagdiff(x,y)) }
 :rule-classes :type-prescription;

Function bagint(x,y)
{ IF consp(x)
     THEN IF memb(car(x),y) THEN car(x) :> bagint(cdr(x),del(car(x),y))
             ELSE bagint(cdr(x),y)
     ELSE nil };

Function term-list-to-type-term(unary-op-name,lst)
{ IF null(lst) THEN ''t
     ELIF null(cdr(lst)) THEN [unary-op-name, car(lst)]
     ELSE ['if, 
           [unary-op-name, car(lst)], 
           term-list-to-type-term(unary-op-name,cdr(lst)), 
           ''nil
           ] }
 :guard symbolp(unary-op-name) & true-listp(lst);

Function binary-op_fringe(binary-op-name,x)
{ IF consp(x) & eq(car(x),binary-op-name)
     THEN    binary-op_fringe(binary-op-name,cadr(x))
           @ binary-op_fringe(binary-op-name,caddr(x))
     ELSE x :> nil }
 :guard symbolp(binary-op-name) & ~(eq(binary-op-name,'quote)) & pseudo-termp(x);

Function binary-op_tree(binary-op-name,constant-name,fix-name,lst)
{ IF endp(lst) THEN ['quote, constant-name]
     ELIF endp(cdr(lst)) THEN [fix-name, car(lst)]
     ELIF endp(cddr(lst)) THEN [binary-op-name, car(lst), cadr(lst)]
     ELSE [binary-op-name, 
           car(lst), 
           binary-op_tree(binary-op-name,constant-name,fix-name,cdr(lst))
           ] }
 :guard symbolp(binary-op-name) & atom(constant-name) & true-listp(lst);

Function binary-op_tree-simple(binary-op-name,constant-name,lst)
{ IF endp(lst) THEN ['quote, constant-name]
     ELIF endp(cdr(lst)) THEN car(lst)
     ELSE [binary-op-name, 
           car(lst), 
           binary-op_tree-simple(binary-op-name,constant-name,cdr(lst))
           ] }
 :guard symbolp(binary-op-name) & atom(constant-name) & true-listp(lst);

Function remove-duplicates-memb(lst)
{ IF consp(lst)
     THEN IF memb(car(lst),cdr(lst)) THEN remove-duplicates-memb(cdr(lst))
             ELSE car(lst) :> remove-duplicates-memb(cdr(lst))
     ELSE nil };

Function fringe-occur(binop,arg,term)
{ IF consp(term) & eq(car(term),binop)
     THEN    fringe-occur(binop,arg,cadr(term))
           | fringe-occur(binop,arg,caddr(term))
     ELSE arg = term }
 :guard pseudo-termp(term) & symbolp(binop) & ~(eq(binop,'quote));


