

Include("/usr/cli/projects/cacl2/version13/infix-prelude");

in-package("ACL2");

Include("term-defuns");

Theorem delete-non-member { ~(memb(x,y)) -> del(x,y) = y };

Theorem member-delete { memb(x,del(u,v)) -> memb(x,v) };

Theorem delete-commutativity { del(x,del(y,z)) = del(y,del(x,z)) };

Theorem subbagp-delete { subbagp(x,del(u,y)) -> subbagp(x,y) };

Theorem subbagp-cdr1 { subbagp(x,y) & consp(x) -> subbagp(cdr(x),y) };

Theorem subbagp-cdr2 { subbagp(x,cdr(y)) & consp(y) -> subbagp(x,y) };

Theorem subbagp-bagint1 { subbagp(bagint(x,y),x) };

Theorem subbagp-bagint2 { subbagp(bagint(x,y),y) };

Theorem memb-append { memb(a,x @ y) = (memb(a,x) | memb(a,y)) };

Theorem binary-op_tree-opener
{    (    ~(consp(lst))
        ->    binary-op_tree(binary-op-name,constant-name,fix-name,lst)
           = ['quote, constant-name])
   &    binary-op_tree(binary-op-name,constant-name,fix-name,x :> lst)
     = (IF ~(consp(lst)) THEN [fix-name, x]
           ELIF consp(lst) & ~(consp(cdr(lst))) THEN [binary-op-name, x, car(lst)]
           ELSE [binary-op-name, 
                 x, 
                 binary-op_tree(binary-op-name,constant-name,fix-name,lst)]) };

Theorem binary-op_tree-simple-opener
{    (    ~(consp(lst))
        ->    binary-op_tree-simple(binary-op-name,constant-name,lst)
           = ['quote, constant-name])
   &    binary-op_tree-simple(binary-op-name,constant-name,x :> lst)
     = (IF ~(consp(lst)) THEN x
           ELSE [binary-op-name, 
                 x, 
                 binary-op_tree-simple(binary-op-name,constant-name,lst)]) };

Theorem fringe-occur-same-as-occur-in-fringe
{ fringe-occur(binop,arg,term) = memb(arg,binary-op_fringe(binop,term)) };


